require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&LIB_DEVICE_MAPPER_H)) {
    eval 'sub LIB_DEVICE_MAPPER_H () {1;}' unless defined(&LIB_DEVICE_MAPPER_H);
    require 'inttypes.ph';
    require 'stdarg.ph';
    require 'sys/types.ph';
    if(defined(&linux)) {
	require 'linux/types.ph';
    }
    require 'limits.ph';
    require 'string.ph';
    require 'stdlib.ph';
    require 'stdio.ph';
    eval("sub DM_DEVICE_CREATE () { 0; }") unless defined(&DM_DEVICE_CREATE);
    eval("sub DM_DEVICE_RELOAD () { 1; }") unless defined(&DM_DEVICE_RELOAD);
    eval("sub DM_DEVICE_REMOVE () { 2; }") unless defined(&DM_DEVICE_REMOVE);
    eval("sub DM_DEVICE_REMOVE_ALL () { 3; }") unless defined(&DM_DEVICE_REMOVE_ALL);
    eval("sub DM_DEVICE_SUSPEND () { 4; }") unless defined(&DM_DEVICE_SUSPEND);
    eval("sub DM_DEVICE_RESUME () { 5; }") unless defined(&DM_DEVICE_RESUME);
    eval("sub DM_DEVICE_INFO () { 6; }") unless defined(&DM_DEVICE_INFO);
    eval("sub DM_DEVICE_DEPS () { 7; }") unless defined(&DM_DEVICE_DEPS);
    eval("sub DM_DEVICE_RENAME () { 8; }") unless defined(&DM_DEVICE_RENAME);
    eval("sub DM_DEVICE_VERSION () { 9; }") unless defined(&DM_DEVICE_VERSION);
    eval("sub DM_DEVICE_STATUS () { 10; }") unless defined(&DM_DEVICE_STATUS);
    eval("sub DM_DEVICE_TABLE () { 11; }") unless defined(&DM_DEVICE_TABLE);
    eval("sub DM_DEVICE_WAITEVENT () { 12; }") unless defined(&DM_DEVICE_WAITEVENT);
    eval("sub DM_DEVICE_LIST () { 13; }") unless defined(&DM_DEVICE_LIST);
    eval("sub DM_DEVICE_CLEAR () { 14; }") unless defined(&DM_DEVICE_CLEAR);
    eval("sub DM_DEVICE_MKNODES () { 15; }") unless defined(&DM_DEVICE_MKNODES);
    eval("sub DM_DEVICE_LIST_VERSIONS () { 16; }") unless defined(&DM_DEVICE_LIST_VERSIONS);
    eval("sub DM_DEVICE_TARGET_MSG () { 17; }") unless defined(&DM_DEVICE_TARGET_MSG);
    eval("sub DM_DEVICE_SET_GEOMETRY () { 18; }") unless defined(&DM_DEVICE_SET_GEOMETRY);
    eval 'sub DM_READ_AHEAD_AUTO () { &UINT32_MAX;}' unless defined(&DM_READ_AHEAD_AUTO);
    eval 'sub DM_READ_AHEAD_NONE () {0;}' unless defined(&DM_READ_AHEAD_NONE);
    eval 'sub DM_READ_AHEAD_MINIMUM_FLAG () {0x1;}' unless defined(&DM_READ_AHEAD_MINIMUM_FLAG);
    eval 'sub DM_FORMAT_DEV_BUFSIZE () {13;}' unless defined(&DM_FORMAT_DEV_BUFSIZE);
    eval 'sub DM_CRYPT_IV_DEFAULT () { &UINT64_C(-1);}' unless defined(&DM_CRYPT_IV_DEFAULT);
    eval 'sub DM_NOSYNC () {0x1;}' unless defined(&DM_NOSYNC);
    eval 'sub DM_FORCESYNC () {0x2;}' unless defined(&DM_FORCESYNC);
    eval 'sub DM_BLOCK_ON_ERROR () {0x4;}' unless defined(&DM_BLOCK_ON_ERROR);
    eval 'sub DM_CORELOG () {0x8;}' unless defined(&DM_CORELOG);
    if(defined(&DEBUG_MEM)) {
	eval 'sub dm_malloc {
	    my($s) = @_;
    	    eval q( &dm_malloc_aux_debug(($s),  &__FILE__,  &__LINE__));
	}' unless defined(&dm_malloc);
	eval 'sub dm_strdup {
	    my($s) = @_;
    	    eval q( &dm_strdup_aux(($s),  &__FILE__,  &__LINE__));
	}' unless defined(&dm_strdup);
	eval 'sub dm_free {
	    my($p) = @_;
    	    eval q( &dm_free_aux($p));
	}' unless defined(&dm_free);
	eval 'sub dm_realloc {
	    my($p, $s) = @_;
    	    eval q( &dm_realloc_aux($p, $s,  &__FILE__,  &__LINE__));
	}' unless defined(&dm_realloc);
	eval 'sub dm_dump_memory () {
	    eval q( &dm_dump_memory_debug());
	}' unless defined(&dm_dump_memory);
	eval 'sub dm_bounds_check () {
	    eval q( &dm_bounds_check_debug());
	}' unless defined(&dm_bounds_check);
    } else {
	eval 'sub dm_malloc {
	    my($s) = @_;
    	    eval q( &dm_malloc_aux(($s),  &__FILE__,  &__LINE__));
	}' unless defined(&dm_malloc);
	eval 'sub dm_strdup {
	    my($s) = @_;
    	    eval q( &strdup($s));
	}' unless defined(&dm_strdup);
	eval 'sub dm_free {
	    my($p) = @_;
    	    eval q( &free($p));
	}' unless defined(&dm_free);
	eval 'sub dm_realloc {
	    my($p, $s) = @_;
    	    eval q( &realloc($p, $s));
	}' unless defined(&dm_realloc);
	eval 'sub dm_dump_memory () {
	    eval q({});
	}' unless defined(&dm_dump_memory);
	eval 'sub dm_bounds_check () {
	    eval q({});
	}' unless defined(&dm_bounds_check);
    }
    eval 'sub DM_BITS_PER_INT () {($sizeof{\'int\'} *  &CHAR_BIT);}' unless defined(&DM_BITS_PER_INT);
    eval 'sub dm_bit {
        my($bs, $i) = @_;
	    eval q(($bs->[($i /  &DM_BITS_PER_INT) + 1] & (0x1 << ($i & ( &DM_BITS_PER_INT - 1)))));
    }' unless defined(&dm_bit);
    eval 'sub dm_bit_set {
        my($bs, $i) = @_;
	    eval q(($bs->[($i /  &DM_BITS_PER_INT) + 1] |= (0x1 << ($i & ( &DM_BITS_PER_INT - 1)))));
    }' unless defined(&dm_bit_set);
    eval 'sub dm_bit_clear {
        my($bs, $i) = @_;
	    eval q(($bs->[($i /  &DM_BITS_PER_INT) + 1] &= ~(0x1 << ($i & ( &DM_BITS_PER_INT - 1)))));
    }' unless defined(&dm_bit_clear);
    eval 'sub dm_bit_set_all {
        my($bs) = @_;
	    eval q( &memset($bs + 1, -1, ((*$bs /  &DM_BITS_PER_INT) + 1) * $sizeof{\'int\'}));
    }' unless defined(&dm_bit_set_all);
    eval 'sub dm_bit_clear_all {
        my($bs) = @_;
	    eval q( &memset($bs + 1, 0, ((*$bs /  &DM_BITS_PER_INT) + 1) * $sizeof{\'int\'}));
    }' unless defined(&dm_bit_clear_all);
    eval 'sub dm_bit_copy {
        my($bs1, $bs2) = @_;
	    eval q( &memcpy($bs1 + 1, $bs2 + 1, ((*$bs1 /  &DM_BITS_PER_INT) + 1) * $sizeof{\'int\'}));
    }' unless defined(&dm_bit_copy);
    eval 'sub dm_hash_iterate {
        my($v, $h) = @_;
	    eval q( &for ($v =  &dm_hash_get_first($h); $v; $v =  &dm_hash_get_next($h, $v)));
    }' unless defined(&dm_hash_iterate);
    eval 'sub DM_LIST_INIT {
        my($name) = @_;
	    eval q(\'struct dm_list\' $name = { ($name), ($name) });
    }' unless defined(&DM_LIST_INIT);
    eval 'sub dm_list_struct_base {
        my($v, $t, $head) = @_;
	    eval q((($t *)(( &uintptr_t)($v) - ( &uintptr_t)(($t *) 0)->$head)));
    }' unless defined(&dm_list_struct_base);
    eval 'sub dm_list_item {
        my($v, $t) = @_;
	    eval q( &dm_list_struct_base(($v), $t,  &list));
    }' unless defined(&dm_list_item);
    eval 'sub dm_struct_field {
        my($v, $t, $e, $f) = @_;
	    eval q(((($t *)(( &uintptr_t)($v) - ( &uintptr_t)(($t *) 0)->$e))->$f));
    }' unless defined(&dm_struct_field);
    eval 'sub dm_list_head {
        my($v, $t, $e) = @_;
	    eval q( &dm_struct_field($v, $t, $e,  &list));
    }' unless defined(&dm_list_head);
    eval 'sub dm_list_iterate {
        my($v, $head) = @_;
	    eval q( &for ($v = ($head)-> &n; $v != $head; $v =  ($v->{n})));
    }' unless defined(&dm_list_iterate);
    eval 'sub dm_list_uniterate {
        my($v, $head, $start) = @_;
	    eval q( &for ($v = ($start)-> &p; $v != $head; $v =  ($v->{p})));
    }' unless defined(&dm_list_uniterate);
    eval 'sub dm_list_iterate_safe {
        my($v, $t, $head) = @_;
	    eval q( &for ($v = ($head)-> &n, $t =  ($v->{n}); $v != $head; $v = $t, $t =  ($v->{n})));
    }' unless defined(&dm_list_iterate_safe);
    eval 'sub dm_list_iterate_items_gen {
        my($v, $head, $field) = @_;
	    eval q( &for ($v =  &dm_list_struct_base(($head)-> &n,  &typeof(*$v), $field);  ($v->{field}) != ($head); $v =  &dm_list_struct_base( ($v->{field}->{n}),  &typeof(*$v), $field)));
    }' unless defined(&dm_list_iterate_items_gen);
    eval 'sub dm_list_iterate_items {
        my($v, $head) = @_;
	    eval q( &dm_list_iterate_items_gen($v, ($head),  &list));
    }' unless defined(&dm_list_iterate_items);
    eval 'sub dm_list_iterate_items_gen_safe {
        my($v, $t, $head, $field) = @_;
	    eval q( &for ($v =  &dm_list_struct_base(($head)-> &n,  &typeof(*$v), $field), $t =  &dm_list_struct_base( ($v->{field}->{n}),  &typeof(*$v), $field);  ($v->{field}) != ($head); $v = $t, $t =  &dm_list_struct_base( ($v->{field}->{n}),  &typeof(*$v), $field)));
    }' unless defined(&dm_list_iterate_items_gen_safe);
    eval 'sub dm_list_iterate_items_safe {
        my($v, $t, $head) = @_;
	    eval q( &dm_list_iterate_items_gen_safe($v, $t, ($head),  &list));
    }' unless defined(&dm_list_iterate_items_safe);
    eval 'sub dm_list_iterate_back_items_gen {
        my($v, $head, $field) = @_;
	    eval q( &for ($v =  &dm_list_struct_base(($head)-> &p,  &typeof(*$v), $field);  ($v->{field}) != ($head); $v =  &dm_list_struct_base( ($v->{field}->{p}),  &typeof(*$v), $field)));
    }' unless defined(&dm_list_iterate_back_items_gen);
    eval 'sub dm_list_iterate_back_items {
        my($v, $head) = @_;
	    eval q( &dm_list_iterate_back_items_gen($v, ($head),  &list));
    }' unless defined(&dm_list_iterate_back_items);
    eval 'sub DM_REPORT_FIELD_MASK () {0xff;}' unless defined(&DM_REPORT_FIELD_MASK);
    eval 'sub DM_REPORT_FIELD_ALIGN_MASK () {0xf;}' unless defined(&DM_REPORT_FIELD_ALIGN_MASK);
    eval 'sub DM_REPORT_FIELD_ALIGN_LEFT () {0x1;}' unless defined(&DM_REPORT_FIELD_ALIGN_LEFT);
    eval 'sub DM_REPORT_FIELD_ALIGN_RIGHT () {0x2;}' unless defined(&DM_REPORT_FIELD_ALIGN_RIGHT);
    eval 'sub DM_REPORT_FIELD_TYPE_MASK () {0xf0;}' unless defined(&DM_REPORT_FIELD_TYPE_MASK);
    eval 'sub DM_REPORT_FIELD_TYPE_STRING () {0x10;}' unless defined(&DM_REPORT_FIELD_TYPE_STRING);
    eval 'sub DM_REPORT_FIELD_TYPE_NUMBER () {0x20;}' unless defined(&DM_REPORT_FIELD_TYPE_NUMBER);
    eval 'sub DM_REPORT_OUTPUT_MASK () {0xff;}' unless defined(&DM_REPORT_OUTPUT_MASK);
    eval 'sub DM_REPORT_OUTPUT_ALIGNED () {0x1;}' unless defined(&DM_REPORT_OUTPUT_ALIGNED);
    eval 'sub DM_REPORT_OUTPUT_BUFFERED () {0x2;}' unless defined(&DM_REPORT_OUTPUT_BUFFERED);
    eval 'sub DM_REPORT_OUTPUT_HEADINGS () {0x4;}' unless defined(&DM_REPORT_OUTPUT_HEADINGS);
    eval 'sub DM_REPORT_OUTPUT_FIELD_NAME_PREFIX () {0x8;}' unless defined(&DM_REPORT_OUTPUT_FIELD_NAME_PREFIX);
    eval 'sub DM_REPORT_OUTPUT_FIELD_UNQUOTED () {0x10;}' unless defined(&DM_REPORT_OUTPUT_FIELD_UNQUOTED);
    eval 'sub DM_REPORT_OUTPUT_COLUMNS_AS_ROWS () {0x20;}' unless defined(&DM_REPORT_OUTPUT_COLUMNS_AS_ROWS);
    eval 'sub DM_COOKIE_MAGIC () {0xd4d;}' unless defined(&DM_COOKIE_MAGIC);
    eval 'sub DM_UDEV_FLAGS_MASK () {0xffff0000;}' unless defined(&DM_UDEV_FLAGS_MASK);
    eval 'sub DM_UDEV_FLAGS_SHIFT () {16;}' unless defined(&DM_UDEV_FLAGS_SHIFT);
    eval 'sub DM_UDEV_DISABLE_DM_RULES_FLAG () {0x1;}' unless defined(&DM_UDEV_DISABLE_DM_RULES_FLAG);
    eval 'sub DM_UDEV_DISABLE_SUBSYSTEM_RULES_FLAG () {0x2;}' unless defined(&DM_UDEV_DISABLE_SUBSYSTEM_RULES_FLAG);
    eval 'sub DM_UDEV_DISABLE_DISK_RULES_FLAG () {0x4;}' unless defined(&DM_UDEV_DISABLE_DISK_RULES_FLAG);
    eval 'sub DM_UDEV_DISABLE_OTHER_RULES_FLAG () {0x8;}' unless defined(&DM_UDEV_DISABLE_OTHER_RULES_FLAG);
    eval 'sub DM_UDEV_LOW_PRIORITY_FLAG () {0x10;}' unless defined(&DM_UDEV_LOW_PRIORITY_FLAG);
    eval 'sub DM_DEV_DIR_UMASK () {0022;}' unless defined(&DM_DEV_DIR_UMASK);
}
1;
