require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_ASM_H_)) {
    eval 'sub _CPU_ASM_H_ () {1;}' unless defined(&_CPU_ASM_H_);
    require 'sys/cdefs.ph';
    if(defined(&PIC)) {
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x@ &PLT);
	}' unless defined(&PIC_PLT);
	if(defined(&__x86_64__)) {
	    eval 'sub PIC_GOT {
	        my($x) = @_;
    		eval q($x@ &GOTPCREL(% &rip));
	    }' unless defined(&PIC_GOT);
	} else {
	    eval 'sub PIC_PROLOGUE () { &pushl % &ebx;  &call 1 &f; 1:  &popl % &ebx;  &addl $ &_GLOBAL_OFFSET_TABLE_+[.-1 &b],% &ebx;}' unless defined(&PIC_PROLOGUE);
	    eval 'sub PIC_EPILOGUE () { &popl % &ebx;}' unless defined(&PIC_EPILOGUE);
	    eval 'sub PIC_GOT {
	        my($x) = @_;
    		eval q($x@ &GOT(% &ebx));
	    }' unless defined(&PIC_GOT);
	    eval 'sub PIC_GOTOFF {
	        my($x) = @_;
    		eval q($x@ &GOTOFF(% &ebx));
	    }' unless defined(&PIC_GOTOFF);
	}
    } else {
	if(!defined(&__x86_64__)) {
	    eval 'sub PIC_PROLOGUE () {1;}' unless defined(&PIC_PROLOGUE);
	    eval 'sub PIC_EPILOGUE () {1;}' unless defined(&PIC_EPILOGUE);
	    eval 'sub PIC_GOTOFF {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&PIC_GOTOFF);
	}
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOT);
    }
    eval 'sub ALIGN_DATA () {. &p2align 3;}' unless defined(&ALIGN_DATA);
    eval 'sub ALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&ALIGN_TEXT);
    eval 'sub SUPERALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&SUPERALIGN_TEXT);
    eval 'sub CNAME {
        my($csym) = @_;
	    eval q($csym);
    }' unless defined(&CNAME);
    eval 'sub HIDENAME {
        my($asmsym) = @_;
	    eval q(.$asmsym);
    }' unless defined(&HIDENAME);
    if(defined(&__x86_64__)) {
	eval 'sub _START_ENTRY () {. &text; . &p2align 4,0x90;}' unless defined(&_START_ENTRY);
    } else {
	eval 'sub _START_ENTRY () {. &text; . &p2align 2,0x90;}' unless defined(&_START_ENTRY);
    }
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q( &_START_ENTRY; . &globl  &CNAME($x); . &type  &CNAME($x),@ &function;  &CNAME($x):);
    }' unless defined(&_ENTRY);
    eval 'sub ALTENTRY {
        my($x) = @_;
	    eval q( &_ENTRY($x));
    }' unless defined(&ALTENTRY);
    eval 'sub ENTRY {
        my($x) = @_;
	    eval q( &_ENTRY($x));
    }' unless defined(&ENTRY);
    eval 'sub END {
        my($x) = @_;
	    eval q(. &size $x, . - $x);
    }' unless defined(&END);
    eval 'sub RCSID {
        my($x) = @_;
	    eval q(. &text; . &asciz $x);
    }' unless defined(&RCSID);
}
1;
