require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_ATOMIC_H_)) {
    eval 'sub _CPU_ATOMIC_H_ () {1;}' unless defined(&_CPU_ATOMIC_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    eval 'sub MPLOCKED () {"lock ; ";}' unless defined(&MPLOCKED);
    eval 'sub XACQUIRE () {"repne; ";}' unless defined(&XACQUIRE);
    eval 'sub XRELEASE () {"repe; ";}' unless defined(&XRELEASE);
    eval 'sub ATOMIC_ASM {
        my($NAME, $TYPE, $OP, $CONS, $V) = @_;
	    eval q( &static  &__inline  &void  &atomic_$NAME &_$TYPE( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile( &MPLOCKED $OP : \\"+m\\" (* &p) : $CONS ($V)); }  &static  &__inline  &void  &atomic_$NAME &_$TYPE &_xacquire( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile( &XACQUIRE  &MPLOCKED $OP : \\"+m\\" (* &p) : $CONS ($V)); }  &static  &__inline  &void  &atomic_$NAME &_$TYPE &_xrelease( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile( &XRELEASE  &MPLOCKED $OP : \\"+m\\" (* &p) : $CONS ($V)); }  &static  &__inline  &void  &atomic_$NAME &_$TYPE &_nonlocked( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile($OP : \\"+m\\" (* &p) : $CONS ($V)); });
    }' unless defined(&ATOMIC_ASM);
    eval 'sub atomic_readandclear_long {
        my($addr) = @_;
	    eval q({ my $res;  $res = 0;  &__asm  &__volatile( \\"	xchgq	%1,%0 ;		\\" \\"# atomic_readandclear_long\\" : \\"+r\\" ( $res), \\"=m\\" (*$addr) : \\"m\\" (*$addr)); ( $res); });
    }' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_readandclear_int {
        my($addr) = @_;
	    eval q({ \'u_int\'  &res;  &res = 0;  &__asm  &__volatile( \\"	xchgl	%1,%0 ;		\\" \\"# atomic_readandclear_int\\" : \\"+r\\" ( &res), \\"=m\\" (*$addr) : \\"m\\" (*$addr)); ( &res); });
    }' unless defined(&atomic_readandclear_int);
    eval 'sub atomic_swap_long {
        my($addr,$value) = @_;
	    eval q({  &__asm  &__volatile(\\"xchgq %0, %1\\" : \\"=r\\" ($value), \\"=m\\" (*$addr) : \\"0\\" ($value) : \\"memory\\"); ($value); });
    }' unless defined(&atomic_swap_long);
    eval 'sub atomic_swap_ptr {
        my($addr,$value) = @_;
	    eval q({  &__asm  &__volatile(\\"xchgq %0, %1\\" : \\"=r\\" ($value), \\"=m\\" (*$addr) : \\"0\\" ($value) : \\"memory\\"); ($value); });
    }' unless defined(&atomic_swap_ptr);
    eval 'sub atomic_poll_acquire_int {
        my($p) = @_;
	    eval q({ \'u_int\'  &data;  &__asm  &__volatile( &MPLOCKED \\"btsl $0,%0; setnc %%al; andl $255,%%eax\\" : \\"+m\\" (*$p), \\"=a\\" ( &data)); ( &data); });
    }' unless defined(&atomic_poll_acquire_int);
    eval 'sub atomic_poll_release_int {
        my($p) = @_;
	    eval q({  &__asm  &__volatile( &MPLOCKED \\"btrl $0,%0\\" : \\"+m\\" (*$p)); });
    }' unless defined(&atomic_poll_release_int);
    eval 'sub atomic_intr_handler_disable {
        my($p) = @_;
	    eval q({ \'int\'  &data;  &__asm  &__volatile( &MPLOCKED \\"orl $0x40000000,%1; movl %1,%%eax; \\" \\"andl $0x80000000,%%eax\\" : \\"=a\\"( &data) , \\"+m\\"(*$p)); ( &data); });
    }' unless defined(&atomic_intr_handler_disable);
    eval 'sub atomic_intr_handler_enable {
        my($p) = @_;
	    eval q({  &__asm  &__volatile( &MPLOCKED \\"andl $0xBFFFFFFF,%0\\" : \\"+m\\" (*$p)); });
    }' unless defined(&atomic_intr_handler_enable);
    eval 'sub atomic_intr_handler_is_enabled {
        my($p) = @_;
	    eval q({ \'int\'  &data;  &__asm  &__volatile(\\"movl %1,%%eax; andl $0x40000000,%%eax\\" : \\"=a\\"( &data) : \\"m\\"(*$p)); ( &data); });
    }' unless defined(&atomic_intr_handler_is_enabled);
    eval 'sub atomic_intr_cond_inc {
        my($p) = @_;
	    eval q({  &__asm  &__volatile( &MPLOCKED \\"incl %0\\" : \\"+m\\" (*$p)); });
    }' unless defined(&atomic_intr_cond_inc);
    eval 'sub atomic_intr_cond_dec {
        my($p) = @_;
	    eval q({  &__asm  &__volatile( &MPLOCKED \\"decl %0\\" : \\"+m\\" (*$p)); });
    }' unless defined(&atomic_intr_cond_dec);
    eval 'sub atomic_intr_cond_enter () {
        eval q(( &__atomic_intr_t * &p,  &void (* &func)( &void *),  &void * &arg) {  &__asm  &__volatile( &MPLOCKED \\"btsl $31,%0; jnc 3f; \\"  &MPLOCKED \\"incl %0; \\" \\"1: ;\\"  &MPLOCKED \\"btsl $31,%0; jnc 2f; \\" \\"movq %2,%%rdi; call *%1; \\" \\"jmp 1b; \\" \\"2: ;\\"  &MPLOCKED \\"decl %0; \\" \\"3: ;\\" : \\"+m\\" (* &p) : \\"r\\"( &func), \\"m\\"( &arg) : \\"ax\\", \\"cx\\", \\"dx\\", \\"rsi\\", \\"rdi\\", \\"r8\\", \\"r9\\", \\"r10\\", \\"r11\\"); } \'int\'  &atomic_intr_cond_try( &__atomic_intr_t * &p) { \'int\'  &ret;  &__asm  &__volatile(\\"subl %%eax,%%eax; \\"  &MPLOCKED \\"btsl $31,%0; jnc 2f; \\" \\"movl $1,%%eax;\\" \\"2: ;\\" : \\"+m\\" (* &p), \\"=&a\\"( &ret) : : \\"cx\\", \\"dx\\"); ( &ret); });
    }' unless defined(&atomic_intr_cond_enter);
    eval 'sub atomic_intr_cond_test {
        my($p) = @_;
	    eval q({ ((*$p & 0x80000000)); });
    }' unless defined(&atomic_intr_cond_test);
    eval 'sub atomic_intr_cond_exit () {
        eval q(( &__atomic_intr_t * &p,  &void (* &func)( &void *),  &void * &arg) {  &__asm  &__volatile( &MPLOCKED \\"btrl $31,%0; \\" \\"testl $0x3FFFFFFF,%0; jz 1f; \\" \\"movq %2,%%rdi; call *%1; \\" \\"1: ;\\" : \\"+m\\" (* &p) : \\"r\\"( &func), \\"m\\"( &arg) : \\"ax\\", \\"cx\\", \\"dx\\", \\"rsi\\", \\"rdi\\", \\"r8\\", \\"r9\\", \\"r10\\", \\"r11\\"); } \'int\'  &atomic_cmpxchg_int( &volatile \'u_int\' * &_dst, \'u_int\'  &_old, \'u_int\'  &_new) { \'u_int\'  &res =  &_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgl %2,%1; \\" : \\"+a\\" ( &res), \\"=m\\" (* &_dst) : \\"r\\" ( &_new), \\"m\\" (* &_dst) : \\"memory\\"); ( &res); });
    }' unless defined(&atomic_intr_cond_exit);
    eval 'sub atomic_cmpxchg_long_test {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_int\'  &res = $_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgq %2,%1; \\" \\" setz %%al;\\" \\" movsbq %%al,%%rax\\" : \\"+a\\" ( &res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( &res); });
    }' unless defined(&atomic_cmpxchg_long_test);
    eval 'sub atomic_cmpset_short {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = $_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgw %w2,%1; \\" : \\"+a\\" ( $res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( $res == $_old); });
    }' unless defined(&atomic_cmpset_short);
    eval 'sub atomic_fcmpset_char {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_char\'  &res = *$_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgb %2,%0; \\" : \\"+m\\" (*$_dst), \\"+a\\" (*$_old) : \\"r\\" ($_new) : \\"memory\\", \\"cc\\"); ( &res == *$_old); });
    }' unless defined(&atomic_fcmpset_char);
    eval 'sub atomic_fcmpset_short {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = *$_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgw %2,%0; \\" : \\"+m\\" (*$_dst), \\"+a\\" (*$_old) : \\"r\\" ($_new) : \\"memory\\", \\"cc\\"); ( $res == *$_old); });
    }' unless defined(&atomic_fcmpset_short);
    eval 'sub atomic_cmpset_int {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_int\'  &res = $_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgl %2,%1; \\" : \\"+a\\" ( &res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( &res == $_old); });
    }' unless defined(&atomic_cmpset_int);
    eval 'sub atomic_fcmpset_int {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_int\'  &res = *$_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgl %2,%0; \\" : \\"+m\\" (*$_dst), \\"+a\\" (*$_old) : \\"r\\" ($_new) : \\"memory\\", \\"cc\\"); ( &res == *$_old); });
    }' unless defined(&atomic_fcmpset_int);
    eval 'sub atomic_cmpset_int_xacquire {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_int\'  &res = $_old;  &__asm  &__volatile( &XACQUIRE  &MPLOCKED \\"cmpxchgl %2,%1; \\" : \\"+a\\" ( &res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( &res == $_old); });
    }' unless defined(&atomic_cmpset_int_xacquire);
    eval 'sub atomic_cmpset_int_xrelease {
        my($_dst,$_old,$_new) = @_;
	    eval q({ \'u_int\'  &res = $_old;  &__asm  &__volatile( &XRELEASE  &MPLOCKED \\"cmpxchgl %2,%1; \\" : \\"+a\\" ( &res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( &res == $_old); });
    }' unless defined(&atomic_cmpset_int_xrelease);
    eval 'sub atomic_cmpset_long {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = $_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgq %2,%1; \\" : \\"+a\\" ( $res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( $res == $_old); });
    }' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_fcmpset_long {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = *$_old;  &__asm  &__volatile( &MPLOCKED \\"cmpxchgq %2,%0; \\" : \\"+m\\" (*$_dst), \\"+a\\" (*$_old) : \\"r\\" ($_new) : \\"memory\\", \\"cc\\"); ( $res == *$_old); });
    }' unless defined(&atomic_fcmpset_long);
    eval 'sub atomic_cmpset_long_xacquire {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = $_old;  &__asm  &__volatile( &XACQUIRE  &MPLOCKED \\"cmpxchgq %2,%1; \\" : \\"+a\\" ( $res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( $res == $_old); });
    }' unless defined(&atomic_cmpset_long_xacquire);
    eval 'sub atomic_cmpset_long_xrelease {
        my($_dst,$_old,$_new) = @_;
	    eval q({ my $res = $_old;  &__asm  &__volatile( &XRELEASE  &MPLOCKED \\"cmpxchgq %2,%1; \\" : \\"+a\\" ( $res), \\"=m\\" (*$_dst) : \\"r\\" ($_new), \\"m\\" (*$_dst) : \\"memory\\"); ( $res == $_old); });
    }' unless defined(&atomic_cmpset_long_xrelease);
    eval 'sub atomic_cas_ptr {
        my($p,$e,$n) = @_;
	    eval q({  &__asm  &volatile( &MPLOCKED \\" cmpxchgq %2, %1\\" : \\"=a\\" ($n), \\"=m\\" (*( &volatile my $long *)$p) : \\"r\\" ($n), \\"a\\" ($e), \\"m\\" (*( &volatile my $long *)$p)); ($n); });
    }' unless defined(&atomic_cas_ptr);
    eval 'sub atomic_fetchadd_int_xacquire {
        my($_p,$_v) = @_;
	    eval q({  &__asm  &__volatile( &XACQUIRE  &MPLOCKED \\"xaddl %0,%1; \\" : \\"+r\\" ($_v), \\"=m\\" (*$_p) : \\"m\\" (*$_p) : \\"memory\\"); ($_v); });
    }' unless defined(&atomic_fetchadd_int_xacquire);
    eval 'sub atomic_fetchadd_int_xrelease {
        my($_p,$_v) = @_;
	    eval q({  &__asm  &__volatile( &XRELEASE  &MPLOCKED \\"xaddl %0,%1; \\" : \\"+r\\" ($_v), \\"=m\\" (*$_p) : \\"m\\" (*$_p) : \\"memory\\"); ($_v); });
    }' unless defined(&atomic_fetchadd_int_xrelease);
    eval 'sub atomic_fetchadd_long {
        my($_p,$_v) = @_;
	    eval q({  &__asm  &__volatile( &MPLOCKED \\"xaddq %0,%1; \\" : \\"+r\\" ($_v), \\"=m\\" (*$_p) : \\"m\\" (*$_p) : \\"memory\\"); ($_v); });
    }' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_fetchadd_long_xacquire {
        my($_p,$_v) = @_;
	    eval q({  &__asm  &__volatile( &XACQUIRE  &MPLOCKED \\"xaddq %0,%1; \\" : \\"+r\\" ($_v), \\"=m\\" (*$_p) : \\"m\\" (*$_p) : \\"memory\\"); ($_v); });
    }' unless defined(&atomic_fetchadd_long_xacquire);
    eval 'sub atomic_fetchadd_long_xrelease {
        my($_p,$_v) = @_;
	    eval q({  &__asm  &__volatile( &XRELEASE  &MPLOCKED \\"xaddq %0,%1; \\" : \\"+r\\" ($_v), \\"=m\\" (*$_p) : \\"m\\" (*$_p) : \\"memory\\"); ($_v); });
    }' unless defined(&atomic_fetchadd_long_xrelease);
    eval 'sub atomic_testandset_int {
        my($p,$v) = @_;
	    eval q({ \'u_char\'  &res;  &__asm  &__volatile( \\"	\\"  &MPLOCKED \\"		\\" \\"	btsl	%2,%1 ;		\\" \\"	setc	%0 ;		\\" \\"# atomic_testandset_int\\" : \\"=q\\" ( &res), \\"+m\\" (*$p) : \\"Ir\\" ($v & 0x1f) : \\"cc\\"); ( &res); });
    }' unless defined(&atomic_testandset_int);
    eval 'sub atomic_testandset_long {
        my($p,$v) = @_;
	    eval q({ \'u_char\'  &res;  &__asm  &__volatile( \\"	\\"  &MPLOCKED \\"		\\" \\"	btsq	%2,%1 ;		\\" \\"	setc	%0 ;		\\" \\"# atomic_testandset_long\\" : \\"=q\\" ( &res), \\"+m\\" (*$p) : \\"Ir\\" ($v & 0x3f) : \\"cc\\"); ( &res); });
    }' unless defined(&atomic_testandset_long);
    eval 'sub atomic_testandclear_int {
        my($p,$v) = @_;
	    eval q({ \'u_char\'  &res;  &__asm  &__volatile( \\"	\\"  &MPLOCKED \\"		\\" \\"	btrl	%2,%1 ;		\\" \\"	setc	%0 ;		\\" \\"# atomic_testandclear_int\\" : \\"=q\\" ( &res), \\"+m\\" (*$p) : \\"Ir\\" ($v & 0x1f) : \\"cc\\"); ( &res); });
    }' unless defined(&atomic_testandclear_int);
    eval 'sub atomic_testandclear_long {
        my($p,$v) = @_;
	    eval q({ \'u_char\'  &res;  &__asm  &__volatile( \\"	\\"  &MPLOCKED \\"		\\" \\"	btrq	%2,%1 ;		\\" \\"	setc	%0 ;		\\" \\"# atomic_testandclear_long\\" : \\"=q\\" ( &res), \\"+m\\" (*$p) : \\"Ir\\" ($v & 0x3f) : \\"cc\\"); ( &res); });
    }' unless defined(&atomic_testandclear_long);
    eval 'sub ATOMIC_STORE_LOAD {
        my($TYPE, $LOP, $SOP) = @_;
	    eval q( &static  &__inline  &u_$TYPE  &atomic_load_acq_$TYPE( &volatile  &u_$TYPE * &p) {  &u_$TYPE  &res;  &__asm  &__volatile( &MPLOCKED $LOP : \\"=a\\" ( &res), \\"=m\\" (* &p) : \\"m\\" (* &p) : \\"memory\\");  &return ( &res); }  &static  &__inline  &void  &atomic_store_rel_$TYPE( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile($SOP : \\"=m\\" (* &p), \\"+r\\" ( &v) : \\"m\\" (* &p)); } \'struct __hack\');
    }' unless defined(&ATOMIC_STORE_LOAD);
    undef(&ATOMIC_ASM) if defined(&ATOMIC_ASM);
    undef(&ATOMIC_STORE_LOAD) if defined(&ATOMIC_STORE_LOAD);
    eval 'sub atomic_set_acq_char () { &atomic_set_char;}' unless defined(&atomic_set_acq_char);
    eval 'sub atomic_set_rel_char () { &atomic_set_char;}' unless defined(&atomic_set_rel_char);
    eval 'sub atomic_clear_acq_char () { &atomic_clear_char;}' unless defined(&atomic_clear_acq_char);
    eval 'sub atomic_clear_rel_char () { &atomic_clear_char;}' unless defined(&atomic_clear_rel_char);
    eval 'sub atomic_add_acq_char () { &atomic_add_char;}' unless defined(&atomic_add_acq_char);
    eval 'sub atomic_add_rel_char () { &atomic_add_char;}' unless defined(&atomic_add_rel_char);
    eval 'sub atomic_subtract_acq_char () { &atomic_subtract_char;}' unless defined(&atomic_subtract_acq_char);
    eval 'sub atomic_subtract_rel_char () { &atomic_subtract_char;}' unless defined(&atomic_subtract_rel_char);
    eval 'sub atomic_set_acq_short () {\'atomic_set_short\';}' unless defined(&atomic_set_acq_short);
    eval 'sub atomic_set_rel_short () {\'atomic_set_short\';}' unless defined(&atomic_set_rel_short);
    eval 'sub atomic_clear_acq_short () {\'atomic_clear_short\';}' unless defined(&atomic_clear_acq_short);
    eval 'sub atomic_clear_rel_short () {\'atomic_clear_short\';}' unless defined(&atomic_clear_rel_short);
    eval 'sub atomic_add_acq_short () {\'atomic_add_short\';}' unless defined(&atomic_add_acq_short);
    eval 'sub atomic_add_rel_short () {\'atomic_add_short\';}' unless defined(&atomic_add_rel_short);
    eval 'sub atomic_subtract_acq_short () {\'atomic_subtract_short\';}' unless defined(&atomic_subtract_acq_short);
    eval 'sub atomic_subtract_rel_short () {\'atomic_subtract_short\';}' unless defined(&atomic_subtract_rel_short);
    eval 'sub atomic_set_acq_int () { &atomic_set_int;}' unless defined(&atomic_set_acq_int);
    eval 'sub atomic_set_rel_int () { &atomic_set_int;}' unless defined(&atomic_set_rel_int);
    eval 'sub atomic_clear_acq_int () { &atomic_clear_int;}' unless defined(&atomic_clear_acq_int);
    eval 'sub atomic_clear_rel_int () { &atomic_clear_int;}' unless defined(&atomic_clear_rel_int);
    eval 'sub atomic_add_acq_int () { &atomic_add_int;}' unless defined(&atomic_add_acq_int);
    eval 'sub atomic_add_rel_int () { &atomic_add_int;}' unless defined(&atomic_add_rel_int);
    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_int;}' unless defined(&atomic_subtract_acq_int);
    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_int;}' unless defined(&atomic_subtract_rel_int);
    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_int;}' unless defined(&atomic_cmpset_acq_int);
    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_int;}' unless defined(&atomic_cmpset_rel_int);
    eval 'sub atomic_set_acq_long () {\'atomic_set_long\';}' unless defined(&atomic_set_acq_long);
    eval 'sub atomic_set_rel_long () {\'atomic_set_long\';}' unless defined(&atomic_set_rel_long);
    eval 'sub atomic_clear_acq_long () {\'atomic_clear_long\';}' unless defined(&atomic_clear_acq_long);
    eval 'sub atomic_clear_rel_long () {\'atomic_clear_long\';}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_add_acq_long () {\'atomic_add_long\';}' unless defined(&atomic_add_acq_long);
    eval 'sub atomic_add_rel_long () {\'atomic_add_long\';}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_subtract_acq_long () {\'atomic_subtract_long\';}' unless defined(&atomic_subtract_acq_long);
    eval 'sub atomic_subtract_rel_long () {\'atomic_subtract_long\';}' unless defined(&atomic_subtract_rel_long);
    eval 'sub atomic_cmpset_acq_long () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_cmpset_rel_long () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_set_cpumask () {\'atomic_set_long\';}' unless defined(&atomic_set_cpumask);
    eval 'sub atomic_clear_cpumask () {\'atomic_clear_long\';}' unless defined(&atomic_clear_cpumask);
    eval 'sub atomic_cmpset_cpumask () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_cpumask);
    eval 'sub atomic_store_rel_cpumask () {\'atomic_store_rel_long\';}' unless defined(&atomic_store_rel_cpumask);
    eval 'sub atomic_load_acq_cpumask () {\'atomic_load_acq_long\';}' unless defined(&atomic_load_acq_cpumask);
    eval 'sub atomic_set_8 () { &atomic_set_char;}' unless defined(&atomic_set_8);
    eval 'sub atomic_set_acq_8 () { &atomic_set_acq_char;}' unless defined(&atomic_set_acq_8);
    eval 'sub atomic_set_rel_8 () { &atomic_set_rel_char;}' unless defined(&atomic_set_rel_8);
    eval 'sub atomic_clear_8 () { &atomic_clear_char;}' unless defined(&atomic_clear_8);
    eval 'sub atomic_clear_acq_8 () { &atomic_clear_acq_char;}' unless defined(&atomic_clear_acq_8);
    eval 'sub atomic_clear_rel_8 () { &atomic_clear_rel_char;}' unless defined(&atomic_clear_rel_8);
    eval 'sub atomic_add_8 () { &atomic_add_char;}' unless defined(&atomic_add_8);
    eval 'sub atomic_add_acq_8 () { &atomic_add_acq_char;}' unless defined(&atomic_add_acq_8);
    eval 'sub atomic_add_rel_8 () { &atomic_add_rel_char;}' unless defined(&atomic_add_rel_8);
    eval 'sub atomic_subtract_8 () { &atomic_subtract_char;}' unless defined(&atomic_subtract_8);
    eval 'sub atomic_subtract_acq_8 () { &atomic_subtract_acq_char;}' unless defined(&atomic_subtract_acq_8);
    eval 'sub atomic_subtract_rel_8 () { &atomic_subtract_rel_char;}' unless defined(&atomic_subtract_rel_8);
    eval 'sub atomic_load_acq_8 () { &atomic_load_acq_char;}' unless defined(&atomic_load_acq_8);
    eval 'sub atomic_store_rel_8 () { &atomic_store_rel_char;}' unless defined(&atomic_store_rel_8);
    eval 'sub atomic_fcmpset_8 () { &atomic_fcmpset_char;}' unless defined(&atomic_fcmpset_8);
    eval 'sub atomic_set_16 () {\'atomic_set_short\';}' unless defined(&atomic_set_16);
    eval 'sub atomic_set_acq_16 () {\'atomic_set_acq_short\';}' unless defined(&atomic_set_acq_16);
    eval 'sub atomic_set_rel_16 () {\'atomic_set_rel_short\';}' unless defined(&atomic_set_rel_16);
    eval 'sub atomic_clear_16 () {\'atomic_clear_short\';}' unless defined(&atomic_clear_16);
    eval 'sub atomic_clear_acq_16 () {\'atomic_clear_acq_short\';}' unless defined(&atomic_clear_acq_16);
    eval 'sub atomic_clear_rel_16 () {\'atomic_clear_rel_short\';}' unless defined(&atomic_clear_rel_16);
    eval 'sub atomic_add_16 () {\'atomic_add_short\';}' unless defined(&atomic_add_16);
    eval 'sub atomic_add_acq_16 () {\'atomic_add_acq_short\';}' unless defined(&atomic_add_acq_16);
    eval 'sub atomic_add_rel_16 () {\'atomic_add_rel_short\';}' unless defined(&atomic_add_rel_16);
    eval 'sub atomic_subtract_16 () {\'atomic_subtract_short\';}' unless defined(&atomic_subtract_16);
    eval 'sub atomic_subtract_acq_16 () {\'atomic_subtract_acq_short\';}' unless defined(&atomic_subtract_acq_16);
    eval 'sub atomic_subtract_rel_16 () {\'atomic_subtract_rel_short\';}' unless defined(&atomic_subtract_rel_16);
    eval 'sub atomic_load_acq_16 () {\'atomic_load_acq_short\';}' unless defined(&atomic_load_acq_16);
    eval 'sub atomic_store_rel_16 () {\'atomic_store_rel_short\';}' unless defined(&atomic_store_rel_16);
    eval 'sub atomic_fcmpset_16 () {\'atomic_fcmpset_short\';}' unless defined(&atomic_fcmpset_16);
    eval 'sub atomic_set_32 () { &atomic_set_int;}' unless defined(&atomic_set_32);
    eval 'sub atomic_set_acq_32 () { &atomic_set_acq_int;}' unless defined(&atomic_set_acq_32);
    eval 'sub atomic_set_rel_32 () { &atomic_set_rel_int;}' unless defined(&atomic_set_rel_32);
    eval 'sub atomic_clear_32 () { &atomic_clear_int;}' unless defined(&atomic_clear_32);
    eval 'sub atomic_clear_acq_32 () { &atomic_clear_acq_int;}' unless defined(&atomic_clear_acq_32);
    eval 'sub atomic_clear_rel_32 () { &atomic_clear_rel_int;}' unless defined(&atomic_clear_rel_32);
    eval 'sub atomic_add_32 () { &atomic_add_int;}' unless defined(&atomic_add_32);
    eval 'sub atomic_add_acq_32 () { &atomic_add_acq_int;}' unless defined(&atomic_add_acq_32);
    eval 'sub atomic_add_rel_32 () { &atomic_add_rel_int;}' unless defined(&atomic_add_rel_32);
    eval 'sub atomic_subtract_32 () { &atomic_subtract_int;}' unless defined(&atomic_subtract_32);
    eval 'sub atomic_subtract_acq_32 () { &atomic_subtract_acq_int;}' unless defined(&atomic_subtract_acq_32);
    eval 'sub atomic_subtract_rel_32 () { &atomic_subtract_rel_int;}' unless defined(&atomic_subtract_rel_32);
    eval 'sub atomic_load_acq_32 () { &atomic_load_acq_int;}' unless defined(&atomic_load_acq_32);
    eval 'sub atomic_store_rel_32 () { &atomic_store_rel_int;}' unless defined(&atomic_store_rel_32);
    eval 'sub atomic_cmpset_32 () { &atomic_cmpset_int;}' unless defined(&atomic_cmpset_32);
    eval 'sub atomic_fcmpset_32 () { &atomic_fcmpset_int;}' unless defined(&atomic_fcmpset_32);
    eval 'sub atomic_cmpset_acq_32 () { &atomic_cmpset_acq_int;}' unless defined(&atomic_cmpset_acq_32);
    eval 'sub atomic_cmpset_rel_32 () { &atomic_cmpset_rel_int;}' unless defined(&atomic_cmpset_rel_32);
    eval 'sub atomic_readandclear_32 () { &atomic_readandclear_int;}' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_fetchadd_32 () { &atomic_fetchadd_int;}' unless defined(&atomic_fetchadd_32);
    eval 'sub atomic_load_acq_64 () {\'atomic_load_acq_long\';}' unless defined(&atomic_load_acq_64);
    eval 'sub atomic_store_rel_64 () {\'atomic_store_rel_long\';}' unless defined(&atomic_store_rel_64);
    eval 'sub atomic_swap_64 () {\'atomic_swap_long\';}' unless defined(&atomic_swap_64);
    eval 'sub atomic_fetchadd_64 () {\'atomic_fetchadd_long\';}' unless defined(&atomic_fetchadd_64);
    eval 'sub atomic_add_64 () {\'atomic_add_long\';}' unless defined(&atomic_add_64);
    eval 'sub atomic_cmpset_64 () {\'atomic_cmpset_long\';}' unless defined(&atomic_cmpset_64);
    eval 'sub atomic_fcmpset_64 () {\'atomic_fcmpset_long\';}' unless defined(&atomic_fcmpset_64);
    eval 'sub atomic_set_64 () {\'atomic_set_long\';}' unless defined(&atomic_set_64);
    eval 'sub atomic_clear_64 () {\'atomic_clear_long\';}' unless defined(&atomic_clear_64);
    eval 'sub atomic_set_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_set_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_set_ptr);
    eval 'sub atomic_set_acq_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_set_acq_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_set_acq_ptr);
    eval 'sub atomic_set_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_set_rel_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_set_rel_ptr);
    eval 'sub atomic_clear_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_clear_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_clear_ptr);
    eval 'sub atomic_clear_acq_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_clear_acq_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_clear_acq_ptr);
    eval 'sub atomic_clear_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_clear_rel_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_clear_rel_ptr);
    eval 'sub atomic_add_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_add_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_add_ptr);
    eval 'sub atomic_add_acq_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_add_acq_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_add_acq_ptr);
    eval 'sub atomic_add_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_add_rel_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_add_rel_ptr);
    eval 'sub atomic_subtract_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_subtract_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_subtract_ptr);
    eval 'sub atomic_subtract_acq_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_subtract_acq_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_subtract_acq_ptr);
    eval 'sub atomic_subtract_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_subtract_rel_long(( &volatile \'u_long\' *), ($v)));
    }' unless defined(&atomic_subtract_rel_ptr);
    eval 'sub atomic_load_acq_ptr {
        my($p) = @_;
	    eval q( &atomic_load_acq_long(( &volatile \'u_long\' *)($p)));
    }' unless defined(&atomic_load_acq_ptr);
    eval 'sub atomic_store_rel_ptr {
        my($p, $v) = @_;
	    eval q( &atomic_store_rel_long(( &volatile \'u_long\' *)($p), ($v)));
    }' unless defined(&atomic_store_rel_ptr);
    eval 'sub atomic_cmpset_ptr {
        my($dst, $old, $new) = @_;
	    eval q( &atomic_cmpset_long(( &volatile \'u_long\' *), , ($new)));
    }' unless defined(&atomic_cmpset_ptr);
    eval 'sub atomic_fcmpset_ptr {
        my($dst, $old, $new) = @_;
	    eval q( &atomic_fcmpset_long(( &volatile \'u_long\' *), , ($new)));
    }' unless defined(&atomic_fcmpset_ptr);
    eval 'sub atomic_cmpset_acq_ptr {
        my($dst, $old, $new) = @_;
	    eval q( &atomic_cmpset_acq_long(( &volatile \'u_long\' *), , ($new)));
    }' unless defined(&atomic_cmpset_acq_ptr);
    eval 'sub atomic_cmpset_rel_ptr {
        my($dst, $old, $new) = @_;
	    eval q( &atomic_cmpset_rel_long(( &volatile \'u_long\' *), , ($new)));
    }' unless defined(&atomic_cmpset_rel_ptr);
    eval 'sub atomic_readandclear_ptr {
        my($p) = @_;
	    eval q( &atomic_readandclear_long(( &volatile \'u_long\' *)($p)));
    }' unless defined(&atomic_readandclear_ptr);
}
1;
