require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_DB_MACHDEP_H_)) {
    eval 'sub _CPU_DB_MACHDEP_H_ () {1;}' unless defined(&_CPU_DB_MACHDEP_H_);
    require 'cpu/frame.ph';
    require 'cpu/trap.ph';
    eval 'sub x86_64_saved_state () { &trapframe;}' unless defined(&x86_64_saved_state);
    if(defined(&_KERNEL)) {
	eval 'sub DDB_EXPR_FMT () {"l";}' unless defined(&DDB_EXPR_FMT);
	eval 'sub DDB_REGS () {( &ddb_regs);}' unless defined(&DDB_REGS);
    }
    eval 'sub BKPT_INST () {0xcc;}' unless defined(&BKPT_INST);
    eval 'sub BKPT_SIZE () {(1);}' unless defined(&BKPT_SIZE);
    eval 'sub BKPT_SET {
        my($inst) = @_;
	    eval q(( &BKPT_INST));
    }' unless defined(&BKPT_SET);
    eval 'sub FIXUP_PC_AFTER_BREAK () { ($ddb_regs->{tf_rip}) -= 1;;}' unless defined(&FIXUP_PC_AFTER_BREAK);
    eval 'sub db_clear_single_step {
        my($regs) = @_;
	    eval q((($regs)-> &tf_rflags &= ~ &PSL_T));
    }' unless defined(&db_clear_single_step);
    eval 'sub db_set_single_step {
        my($regs) = @_;
	    eval q((($regs)-> &tf_rflags |=  &PSL_T));
    }' unless defined(&db_set_single_step);
    eval 'sub IS_BREAKPOINT_TRAP {
        my($type, $code) = @_;
	    eval q((($type) ==  &T_BPTFLT));
    }' unless defined(&IS_BREAKPOINT_TRAP);
    eval 'sub IS_WATCHPOINT_TRAP {
        my($type, $code) = @_;
	    eval q(0);
    }' unless defined(&IS_WATCHPOINT_TRAP);
    eval 'sub I_CALL () {0xe8;}' unless defined(&I_CALL);
    eval 'sub I_CALLI () {0xff;}' unless defined(&I_CALLI);
    eval 'sub I_RET () {0xc3;}' unless defined(&I_RET);
    eval 'sub I_IRET () {0xcf;}' unless defined(&I_IRET);
    eval 'sub inst_trap_return {
        my($ins) = @_;
	    eval q(((($ins)&0xff) ==  &I_IRET));
    }' unless defined(&inst_trap_return);
    eval 'sub inst_return {
        my($ins) = @_;
	    eval q(((($ins)&0xff) ==  &I_RET));
    }' unless defined(&inst_return);
    eval 'sub inst_call {
        my($ins) = @_;
	    eval q(((($ins)&0xff) ==  &I_CALL || ((($ins)&0xff) ==  &I_CALLI  && (($ins)&0x3800) == 0x1000)));
    }' unless defined(&inst_call);
    eval 'sub inst_load {
        my($ins) = @_;
	    eval q(0);
    }' unless defined(&inst_load);
    eval 'sub inst_store {
        my($ins) = @_;
	    eval q(0);
    }' unless defined(&inst_store);
    eval 'sub DB_SMALL_VALUE_MAX () {0x7fffffff;}' unless defined(&DB_SMALL_VALUE_MAX);
    eval 'sub DB_SMALL_VALUE_MIN () {(-0x400001);}' unless defined(&DB_SMALL_VALUE_MIN);
}
1;
