require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_ELF_H_)) {
    eval 'sub _CPU_ELF_H_ () {1;}' unless defined(&_CPU_ELF_H_);
    unless(defined(&__ELF_WORD_SIZE)) {
	eval 'sub __ELF_WORD_SIZE () {64;}' unless defined(&__ELF_WORD_SIZE);
    }
    require 'sys/elf32.ph';
    require 'sys/elf64.ph';
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_X86_64;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_X86_64));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_BRK () {10;}' unless defined(&AT_BRK);
    eval 'sub AT_DEBUG () {11;}' unless defined(&AT_DEBUG);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_EXECPATH () {15;}' unless defined(&AT_EXECPATH);
    eval 'sub AT_CANARY () {16;}' unless defined(&AT_CANARY);
    eval 'sub AT_CANARYLEN () {17;}' unless defined(&AT_CANARYLEN);
    eval 'sub AT_OSRELDATE () {18;}' unless defined(&AT_OSRELDATE);
    eval 'sub AT_NCPUS () {19;}' unless defined(&AT_NCPUS);
    eval 'sub AT_PAGESIZES () {20;}' unless defined(&AT_PAGESIZES);
    eval 'sub AT_PAGESIZESLEN () {21;}' unless defined(&AT_PAGESIZESLEN);
    eval 'sub AT_STACKPROT () {23;}' unless defined(&AT_STACKPROT);
    eval 'sub AT_COUNT () {24;}' unless defined(&AT_COUNT);
    eval 'sub R_X86_64_NONE () {0;}' unless defined(&R_X86_64_NONE);
    eval 'sub R_X86_64_64 () {1;}' unless defined(&R_X86_64_64);
    eval 'sub R_X86_64_PC32 () {2;}' unless defined(&R_X86_64_PC32);
    eval 'sub R_X86_64_GOT32 () {3;}' unless defined(&R_X86_64_GOT32);
    eval 'sub R_X86_64_PLT32 () {4;}' unless defined(&R_X86_64_PLT32);
    eval 'sub R_X86_64_COPY () {5;}' unless defined(&R_X86_64_COPY);
    eval 'sub R_X86_64_GLOB_DAT () {6;}' unless defined(&R_X86_64_GLOB_DAT);
    eval 'sub R_X86_64_JMP_SLOT () {7;}' unless defined(&R_X86_64_JMP_SLOT);
    eval 'sub R_X86_64_RELATIVE () {8;}' unless defined(&R_X86_64_RELATIVE);
    eval 'sub R_X86_64_GOTPCREL () {9;}' unless defined(&R_X86_64_GOTPCREL);
    eval 'sub R_X86_64_32 () {10;}' unless defined(&R_X86_64_32);
    eval 'sub R_X86_64_32S () {11;}' unless defined(&R_X86_64_32S);
    eval 'sub R_X86_64_16 () {12;}' unless defined(&R_X86_64_16);
    eval 'sub R_X86_64_PC16 () {13;}' unless defined(&R_X86_64_PC16);
    eval 'sub R_X86_64_8 () {14;}' unless defined(&R_X86_64_8);
    eval 'sub R_X86_64_PC8 () {15;}' unless defined(&R_X86_64_PC8);
    eval 'sub R_X86_64_DTPMOD64 () {16;}' unless defined(&R_X86_64_DTPMOD64);
    eval 'sub R_X86_64_DTPOFF64 () {17;}' unless defined(&R_X86_64_DTPOFF64);
    eval 'sub R_X86_64_TPOFF64 () {18;}' unless defined(&R_X86_64_TPOFF64);
    eval 'sub R_X86_64_TLSGD () {19;}' unless defined(&R_X86_64_TLSGD);
    eval 'sub R_X86_64_TLSLD () {20;}' unless defined(&R_X86_64_TLSLD);
    eval 'sub R_X86_64_DTPOFF32 () {21;}' unless defined(&R_X86_64_DTPOFF32);
    eval 'sub R_X86_64_GOTTPOFF () {22;}' unless defined(&R_X86_64_GOTTPOFF);
    eval 'sub R_X86_64_TPOFF32 () {23;}' unless defined(&R_X86_64_TPOFF32);
    eval 'sub R_X86_64_IRELATIVE () {37;}' unless defined(&R_X86_64_IRELATIVE);
    eval 'sub R_X86_64_COUNT () {38;}' unless defined(&R_X86_64_COUNT);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 32) {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    } else {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS64;}' unless defined(&ELF_TARG_CLASS);
    }
    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    eval 'sub ELF_TARG_MACH () { &EM_X86_64;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    eval 'sub ET_DYN_LOAD_ADDR () {0x1021000;}' unless defined(&ET_DYN_LOAD_ADDR);
    if(defined(&_KERNEL)) {
	eval 'sub ELF_RTLD_ADDR {
	    my($vmspace) = @_;
    	    eval q(( &round_page(( &vm_offset_t)($vmspace)-> &vm_daddr +  &maxdsiz)));
	}' unless defined(&ELF_RTLD_ADDR);
    }
}
1;
