require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CPU_LIMITS_H_)) {
    eval 'sub _CPU_LIMITS_H_ () {1;}' unless defined(&_CPU_LIMITS_H_);
    require 'sys/cdefs.ph';
    eval 'sub CHAR_BIT () {8;}' unless defined(&CHAR_BIT);
    eval 'sub MB_LEN_MAX () {6;}' unless defined(&MB_LEN_MAX);
    eval 'sub SCHAR_MAX () {0x7f;}' unless defined(&SCHAR_MAX);
    eval 'sub SCHAR_MIN () {(-0x7f - 1);}' unless defined(&SCHAR_MIN);
    eval 'sub UCHAR_MAX () {0xff;}' unless defined(&UCHAR_MAX);
    if(defined(&__CHAR_UNSIGNED__)) {
	eval 'sub CHAR_MAX () { &UCHAR_MAX;}' unless defined(&CHAR_MAX);
	eval 'sub CHAR_MIN () {0;}' unless defined(&CHAR_MIN);
    } else {
	eval 'sub CHAR_MAX () { &SCHAR_MAX;}' unless defined(&CHAR_MAX);
	eval 'sub CHAR_MIN () { &SCHAR_MIN;}' unless defined(&CHAR_MIN);
    }
    eval 'sub USHRT_MAX () {0xffff;}' unless defined(&USHRT_MAX);
    eval 'sub SHRT_MAX () {0x7fff;}' unless defined(&SHRT_MAX);
    eval 'sub SHRT_MIN () {(-0x7fff - 1);}' unless defined(&SHRT_MIN);
    eval 'sub UINT_MAX () {0xffffffff;}' unless defined(&UINT_MAX);
    eval 'sub INT_MAX () {0x7fffffff;}' unless defined(&INT_MAX);
    eval 'sub INT_MIN () {(-0x7fffffff - 1);}' unless defined(&INT_MIN);
    if(defined(&__x86_64__)) {
	eval 'sub ULONG_MAX () {0xffffffffffffffff;}' unless defined(&ULONG_MAX);
	eval 'sub LONG_MAX () {0x7fffffffffffffff;}' unless defined(&LONG_MAX);
	eval 'sub LONG_MIN () {(-0x7fffffffffffffff - 1);}' unless defined(&LONG_MIN);
	if(defined(&__LONG_LONG_SUPPORTED)) {
	    eval 'sub ULLONG_MAX () {0xffffffffffffffff;}' unless defined(&ULLONG_MAX);
	    eval 'sub LLONG_MAX () {0x7fffffffffffffff;}' unless defined(&LLONG_MAX);
	    eval 'sub LLONG_MIN () {(-0x7fffffffffffffff - 1);}' unless defined(&LLONG_MIN);
	}
    }
 elsif(defined(&__i386__)) {
	eval 'sub ULONG_MAX () {0xffffffff;}' unless defined(&ULONG_MAX);
	eval 'sub LONG_MAX () {0x7fffffff;}' unless defined(&LONG_MAX);
	eval 'sub LONG_MIN () {(-0x7fffffff - 1);}' unless defined(&LONG_MIN);
	if(defined(&__LONG_LONG_SUPPORTED)) {
	    eval 'sub ULLONG_MAX () {0xffffffff;}' unless defined(&ULLONG_MAX);
	    eval 'sub LLONG_MAX () {0x7fffffff;}' unless defined(&LLONG_MAX);
	    eval 'sub LLONG_MIN () {(-0x7fffffff - 1);}' unless defined(&LLONG_MIN);
	}
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) || (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef)) {
	eval 'sub SSIZE_MAX () { &LONG_MAX;}' unless defined(&SSIZE_MAX);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112|| (defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef)) {
	eval 'sub SIZE_T_MAX () { &ULONG_MAX;}' unless defined(&SIZE_T_MAX);
	eval 'sub OFF_MAX () { &LONG_MAX;}' unless defined(&OFF_MAX);
	eval 'sub OFF_MIN () { &LONG_MIN;}' unless defined(&OFF_MIN);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub GID_MAX () { &UINT_MAX;}' unless defined(&GID_MAX);
	eval 'sub UID_MAX () { &UINT_MAX;}' unless defined(&UID_MAX);
	eval 'sub UQUAD_MAX () { &ULLONG_MAX;}' unless defined(&UQUAD_MAX);
	eval 'sub QUAD_MAX () { &LLONG_MAX;}' unless defined(&QUAD_MAX);
	eval 'sub QUAD_MIN () { &LLONG_MIN;}' unless defined(&QUAD_MIN);
    }
    if((defined(&__XSI_VISIBLE) ? &__XSI_VISIBLE : undef) || (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200809) {
	if(defined(&__x86_64__)) {
	    eval 'sub LONG_BIT () {64;}' unless defined(&LONG_BIT);
	}
 elsif(defined(&__i386__)) {
	    eval 'sub LONG_BIT () {32;}' unless defined(&LONG_BIT);
	}
	eval 'sub WORD_BIT () {32;}' unless defined(&WORD_BIT);
    }
}
1;
