require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_BUF2_H_)) {
    eval 'sub _SYS_BUF2_H_ () {1;}' unless defined(&_SYS_BUF2_H_);
    if(defined(&_KERNEL)) {
	unless(defined(&_SYS_BUF_H_)) {
	    require 'sys/buf.ph';
	}
	unless(defined(&_SYS_MOUNT_H_)) {
	    require 'sys/mount.ph';
	}
	unless(defined(&_SYS_VNODE_H_)) {
	    require 'sys/vnode.ph';
	}
	unless(defined(&_VM_VM_PAGE_H_)) {
	    require 'vm/vm_page.ph';
	}
	eval 'sub BUF_LOCKINIT {
	    my($bp) = @_;
    	    eval q( &lockinit(($bp)-> &b_lock,  &buf_wmesg, 0,  &LK_NOCOLLSTATS));
	}' unless defined(&BUF_LOCKINIT);
	eval 'sub BUF_LOCKFREE {
	    my($bp) = @_;
    	    eval q( &if ( &BUF_LOCKINUSE($bp))  &panic(\\"free locked buf\\"));
	}' unless defined(&BUF_LOCKFREE);
	eval 'sub bioq_init {
	    my($bioq) = @_;
    	    eval q({  &TAILQ_INIT( ($bioq->{queue}));  ($bioq->{off_unused}) = 0;  ($bioq->{reorder}) = 0;  ($bioq->{transition}) =  &NULL;  ($bioq->{bio_unused}) =  &NULL; });
	}' unless defined(&bioq_init);
	eval 'sub bioq_insert_tail {
	    my($bioq,$bio) = @_;
    	    eval q({  ($bioq->{transition}) =  &NULL;  &TAILQ_INSERT_TAIL( ($bioq->{queue}), $bio,  &bio_act); });
	}' unless defined(&bioq_insert_tail);
	eval 'sub bioq_remove {
	    my($bioq,$bio) = @_;
    	    eval q({  &if ($bio ==  ($bioq->{transition}))  ($bioq->{transition}) =  &TAILQ_NEXT($bio,  &bio_act);  &TAILQ_REMOVE( ($bioq->{queue}), $bio,  &bio_act); });
	}' unless defined(&bioq_remove);
	eval 'sub bioq_first {
	    my($bioq) = @_;
    	    eval q({ ( &TAILQ_FIRST( ($bioq->{queue}))); });
	}' unless defined(&bioq_first);
	eval 'sub bioq_takefirst {
	    my($bioq) = @_;
    	    eval q({ \'struct bio\' * &bp;  &bp =  &TAILQ_FIRST( ($bioq->{queue}));  &if ( &bp !=  &NULL)  &bioq_remove($bioq,  &bp); ( &bp); });
	}' unless defined(&bioq_takefirst);
	eval 'sub buf_act_decline {
	    my($bp) = @_;
    	    eval q({  &if ( ($bp->{b_act_count}) <  &ACT_DECLINE)  ($bp->{b_act_count}) = 0;  &else  ($bp->{b_act_count}) -=  &ACT_DECLINE; });
	}' unless defined(&buf_act_decline);
	eval 'sub bread {
	    my($vp,$loffset,$size,$bpp) = @_;
    	    eval q({ *$bpp =  &NULL; ( &breadnx($vp, $loffset, $size,  &B_NOTMETA,  &NULL,  &NULL, 0, $bpp)); });
	}' unless defined(&bread);
	eval 'sub bread_kvabio {
	    my($vp,$loffset,$size,$bpp) = @_;
    	    eval q({ *$bpp =  &NULL; ( &breadnx($vp, $loffset, $size,  &B_NOTMETA |  &B_KVABIO,  &NULL,  &NULL, 0, $bpp)); });
	}' unless defined(&bread_kvabio);
	eval 'sub breadn {
	    my($vp,$loffset,$size,$raoffset,$rabsize,$cnt,$bpp) = @_;
    	    eval q({ *$bpp =  &NULL; ( &breadnx($vp, $loffset, $size,  &B_NOTMETA, $raoffset, $rabsize, $cnt, $bpp)); });
	}' unless defined(&breadn);
	eval 'sub cluster_read {
	    my($vp,$filesize,$loffset,$blksize,$minreq,$maxreq,$bpp) = @_;
    	    eval q({ *$bpp =  &NULL; ( &cluster_readx($vp, $filesize, $loffset, $blksize,  &B_NOTMETA, $minreq, $maxreq, $bpp)); });
	}' unless defined(&cluster_read);
	eval 'sub cluster_read_kvabio {
	    my($vp,$filesize,$loffset,$blksize,$minreq,$maxreq,$bpp) = @_;
    	    eval q({ *$bpp =  &NULL; ( &cluster_readx($vp, $filesize, $loffset, $blksize,  &B_NOTMETA |  &B_KVABIO, $minreq, $maxreq, $bpp)); });
	}' unless defined(&cluster_read_kvabio);
    }
}
1;
