require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CDEFS_H_)) {
    eval 'sub _SYS_CDEFS_H_ () {1;}' unless defined(&_SYS_CDEFS_H_);
    unless(defined(&__has_attribute)) {
	eval 'sub __has_attribute {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_attribute);
    }
    unless(defined(&__has_extension)) {
	eval 'sub __has_extension () { &__has_feature;}' unless defined(&__has_extension);
    }
    unless(defined(&__has_feature)) {
	eval 'sub __has_feature {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_feature);
    }
    unless(defined(&__has_include)) {
	eval 'sub __has_include {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_include);
    }
    unless(defined(&__has_builtin)) {
	eval 'sub __has_builtin {
	    my($x) = @_;
    	    eval q(0);
	}' unless defined(&__has_builtin);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __GNUC_PREREQ__ {
	    my($ma, $mi) = @_;
    	    eval q(( &__GNUC__ > ($ma) ||  &__GNUC__ == ($ma)  &&  &__GNUC_MINOR__ >= ($mi)));
	}' unless defined(&__GNUC_PREREQ__);
    } else {
	eval 'sub __GNUC_PREREQ__ {
	    my($ma, $mi) = @_;
    	    eval q(0);
	}' unless defined(&__GNUC_PREREQ__);
    }
    if(defined(&__cplusplus)) {
	eval 'sub __BEGIN_EXTERN_C () { &extern "C" {;}' unless defined(&__BEGIN_EXTERN_C);
	eval 'sub __END_EXTERN_C () {};}' unless defined(&__END_EXTERN_C);
    } else {
	eval 'sub __BEGIN_DECLS () {1;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () {1;}' unless defined(&__END_DECLS);
	eval 'sub __BEGIN_EXTERN_C () {1;}' unless defined(&__BEGIN_EXTERN_C);
	eval 'sub __END_EXTERN_C () {1;}' unless defined(&__END_EXTERN_C);
    }
    if( &__GNUC_PREREQ__(4, 0)) {
	eval 'sub __dso_public () { &__attribute__(( &__visibility__("default")));}' unless defined(&__dso_public);
	eval 'sub __dso_hidden () { &__attribute__(( &__visibility__("hidden")));}' unless defined(&__dso_hidden);
	eval 'sub __BEGIN_PUBLIC_DECLS () { &_Pragma("GCC visibility push(default)")  &__BEGIN_EXTERN_C;}' unless defined(&__BEGIN_PUBLIC_DECLS);
	eval 'sub __END_PUBLIC_DECLS () { &__END_EXTERN_C  &_Pragma("GCC visibility pop");}' unless defined(&__END_PUBLIC_DECLS);
	eval 'sub __BEGIN_HIDDEN_DECLS () { &_Pragma("GCC visibility push(hidden)")  &__BEGIN_EXTERN_C;}' unless defined(&__BEGIN_HIDDEN_DECLS);
	eval 'sub __END_HIDDEN_DECLS () { &__END_EXTERN_C  &_Pragma("GCC visibility pop");}' unless defined(&__END_HIDDEN_DECLS);
    } else {
	eval 'sub __dso_public () {1;}' unless defined(&__dso_public);
	eval 'sub __dso_hidden () {1;}' unless defined(&__dso_hidden);
	eval 'sub __BEGIN_PUBLIC_DECLS () { &__BEGIN_EXTERN_C;}' unless defined(&__BEGIN_PUBLIC_DECLS);
	eval 'sub __END_PUBLIC_DECLS () { &__END_EXTERN_C;}' unless defined(&__END_PUBLIC_DECLS);
	eval 'sub __BEGIN_HIDDEN_DECLS () { &__BEGIN_EXTERN_C;}' unless defined(&__BEGIN_HIDDEN_DECLS);
	eval 'sub __END_HIDDEN_DECLS () { &__END_EXTERN_C;}' unless defined(&__END_HIDDEN_DECLS);
    }
    if(defined(&__cplusplus)) {
	eval 'sub __BEGIN_DECLS () { &__BEGIN_PUBLIC_DECLS;}' unless defined(&__BEGIN_DECLS);
	eval 'sub __END_DECLS () { &__END_PUBLIC_DECLS;}' unless defined(&__END_DECLS);
    }
    eval 'sub __VM_CACHELINE_SIZE () {64;}' unless defined(&__VM_CACHELINE_SIZE);
    eval 'sub __VM_CACHELINE_MASK () {( &__VM_CACHELINE_SIZE - 1);}' unless defined(&__VM_CACHELINE_MASK);
    eval 'sub __VM_CACHELINE_ALIGN {
        my($n) = @_;
	    eval q(((($n) +  &__VM_CACHELINE_MASK) & ~ &__VM_CACHELINE_MASK));
    }' unless defined(&__VM_CACHELINE_ALIGN);
    if(defined(&__STDC__) || defined(&__cplusplus)) {
	eval 'sub __P {
	    my($protos) = @_;
    	    eval q($protos);
	}' unless defined(&__P);
	eval 'sub __CONCAT1 {
	    my($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT1);
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q( &__CONCAT1($x,$y));
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
	eval 'sub __XSTRING {
	    my($x) = @_;
    	    eval q( &__STRING($x));
	}' unless defined(&__XSTRING);
	eval 'sub __const () { &const;}' unless defined(&__const);
	eval 'sub __signed () {\'signed\';}' unless defined(&__signed);
	eval 'sub __volatile () { &volatile;}' unless defined(&__volatile);
	if(defined(&__cplusplus)) {
	    eval 'sub __inline () { &inline;}' unless defined(&__inline);
	} else {
	    unless(defined(&__GNUC__)) {
		eval 'sub __inline () {1;}' unless defined(&__inline);
	    }
	}
    } else {
	eval 'sub __P {
	    my($protos) = @_;
    	    eval q(());
	}' unless defined(&__P);
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
	unless(defined(&__GNUC__)) {
	    eval 'sub __const () {1;}' unless defined(&__const);
	    eval 'sub __inline () {1;}' unless defined(&__inline);
	    eval 'sub __signed () {1;}' unless defined(&__signed);
	    eval 'sub __volatile () {1;}' unless defined(&__volatile);
	    unless(defined(&NO_ANSI_KEYWORDS)) {
		eval 'sub const () {1;}' unless defined(&const);
		eval 'sub inline () {1;}' unless defined(&inline);
		eval 'sub signed () {1;}' unless defined(&signed);
		eval 'sub volatile () {1;}' unless defined(&volatile);
	    }
	}
    }
    eval 'sub __weak_symbol () { &__attribute__(( &__weak__));}' unless defined(&__weak_symbol);
    if( &__GNUC_PREREQ__(2, 7)) {
	eval 'sub __dead2 () { &__attribute__(( &__noreturn__));}' unless defined(&__dead2);
	eval 'sub __pure2 () { &__attribute__(( &__const__));}' unless defined(&__pure2);
	eval 'sub __unused () { &__attribute__(( &__unused__));}' unless defined(&__unused);
	eval 'sub __packed () { &__attribute__(( &__packed__));}' unless defined(&__packed);
	eval 'sub __aligned {
	    my($x) = @_;
    	    eval q( &__attribute__(( &__aligned__($x))));
	}' unless defined(&__aligned);
	eval 'sub __section {
	    my($x) = @_;
    	    eval q( &__attribute__(( &__section__($x))));
	}' unless defined(&__section);
    } else {
	eval 'sub __dead2 () {1;}' unless defined(&__dead2);
	eval 'sub __pure2 () {1;}' unless defined(&__pure2);
	eval 'sub __unused () {1;}' unless defined(&__unused);
    }
    if( &__GNUC_PREREQ__(2, 96)) {
	eval 'sub __malloclike () { &__attribute__(( &__malloc__));}' unless defined(&__malloclike);
	eval 'sub __pure () { &__attribute__(( &__pure__));}' unless defined(&__pure);
    } else {
	eval 'sub __malloclike () {1;}' unless defined(&__malloclike);
	eval 'sub __pure () { &__pure2;}' unless defined(&__pure);
    }
    if( &__GNUC_PREREQ__(3, 1)) {
	eval 'sub __always_inline () { &__attribute__(( &__always_inline__));}' unless defined(&__always_inline);
	eval 'sub __noinline () { &__attribute__(( &__noinline__));}' unless defined(&__noinline);
    } else {
	eval 'sub __always_inline () {1;}' unless defined(&__always_inline);
	eval 'sub __noinline () {1;}' unless defined(&__noinline);
    }
    if( &__GNUC_PREREQ__(3, 3)) {
	eval 'sub __nonnull () {(...)  &__attribute__(( &__nonnull__( &__VA_ARGS__)));}' unless defined(&__nonnull);
	eval 'sub __used () { &__attribute__(( &__used__));}' unless defined(&__used);
    } else {
	eval 'sub __nonnull () {(...);}' unless defined(&__nonnull);
	eval 'sub __used () { &__unused;}' unless defined(&__used);
    }
    if( &__GNUC_PREREQ__(3, 4)) {
	eval 'sub __heedresult () { &__attribute__(( &__warn_unused_result__));}' unless defined(&__heedresult);
    } else {
	eval 'sub __heedresult () {1;}' unless defined(&__heedresult);
    }
    if( &__GNUC_PREREQ__(4, 1)) {
	eval 'sub __returns_twice () { &__attribute__(( &__returns_twice__));}' unless defined(&__returns_twice);
    } else {
	eval 'sub __returns_twice () {1;}' unless defined(&__returns_twice);
    }
    if( &__GNUC_PREREQ__(4, 6) ||  &__has_builtin((defined(&__builtin_unreachable) ? &__builtin_unreachable : undef))) {
	eval 'sub __unreachable () {
	    eval q( &__builtin_unreachable());
	}' unless defined(&__unreachable);
    } else {
	eval 'sub __unreachable () {
	    eval q((( &void)0));
	}' unless defined(&__unreachable);
    }
    if( &__GNUC_PREREQ__(4, 3) ||  &__has_attribute((defined(&__alloc_size__) ? &__alloc_size__ : undef))) {
	eval 'sub __alloc_size {
	    my($x) = @_;
    	    eval q( &__attribute__(( &__alloc_size__($x))));
	}' unless defined(&__alloc_size);
	eval 'sub __alloc_size2 {
	    my($n, $x) = @_;
    	    eval q( &__attribute__(( &__alloc_size__($n, $x))));
	}' unless defined(&__alloc_size2);
    } else {
	eval 'sub __alloc_size {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&__alloc_size);
	eval 'sub __alloc_size2 {
	    my($n, $x) = @_;
    	    eval q();
	}' unless defined(&__alloc_size2);
    }
    if( &__GNUC_PREREQ__(4, 9) ||  &__has_attribute((defined(&__alloc_align__) ? &__alloc_align__ : undef))) {
	eval 'sub __alloc_align {
	    my($x) = @_;
    	    eval q( &__attribute__(( &__alloc_align__($x))));
	}' unless defined(&__alloc_align);
    } else {
	eval 'sub __alloc_align {
	    my($x) = @_;
    	    eval q();
	}' unless defined(&__alloc_align);
    }
    if(! &__GNUC_PREREQ__(2, 7)  && (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) < 199901) {
	eval 'sub __func__ () { &NULL;}' unless defined(&__func__);
    }
    if(( &__GNUC_PREREQ__(2, 0)  && !defined(&__STRICT_ANSI__)) || (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 199901) {
	eval 'sub __LONG_LONG_SUPPORTED () {1;}' unless defined(&__LONG_LONG_SUPPORTED);
    }
    if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	eval 'sub __LONG_LONG_SUPPORTED () {1;}' unless defined(&__LONG_LONG_SUPPORTED);
	unless(defined(&__STDC_LIMIT_MACROS)) {
	    eval 'sub __STDC_LIMIT_MACROS () {1;}' unless defined(&__STDC_LIMIT_MACROS);
	}
	unless(defined(&__STDC_CONSTANT_MACROS)) {
	    eval 'sub __STDC_CONSTANT_MACROS () {1;}' unless defined(&__STDC_CONSTANT_MACROS);
	}
    }
    if(! &__GNUC_PREREQ__(2, 95)) {
	if((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) < 199901) {
	    eval 'sub __restrict () {1;}' unless defined(&__restrict);
	} else {
	    eval 'sub __restrict () { &restrict;}' unless defined(&__restrict);
	}
    }
    if( &__GNUC_PREREQ__(3, 1)  && !defined(&__GNUG__)) {
	eval 'sub __restrict_arr () { &__restrict;}' unless defined(&__restrict_arr);
    } else {
	if(defined(&__GNUC__)) {
	    eval 'sub __restrict_arr () {1;}' unless defined(&__restrict_arr);
	} else {
	    if(defined(&__STDC_VERSION__)  && (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 199901) {
		eval 'sub __restrict_arr () { &restrict;}' unless defined(&__restrict_arr);
	    } else {
		eval 'sub __restrict_arr () {1;}' unless defined(&__restrict_arr);
	    }
	}
    }
    if( &__GNUC_PREREQ__(2, 96)) {
	eval 'sub __predict_true {
	    my($exp) = @_;
    	    eval q( &__builtin_expect(($exp), 1));
	}' unless defined(&__predict_true);
	eval 'sub __predict_false {
	    my($exp) = @_;
    	    eval q( &__builtin_expect(($exp), 0));
	}' unless defined(&__predict_false);
    } else {
	eval 'sub __predict_true {
	    my($exp) = @_;
    	    eval q(($exp));
	}' unless defined(&__predict_true);
	eval 'sub __predict_false {
	    my($exp) = @_;
    	    eval q(($exp));
	}' unless defined(&__predict_false);
    }
    if( &__GNUC_PREREQ__(4, 1)) {
	eval 'sub __offsetof {
	    my($type, $field) = @_;
    	    eval q( &__builtin_offsetof($type, $field));
	}' unless defined(&__offsetof);
    } else {
	unless(defined(&__cplusplus)) {
	    eval 'sub __offsetof {
	        my($type, $field) = @_;
    		eval q((( &__size_t)( &__uintptr_t)(( &const  &volatile  &void *)(($type *)0)->$field)));
	    }' unless defined(&__offsetof);
	} else {
	    eval 'sub __offsetof {
	        my($type, $field) = @_;
    		eval q(( &__offsetof__ ( &reinterpret_cast < &__size_t> ( &reinterpret_cast < &const  &volatile \'char\' &> ( &static_cast<$type *> (0)->$field)))));
	    }' unless defined(&__offsetof);
	}
    }
    if(! &__GNUC_PREREQ__(2, 7)) {
	eval 'sub __printflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__printflike);
	eval 'sub __scanflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__scanflike);
	eval 'sub __printf0like {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__printf0like);
	eval 'sub __format_arg {
	    my($fmtarg) = @_;
    	    eval q();
	}' unless defined(&__format_arg);
	eval 'sub __strfmonlike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__strfmonlike);
	eval 'sub __strftimelike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__strftimelike);
    }
 elsif( &__GNUC_PREREQ__(3, 0)) {
	eval 'sub __printflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__nonnull__($fmtarg),  &__format__ ( &__printf__, $fmtarg, $firstvararg))));
	}' unless defined(&__printflike);
	eval 'sub __printf0like {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf__, $fmtarg, $firstvararg))));
	}' unless defined(&__printf0like);
	eval 'sub __scanflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__scanf__, $fmtarg, $firstvararg))));
	}' unless defined(&__scanflike);
	eval 'sub __format_arg {
	    my($fmtarg) = @_;
    	    eval q( &__attribute__(( &__format_arg__ ($fmtarg))));
	}' unless defined(&__format_arg);
	eval 'sub __strfmonlike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__strfmon__, $fmtarg, $firstvararg))));
	}' unless defined(&__strfmonlike);
	eval 'sub __strftimelike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__strftime__, $fmtarg, $firstvararg))));
	}' unless defined(&__strftimelike);
    } else {
	eval 'sub __printflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf__, $fmtarg, $firstvararg))));
	}' unless defined(&__printflike);
	eval 'sub __printf0like {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf0__, $fmtarg, $firstvararg))));
	}' unless defined(&__printf0like);
	eval 'sub __scanflike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__scanf__, $fmtarg, $firstvararg))));
	}' unless defined(&__scanflike);
	eval 'sub __format_arg {
	    my($fmtarg) = @_;
    	    eval q( &__attribute__(( &__format_arg__ ($fmtarg))));
	}' unless defined(&__format_arg);
	eval 'sub __strfmonlike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__strfmon__, $fmtarg, $firstvararg))));
	}' unless defined(&__strfmonlike);
	eval 'sub __strftimelike {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__strftime__, $fmtarg, $firstvararg))));
	}' unless defined(&__strftimelike);
    }
    if(! &__GNUC_PREREQ__(3, 0)) {
	eval 'sub __ARRAY_ZERO () {0;}' unless defined(&__ARRAY_ZERO);
    } else {
	eval 'sub __ARRAY_ZERO () {1;}' unless defined(&__ARRAY_ZERO);
    }
    if( &__GNUC_PREREQ__(4, 3)) {
	eval 'sub __constructor {
	    my($prio) = @_;
    	    eval q( &__attribute__(( &constructor($prio))));
	}' unless defined(&__constructor);
    } else {
	eval 'sub __constructor {
	    my($prio) = @_;
    	    eval q( &__attribute__(( &constructor)));
	}' unless defined(&__constructor);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __cachealign () { &__attribute__(( &__aligned__( &__VM_CACHELINE_SIZE)));}' unless defined(&__cachealign);
	eval 'sub __usereg () { &__attribute__(( &__regparm__(3)));}' unless defined(&__usereg);
    } else {
	eval 'sub __cachealign () {1;}' unless defined(&__cachealign);
	eval 'sub __usereg () {1;}' unless defined(&__usereg);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __strong_reference {
	    my($sym,$aliassym) = @_;
    	    eval q( &extern  &__typeof ($sym) $aliassym  &__attribute__ (( &__alias__ ($sym))));
	}' unless defined(&__strong_reference);
	eval 'sub __weak_reference {
	    my($sym,$aliassym) = @_;
    	    eval q( &__strong_reference($sym,$aliassym)  &__attribute__ (( &__weak__)));
	}' unless defined(&__weak_reference);
	eval 'sub __weak_reference_asm {
	    my($sym,$alias) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__weak_reference_asm);
	eval 'sub __warn_references {
	    my($sym,$msg) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__warn_references);
	eval 'sub __sym_compat {
	    my($sym,$impl,$verid) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__sym_compat);
	eval 'sub __sym_default {
	    my($sym,$impl,$verid) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__sym_default);
    }
    if(defined(&__GNUC__)) {
	eval 'sub __IDSTRING {
	    my($name,$string) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__IDSTRING);
    }
    unless(defined(&__RCSID)) {
	eval 'sub __RCSID {
	    my($s) = @_;
    	    eval q(\'struct __hack\');
	}' unless defined(&__RCSID);
    }
    unless(defined(&__RCSID_SOURCE)) {
	eval 'sub __RCSID_SOURCE {
	    my($s) = @_;
    	    eval q(\'struct __hack\');
	}' unless defined(&__RCSID_SOURCE);
    }
    unless(defined(&__SCCSID)) {
	eval 'sub __SCCSID {
	    my($s) = @_;
    	    eval q(\'struct __hack\');
	}' unless defined(&__SCCSID);
    }
    unless(defined(&__FBSDID)) {
	eval 'sub __FBSDID {
	    my($s) = @_;
    	    eval q(\'struct __hack\');
	}' unless defined(&__FBSDID);
    }
    unless(defined(&__COPYRIGHT)) {
	eval 'sub __COPYRIGHT {
	    my($s) = @_;
    	    eval q(\'struct __hack\');
	}' unless defined(&__COPYRIGHT);
    }
    unless(defined(&__DECONST)) {
	eval 'sub __DECONST {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &const  &void *)($var)));
	}' unless defined(&__DECONST);
    }
    unless(defined(&__DEVOLATILE)) {
	eval 'sub __DEVOLATILE {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &volatile  &void *)($var)));
	}' unless defined(&__DEVOLATILE);
    }
    unless(defined(&__DEQUALIFY)) {
	eval 'sub __DEQUALIFY {
	    my($type, $var) = @_;
    	    eval q((($type)( &__uintptr_t)( &const  &volatile  &void *)($var)));
	}' unless defined(&__DEQUALIFY);
    }
    if(! &__GNUC_PREREQ__(2, 95)) {
	eval 'sub __alignof {
	    my($x) = @_;
    	    eval q( &__offsetof(\'struct struct\' { \'char\'  &__a; $x  &__b; },  &__b));
	}' unless defined(&__alignof);
    }
    if(!defined(&__STDC_VERSION__) || (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) < 201112) {
	if(! &__has_extension((defined(&c_alignas) ? &c_alignas : undef))) {
	    if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) ||  &__has_extension((defined(&cxx_alignas) ? &cxx_alignas : undef))) {
		eval 'sub _Alignas {
		    my($x) = @_;
    		    eval q( &alignas($x));
		}' unless defined(&_Alignas);
	    } else {
		eval 'sub _Alignas {
		    my($x) = @_;
    		    eval q( &__aligned($x));
		}' unless defined(&_Alignas);
	    }
	}
	if(defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) {
	    eval 'sub _Alignof {
	        my($x) = @_;
    		eval q( &alignof($x));
	    }' unless defined(&_Alignof);
	} else {
	    eval 'sub _Alignof {
	        my($x) = @_;
    		eval q( &__alignof($x));
	    }' unless defined(&_Alignof);
	}
	if(!defined(&_Noreturn)) {
	    eval 'sub _Noreturn () { &__dead2;}' unless defined(&_Noreturn);
	}
	if(! &__has_extension((defined(&c_static_assert) ? &c_static_assert : undef))) {
	    if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103) ||  &__has_extension((defined(&cxx_static_assert) ? &cxx_static_assert : undef))) {
		eval 'sub _Static_assert {
		    my($x, $y) = @_;
    		    eval q( &static_assert($x, $y));
		}' unless defined(&_Static_assert);
	    }
 elsif(! &__GNUC_PREREQ__(4, 6)) {
		eval 'sub _Static_assert {
		    my($x, $y) = @_;
    		    eval q(\'struct __hack\');
		}' unless defined(&_Static_assert);
		if(defined(&_KERNEL)) {
		    eval 'sub CTASSERT {
		        my($x) = @_;
    			eval q( &_CTASSERT($x,  &__LINE__));
		    }' unless defined(&CTASSERT);
		    eval 'sub _CTASSERT {
		        my($x, $y) = @_;
    			eval q( &__CTASSERT($x, $y));
		    }' unless defined(&_CTASSERT);
		    eval 'sub __CTASSERT {
		        my($x, $y) = @_;
    			eval q( &typedef \'char\'  &__assert  $y->[($x) ? 1: -1]);
		    }' unless defined(&__CTASSERT);
		}
	    }
	    if(! &__has_extension((defined(&c_thread_local) ? &c_thread_local : undef))) {
		if((defined(&__cplusplus)  && (defined(&__cplusplus) ? &__cplusplus : undef) >= 201103  &&  &__GNUC_PREREQ__(4, 8)) ||  &__has_extension((defined(&cxx_thread_local) ? &cxx_thread_local : undef))) {
		    eval 'sub _Thread_local () { &thread_local;}' unless defined(&_Thread_local);
		} else {
		    eval 'sub _Thread_local () { &__thread;}' unless defined(&_Thread_local);
		}
	    }
	}
    }
    if(defined(&_KERNEL)  && !defined(&CTASSERT)) {
	eval 'sub CTASSERT {
	    my($x) = @_;
    	    eval q( &_Static_assert($x, \\"compile-time assertion failed\\"));
	}' unless defined(&CTASSERT);
    }
    if(defined(&__STDC_VERSION__)  && (defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) >= 201112) {
	eval 'sub __generic {
	    my($expr, $t, $yes, $no) = @_;
    	    eval q( &_Generic($expr, $t: $yes,  &default: $no));
	}' unless defined(&__generic);
    }
 elsif( &__GNUC_PREREQ__(3, 1)  && !defined(&__cplusplus)) {
	eval 'sub __generic {
	    my($expr, $t, $yes, $no) = @_;
    	    eval q( &__builtin_choose_expr(  &__builtin_types_compatible_p( &__typeof($expr), $t), $yes, $no));
	}' unless defined(&__generic);
    }
    if(defined(&_POSIX_C_SOURCE)  && ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) == 1) {
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {199009;}' unless defined(&_POSIX_C_SOURCE);
    }
    if(defined(&_POSIX_C_SOURCE)  && ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) == 2) {
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {199209;}' unless defined(&_POSIX_C_SOURCE);
    }
    if(defined(&_XOPEN_SOURCE)) {
	if((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0>= 700) {
	    eval 'sub __XSI_VISIBLE () {700;}' unless defined(&__XSI_VISIBLE);
	    undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	    eval 'sub _POSIX_C_SOURCE () {200809;}' unless defined(&_POSIX_C_SOURCE);
	}
 elsif((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0>= 600) {
	    eval 'sub __XSI_VISIBLE () {600;}' unless defined(&__XSI_VISIBLE);
	    undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	    eval 'sub _POSIX_C_SOURCE () {200112;}' unless defined(&_POSIX_C_SOURCE);
	}
 elsif((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0>= 500) {
	    eval 'sub __XSI_VISIBLE () {500;}' unless defined(&__XSI_VISIBLE);
	    undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	    eval 'sub _POSIX_C_SOURCE () {199506;}' unless defined(&_POSIX_C_SOURCE);
	}
    }
    if(defined(&_POSIX_SOURCE)  && !defined(&_POSIX_C_SOURCE)) {
	eval 'sub _POSIX_C_SOURCE () {198808;}' unless defined(&_POSIX_C_SOURCE);
    }
    if(defined(&_POSIX_C_SOURCE)) {
	if(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 200809) {
	    eval 'sub __POSIX_VISIBLE () {200809;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1999;}' unless defined(&__ISO_C_VISIBLE);
	}
 elsif(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 200112) {
	    eval 'sub __POSIX_VISIBLE () {200112;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1999;}' unless defined(&__ISO_C_VISIBLE);
	}
 elsif(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 199506) {
	    eval 'sub __POSIX_VISIBLE () {199506;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1990;}' unless defined(&__ISO_C_VISIBLE);
	}
 elsif(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 199309) {
	    eval 'sub __POSIX_VISIBLE () {199309;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1990;}' unless defined(&__ISO_C_VISIBLE);
	}
 elsif(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 199209) {
	    eval 'sub __POSIX_VISIBLE () {199209;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1990;}' unless defined(&__ISO_C_VISIBLE);
	}
 elsif(((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 199009) {
	    eval 'sub __POSIX_VISIBLE () {199009;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1990;}' unless defined(&__ISO_C_VISIBLE);
	} else {
	    eval 'sub __POSIX_VISIBLE () {198808;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {0;}' unless defined(&__ISO_C_VISIBLE);
	}
    } else {
	if(defined(&_ANSI_SOURCE) ) {
	    eval 'sub __POSIX_VISIBLE () {0;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __XSI_VISIBLE () {0;}' unless defined(&__XSI_VISIBLE);
	    eval 'sub __BSD_VISIBLE () {0;}' unless defined(&__BSD_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1990;}' unless defined(&__ISO_C_VISIBLE);
	    eval 'sub __EXT1_VISIBLE () {0;}' unless defined(&__EXT1_VISIBLE);
	}
 elsif(defined(&_C99_SOURCE) ) {
	    eval 'sub __POSIX_VISIBLE () {0;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __XSI_VISIBLE () {0;}' unless defined(&__XSI_VISIBLE);
	    eval 'sub __BSD_VISIBLE () {0;}' unless defined(&__BSD_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {1999;}' unless defined(&__ISO_C_VISIBLE);
	    eval 'sub __EXT1_VISIBLE () {0;}' unless defined(&__EXT1_VISIBLE);
	}
 elsif(defined(&_C11_SOURCE) ) {
	    eval 'sub __POSIX_VISIBLE () {0;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __XSI_VISIBLE () {0;}' unless defined(&__XSI_VISIBLE);
	    eval 'sub __BSD_VISIBLE () {0;}' unless defined(&__BSD_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {2011;}' unless defined(&__ISO_C_VISIBLE);
	    eval 'sub __EXT1_VISIBLE () {0;}' unless defined(&__EXT1_VISIBLE);
	} else {
	    eval 'sub __POSIX_VISIBLE () {200809;}' unless defined(&__POSIX_VISIBLE);
	    eval 'sub __XSI_VISIBLE () {700;}' unless defined(&__XSI_VISIBLE);
	    eval 'sub __BSD_VISIBLE () {1;}' unless defined(&__BSD_VISIBLE);
	    eval 'sub __ISO_C_VISIBLE () {2011;}' unless defined(&__ISO_C_VISIBLE);
	    eval 'sub __EXT1_VISIBLE () {1;}' unless defined(&__EXT1_VISIBLE);
	}
    }
    if(defined(&__STDC_WANT_LIB_EXT1__)) {
	undef(&__EXT1_VISIBLE) if defined(&__EXT1_VISIBLE);
	if((defined(&__STDC_WANT_LIB_EXT1__) ? &__STDC_WANT_LIB_EXT1__ : undef)) {
	    eval 'sub __EXT1_VISIBLE () {1;}' unless defined(&__EXT1_VISIBLE);
	} else {
	    eval 'sub __EXT1_VISIBLE () {0;}' unless defined(&__EXT1_VISIBLE);
	}
    }
    unless(defined(&__BSD_VISIBLE)) {
	eval 'sub __BSD_VISIBLE () {0;}' unless defined(&__BSD_VISIBLE);
    }
    unless(defined(&__EXT1_VISIBLE)) {
	eval 'sub __EXT1_VISIBLE () {0;}' unless defined(&__EXT1_VISIBLE);
    }
    eval 'sub __GLOBL1 {
        my($sym) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__GLOBL1);
    eval 'sub __GLOBL {
        my($sym) = @_;
	    eval q( &__GLOBL1($sym));
    }' unless defined(&__GLOBL);
}
1;
