require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DISKSLICE_H_)) {
    eval 'sub _SYS_DISKSLICE_H_ () {1;}' unless defined(&_SYS_DISKSLICE_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_SYS_DISKLABEL_H_)) {
	require 'sys/disklabel.ph';
    }
    unless(defined(&_SYS_UUID_H_)) {
	require 'sys/uuid.ph';
    }
    unless(defined(&_SYS_IOCCOM_H_)) {
	require 'sys/ioccom.ph';
    }
    if(defined(&_KERNEL)) {
	unless(defined(&_SYS_CONF_H_)) {
	    require 'sys/conf.ph';
	}
	unless(defined(&_SYS_SYSTM_H_)) {
	    require 'sys/systm.ph';
	}
    }
    eval 'sub BASE_SLICE () {2;}' unless defined(&BASE_SLICE);
    eval 'sub COMPATIBILITY_SLICE () {0;}' unless defined(&COMPATIBILITY_SLICE);
    eval 'sub DIOCWLABEL () { &_IOW(ord(\'d\'), 109, \'int\');}' unless defined(&DIOCWLABEL);
    eval 'sub DIOCGSLICEINFO () { &_IOR(ord(\'d\'), 111, \'struct diskslices\');}' unless defined(&DIOCGSLICEINFO);
    eval 'sub DIOCSYNCSLICEINFO () { &_IOW(ord(\'d\'), 112, \'int\');}' unless defined(&DIOCSYNCSLICEINFO);
    eval 'sub DIOCGKERNELDUMP () { &_IOW(ord(\'d\'), 133, \'u_int\');}' unless defined(&DIOCGKERNELDUMP);
    eval 'sub DIOCRECLUSTER () { &_IOWR(ord(\'d\'), 134, \'struct disk_ioc_recluster\');}' unless defined(&DIOCRECLUSTER);
    eval 'sub MAX_SLICES () {16;}' unless defined(&MAX_SLICES);
    eval 'sub DKMAXUNITS () {512;}' unless defined(&DKMAXUNITS);
    eval 'sub DKMAXSLICES () {128;}' unless defined(&DKMAXSLICES);
    eval 'sub DKRESPARTITIONS () {128;}' unless defined(&DKRESPARTITIONS);
    eval 'sub DKMAXPARTITIONS () {256;}' unless defined(&DKMAXPARTITIONS);
    eval 'sub WHOLE_DISK_SLICE () {1;}' unless defined(&WHOLE_DISK_SLICE);
    eval 'sub WHOLE_SLICE_PART () {( &DKMAXPARTITIONS - 1);}' unless defined(&WHOLE_SLICE_PART);
    if(defined(&MAXPARTITIONS)) {
	if((defined(&MAXPARTITIONS) ? &MAXPARTITIONS : undef) != 16) {
	    die("inconsistent MAXPARTITIONS");
	}
    } else {
	eval 'sub MAXPARTITIONS () {16;}' unless defined(&MAXPARTITIONS);
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
    } else {
    }
    eval 'sub DSF_REPROBE () {0x1;}' unless defined(&DSF_REPROBE);
    eval 'sub DIOCGPART () { &_IOR(ord(\'d\'), 104, \'struct partinfo\');}' unless defined(&DIOCGPART);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub dkmakeslice {
	    my($slice) = @_;
    	    eval q({ ( &dkmakeminor(0, ( &u_int32_t)$slice, 0)); });
	}' unless defined(&dkmakeslice);
	eval 'sub dkmakepart {
	    my($part) = @_;
    	    eval q({ ( &dkmakeminor(0, 0, ( &u_int32_t)$part)); });
	}' unless defined(&dkmakepart);
    }
    if(defined(&_KERNEL)) {
	eval 'sub dkunit {
	    my($dev) = @_;
    	    eval q({  &u_int32_t  &val =  &minor;  &val = (( &val >> 3) & 0x1f) | (( &val >> 16) & 0x1e0); ( &val); });
	}' unless defined(&dkunit);
	eval 'sub dkslice {
	    my($dev) = @_;
    	    eval q({  &u_int32_t  &val =  &minor($dev);  &val = (( &val >> 16) & 0xf) | (( &val >> 25) & 0x70); ( &val); });
	}' unless defined(&dkslice);
	eval 'sub dkpart {
	    my($dev) = @_;
    	    eval q({  &u_int32_t  &val =  &minor($dev);  &val = ( &val & 0x7) | (( &val >> 17) & 0x8) | (( &val >> 21) & 0xf0); ( &val); });
	}' unless defined(&dkpart);
    }
    if(defined(&_KERNEL)) {
    }
}
1;
