require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DMSG_H_)) {
    eval 'sub _SYS_DMSG_H_ () {1;}' unless defined(&_SYS_DMSG_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_TREE_H_)) {
	    require 'sys/tree.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
    }
    unless(defined(&_SYS_UUID_H_)) {
	require 'sys/uuid.ph';
    }
    eval 'sub DMSG_TERMINATE_STRING {
        my($ary) = @_;
	    eval q( &do { ($ary)[$sizeof{$ary} - 1] = 0; }  &while (0));
    }' unless defined(&DMSG_TERMINATE_STRING);
    eval 'sub DMSG_HDR_MAGIC () {0x4832;}' unless defined(&DMSG_HDR_MAGIC);
    eval 'sub DMSG_HDR_MAGIC_REV () {0x3248;}' unless defined(&DMSG_HDR_MAGIC_REV);
    eval 'sub DMSG_HDR_CRCOFF () { &offsetof( &dmsg_hdr_t,  &salt);}' unless defined(&DMSG_HDR_CRCOFF);
    eval 'sub DMSG_HDR_CRCBYTES () {($sizeof{ &dmsg_hdr_t} -  &DMSG_HDR_CRCOFF);}' unless defined(&DMSG_HDR_CRCBYTES);
    eval 'sub DMSG_HDR_MAX () {2048;}' unless defined(&DMSG_HDR_MAX);
    eval 'sub DMSG_AUX_MAX () {(1024*1024);}' unless defined(&DMSG_AUX_MAX);
    eval 'sub DMSG_BUF_SIZE () {( &DMSG_HDR_MAX * 4);}' unless defined(&DMSG_BUF_SIZE);
    eval 'sub DMSG_BUF_MASK () {( &DMSG_BUF_SIZE - 1);}' unless defined(&DMSG_BUF_MASK);
    eval 'sub DMSGF_CREATE () {0x80000000;}' unless defined(&DMSGF_CREATE);
    eval 'sub DMSGF_DELETE () {0x40000000;}' unless defined(&DMSGF_DELETE);
    eval 'sub DMSGF_REPLY () {0x20000000;}' unless defined(&DMSGF_REPLY);
    eval 'sub DMSGF_ABORT () {0x10000000;}' unless defined(&DMSGF_ABORT);
    eval 'sub DMSGF_REVTRANS () {0x8000000;}' unless defined(&DMSGF_REVTRANS);
    eval 'sub DMSGF_REVCIRC () {0x4000000;}' unless defined(&DMSGF_REVCIRC);
    eval 'sub DMSGF_FLAG1 () {0x2000000;}' unless defined(&DMSGF_FLAG1);
    eval 'sub DMSGF_FLAG0 () {0x1000000;}' unless defined(&DMSGF_FLAG0);
    eval 'sub DMSGF_FLAGS () {0xff000000;}' unless defined(&DMSGF_FLAGS);
    eval 'sub DMSGF_PROTOS () {0xf00000;}' unless defined(&DMSGF_PROTOS);
    eval 'sub DMSGF_CMDS () {0xfff00;}' unless defined(&DMSGF_CMDS);
    eval 'sub DMSGF_SIZE () {0xff;}' unless defined(&DMSGF_SIZE);
    eval 'sub DMSGF_CMDF_EXPECT_ACK () {0x80000;}' unless defined(&DMSGF_CMDF_EXPECT_ACK);
    eval 'sub DMSGF_CMDSWMASK () {( &DMSGF_CMDS |  &DMSGF_SIZE |  &DMSGF_PROTOS |  &DMSGF_REPLY);}' unless defined(&DMSGF_CMDSWMASK);
    eval 'sub DMSGF_BASECMDMASK () {( &DMSGF_CMDS |  &DMSGF_SIZE |  &DMSGF_PROTOS);}' unless defined(&DMSGF_BASECMDMASK);
    eval 'sub DMSGF_TRANSMASK () {( &DMSGF_CMDS |  &DMSGF_SIZE |  &DMSGF_PROTOS |  &DMSGF_REPLY |  &DMSGF_CREATE |  &DMSGF_DELETE);}' unless defined(&DMSGF_TRANSMASK);
    eval 'sub DMSGF_BASEFLAGS () {( &DMSGF_CREATE |  &DMSGF_DELETE |  &DMSGF_REPLY);}' unless defined(&DMSGF_BASEFLAGS);
    eval 'sub DMSG_PROTO_LNK () {0x;}' unless defined(&DMSG_PROTO_LNK);
    eval 'sub DMSG_PROTO_DBG () {0x100000;}' unless defined(&DMSG_PROTO_DBG);
    eval 'sub DMSG_PROTO_HM2 () {0x200000;}' unless defined(&DMSG_PROTO_HM2);
    eval 'sub DMSG_PROTO_XX3 () {0x300000;}' unless defined(&DMSG_PROTO_XX3);
    eval 'sub DMSG_PROTO_XX4 () {0x400000;}' unless defined(&DMSG_PROTO_XX4);
    eval 'sub DMSG_PROTO_BLK () {0x500000;}' unless defined(&DMSG_PROTO_BLK);
    eval 'sub DMSG_PROTO_VOP () {0x600000;}' unless defined(&DMSG_PROTO_VOP);
    eval 'sub DMSG_ALIGN () {64;}' unless defined(&DMSG_ALIGN);
    eval 'sub DMSG_ALIGNMASK () {( &DMSG_ALIGN - 1);}' unless defined(&DMSG_ALIGNMASK);
    eval 'sub DMSG_DOALIGN {
        my($bytes) = @_;
	    eval q(((($bytes) +  &DMSG_ALIGNMASK) & ~ &DMSG_ALIGNMASK));
    }' unless defined(&DMSG_DOALIGN);
    eval 'sub DMSG_HDR_ENCODE {
        my($elm) = @_;
	    eval q(((( &uint32_t)$sizeof{\'struct elm\'} +  &DMSG_ALIGNMASK) /  &DMSG_ALIGN));
    }' unless defined(&DMSG_HDR_ENCODE);
    eval 'sub DMSG_LNK {
        my($cmd, $elm) = @_;
	    eval q(( &DMSG_PROTO_LNK | (($cmd) << 8) |  &DMSG_HDR_ENCODE($elm)));
    }' unless defined(&DMSG_LNK);
    eval 'sub DMSG_DBG {
        my($cmd, $elm) = @_;
	    eval q(( &DMSG_PROTO_DBG | (($cmd) << 8) |  &DMSG_HDR_ENCODE($elm)));
    }' unless defined(&DMSG_DBG);
    eval 'sub DMSG_HM2 {
        my($cmd, $elm) = @_;
	    eval q(( &DMSG_PROTO_HM2 | (($cmd) << 8) |  &DMSG_HDR_ENCODE($elm)));
    }' unless defined(&DMSG_HM2);
    eval 'sub DMSG_BLK {
        my($cmd, $elm) = @_;
	    eval q(( &DMSG_PROTO_BLK | (($cmd) << 8) |  &DMSG_HDR_ENCODE($elm)));
    }' unless defined(&DMSG_BLK);
    eval 'sub DMSG_VOP {
        my($cmd, $elm) = @_;
	    eval q(( &DMSG_PROTO_VOP | (($cmd) << 8) |  &DMSG_HDR_ENCODE($elm)));
    }' unless defined(&DMSG_VOP);
    eval 'sub DMSG_LNK_PAD () { &DMSG_LNK(0x,  &dmsg_hdr);}' unless defined(&DMSG_LNK_PAD);
    eval 'sub DMSG_LNK_PING () { &DMSG_LNK(0x1,  &dmsg_hdr);}' unless defined(&DMSG_LNK_PING);
    eval 'sub DMSG_LNK_AUTH () { &DMSG_LNK(0x10,  &dmsg_lnk_auth);}' unless defined(&DMSG_LNK_AUTH);
    eval 'sub DMSG_LNK_CONN () { &DMSG_LNK(0x11,  &dmsg_lnk_conn);}' unless defined(&DMSG_LNK_CONN);
    eval 'sub DMSG_LNK_SPAN () { &DMSG_LNK(0x12,  &dmsg_lnk_span);}' unless defined(&DMSG_LNK_SPAN);
    eval 'sub DMSG_LNK_ERROR () { &DMSG_LNK(0xfff,  &dmsg_hdr);}' unless defined(&DMSG_LNK_ERROR);
    eval 'sub DMSG_LNK_CMD_HAMMER2_VOLCONF () {0x20;}' unless defined(&DMSG_LNK_CMD_HAMMER2_VOLCONF);
    eval 'sub DMSG_LABEL_SIZE () {128;}' unless defined(&DMSG_LABEL_SIZE);
    eval 'sub DMSG_PEER_NONE () {0;}' unless defined(&DMSG_PEER_NONE);
    eval 'sub DMSG_PEER_ROUTER () {1;}' unless defined(&DMSG_PEER_ROUTER);
    eval 'sub DMSG_PEER_BLOCK () {2;}' unless defined(&DMSG_PEER_BLOCK);
    eval 'sub DMSG_PEER_HAMMER2 () {3;}' unless defined(&DMSG_PEER_HAMMER2);
    eval 'sub DMSG_PEER_CLIENT () {63;}' unless defined(&DMSG_PEER_CLIENT);
    eval 'sub DMSG_PEER_MAX () {64;}' unless defined(&DMSG_PEER_MAX);
    eval 'sub DMSG_PFSTYPE_DEFAULT () {0;}' unless defined(&DMSG_PFSTYPE_DEFAULT);
    eval 'sub DMSG_PFSTYPE_MASK () {0xf;}' unless defined(&DMSG_PFSTYPE_MASK);
    eval 'sub DMSG_SPAN_PROTO_1 () {1;}' unless defined(&DMSG_SPAN_PROTO_1);
    eval 'sub DMSG_DBG_SHELL () { &DMSG_DBG(0x1,  &dmsg_dbg_shell);}' unless defined(&DMSG_DBG_SHELL);
    eval 'sub DMSG_HM2_OPENPFS () { &DMSG_HM2(0x1,  &dmsg_hm2_openpfs);}' unless defined(&DMSG_HM2_OPENPFS);
    eval 'sub DMSG_BLK_OPEN () { &DMSG_BLK(0x1,  &dmsg_blk_open);}' unless defined(&DMSG_BLK_OPEN);
    eval 'sub DMSG_BLK_CLOSE () { &DMSG_BLK(0x2,  &dmsg_blk_open);}' unless defined(&DMSG_BLK_CLOSE);
    eval 'sub DMSG_BLK_READ () { &DMSG_BLK(0x3,  &dmsg_blk_read);}' unless defined(&DMSG_BLK_READ);
    eval 'sub DMSG_BLK_WRITE () { &DMSG_BLK(0x4,  &dmsg_blk_write);}' unless defined(&DMSG_BLK_WRITE);
    eval 'sub DMSG_BLK_FLUSH () { &DMSG_BLK(0x5,  &dmsg_blk_flush);}' unless defined(&DMSG_BLK_FLUSH);
    eval 'sub DMSG_BLK_FREEBLKS () { &DMSG_BLK(0x6,  &dmsg_blk_freeblks);}' unless defined(&DMSG_BLK_FREEBLKS);
    eval 'sub DMSG_BLK_ERROR () { &DMSG_BLK(0xfff,  &dmsg_blk_error);}' unless defined(&DMSG_BLK_ERROR);
    eval 'sub DMSG_BLKOPEN_RD () {0x1;}' unless defined(&DMSG_BLKOPEN_RD);
    eval 'sub DMSG_BLKOPEN_WR () {0x2;}' unless defined(&DMSG_BLKOPEN_WR);
    eval 'sub DMSG_ERR_NOSUPP () {0x20;}' unless defined(&DMSG_ERR_NOSUPP);
    eval 'sub DMSG_ERR_LOSTLINK () {0x21;}' unless defined(&DMSG_ERR_LOSTLINK);
    eval 'sub DMSG_ERR_IO () {0x22;}' unless defined(&DMSG_ERR_IO);
    eval 'sub DMSG_ERR_PARAM () {0x23;}' unless defined(&DMSG_ERR_PARAM);
    eval 'sub DMSG_ERR_CANTCIRC () {0x24;}' unless defined(&DMSG_ERR_CANTCIRC);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub KDMSG_CLUSTERCTL_UNUSED01 () {0x1;}' unless defined(&KDMSG_CLUSTERCTL_UNUSED01);
	eval 'sub KDMSG_CLUSTERCTL_KILLRX () {0x2;}' unless defined(&KDMSG_CLUSTERCTL_KILLRX);
	eval 'sub KDMSG_CLUSTERCTL_KILLTX () {0x4;}' unless defined(&KDMSG_CLUSTERCTL_KILLTX);
	eval 'sub KDMSG_CLUSTERCTL_SLEEPING () {0x8;}' unless defined(&KDMSG_CLUSTERCTL_SLEEPING);
	eval 'sub KDMSG_STATE_SUBINSERTED () {0x1;}' unless defined(&KDMSG_STATE_SUBINSERTED);
	eval 'sub KDMSG_STATE_DYNAMIC () {0x2;}' unless defined(&KDMSG_STATE_DYNAMIC);
	eval 'sub KDMSG_STATE_UNUSED0004 () {0x4;}' unless defined(&KDMSG_STATE_UNUSED0004);
	eval 'sub KDMSG_STATE_ABORTING () {0x8;}' unless defined(&KDMSG_STATE_ABORTING);
	eval 'sub KDMSG_STATE_OPPOSITE () {0x10;}' unless defined(&KDMSG_STATE_OPPOSITE);
	eval 'sub KDMSG_STATE_DYING () {0x20;}' unless defined(&KDMSG_STATE_DYING);
	eval 'sub KDMSG_STATE_INTERLOCK () {0x40;}' unless defined(&KDMSG_STATE_INTERLOCK);
	eval 'sub KDMSG_STATE_RBINSERTED () {0x80;}' unless defined(&KDMSG_STATE_RBINSERTED);
	eval 'sub KDMSG_STATE_SIGNAL () {0x400;}' unless defined(&KDMSG_STATE_SIGNAL);
	eval 'sub KDMSG_STATE_NEW () {0x800;}' unless defined(&KDMSG_STATE_NEW);
	eval 'sub KDMSG_FLAG_AUXALLOC () {0x1;}' unless defined(&KDMSG_FLAG_AUXALLOC);
	eval 'sub KDMSG_IOCOMF_AUTOCONN () {0x1;}' unless defined(&KDMSG_IOCOMF_AUTOCONN);
	eval 'sub KDMSG_IOCOMF_AUTORXSPAN () {0x2;}' unless defined(&KDMSG_IOCOMF_AUTORXSPAN);
	eval 'sub KDMSG_IOCOMF_AUTOTXSPAN () {0x8;}' unless defined(&KDMSG_IOCOMF_AUTOTXSPAN);
	eval 'sub KDMSG_IOCOMF_EXITNOACC () {0x8000;}' unless defined(&KDMSG_IOCOMF_EXITNOACC);
	eval 'sub KDMSG_IOCOMF_AUTOANY () {( &KDMSG_IOCOMF_AUTOCONN |  &KDMSG_IOCOMF_AUTORXSPAN |  &KDMSG_IOCOMF_AUTOTXSPAN);}' unless defined(&KDMSG_IOCOMF_AUTOANY);
    }
    if(defined(&_KERNEL)) {
    }
}
1;
