require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_KERNEL_H_)) {
    eval 'sub _SYS_KERNEL_H_ () {1;}' unless defined(&_SYS_KERNEL_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included by userland programs.");
    }
    unless(defined(&_SYS_PARAM_H_)) {
	require 'sys/param.ph';
    }
    unless(defined(&_SYS_LINKER_SET_H_)) {
	require 'sys/linker_set.ph';
    }
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    eval("sub VMM_GUEST_NONE () { 0; }") unless defined(&VMM_GUEST_NONE);
    eval("sub VMM_GUEST_QEMU () { 1; }") unless defined(&VMM_GUEST_QEMU);
    eval("sub VMM_GUEST_PLEX86 () { 2; }") unless defined(&VMM_GUEST_PLEX86);
    eval("sub VMM_GUEST_BOCHS () { 3; }") unless defined(&VMM_GUEST_BOCHS);
    eval("sub VMM_GUEST_XEN () { 4; }") unless defined(&VMM_GUEST_XEN);
    eval("sub VMM_GUEST_BHYVE () { 5; }") unless defined(&VMM_GUEST_BHYVE);
    eval("sub VMM_GUEST_KVM () { 6; }") unless defined(&VMM_GUEST_KVM);
    eval("sub VMM_GUEST_VMWARE () { 7; }") unless defined(&VMM_GUEST_VMWARE);
    eval("sub VMM_GUEST_HYPERV () { 8; }") unless defined(&VMM_GUEST_HYPERV);
    eval("sub VMM_GUEST_VBOX () { 9; }") unless defined(&VMM_GUEST_VBOX);
    eval("sub VMM_GUEST_PARALLELS () { 10; }") unless defined(&VMM_GUEST_PARALLELS);
    eval("sub VMM_GUEST_VKERNEL () { 11; }") unless defined(&VMM_GUEST_VKERNEL);
    eval("sub VMM_GUEST_UNKNOWN () { 12; }") unless defined(&VMM_GUEST_UNKNOWN);
    eval("sub VMM_GUEST_LAST () { 13; }") unless defined(&VMM_GUEST_LAST);
    eval("sub SI_SPECIAL_DUMMY () { 0x0000000; }") unless defined(&SI_SPECIAL_DUMMY);
    eval("sub SI_SPECIAL_DONE () { 0x0000001; }") unless defined(&SI_SPECIAL_DONE);
    eval("sub SI_BOOT1_TUNABLES () { 0x0700000; }") unless defined(&SI_BOOT1_TUNABLES);
    eval("sub SI_BOOT1_COPYRIGHT () { 0x0800000; }") unless defined(&SI_BOOT1_COPYRIGHT);
    eval("sub SI_BOOT1_LOCK () { 0x0900000; }") unless defined(&SI_BOOT1_LOCK);
    eval("sub SI_BOOT1_VM () { 0x1000000; }") unless defined(&SI_BOOT1_VM);
    eval("sub SI_BOOT1_ALLOCATOR () { 0x1400000; }") unless defined(&SI_BOOT1_ALLOCATOR);
    eval("sub SI_BOOT1_KMALLOC () { 0x1600000; }") unless defined(&SI_BOOT1_KMALLOC);
    eval("sub SI_BOOT1_DYNALLOC () { 0x1700000; }") unless defined(&SI_BOOT1_DYNALLOC);
    eval("sub SI_BOOT1_POST () { 0x1800000; }") unless defined(&SI_BOOT1_POST);
    eval("sub SI_BOOT2_LEAVE_CRIT () { 0x1900000; }") unless defined(&SI_BOOT2_LEAVE_CRIT);
    eval("sub SI_BOOT2_PRESMP () { 0x1a00000; }") unless defined(&SI_BOOT2_PRESMP);
    eval("sub SI_BOOT2_START_CPU () { 0x1a40000; }") unless defined(&SI_BOOT2_START_CPU);
    eval("sub SI_BOOT2_LAPIC () { 0x1a50000; }") unless defined(&SI_BOOT2_LAPIC);
    eval("sub SI_BOOT2_CPU_TOPOLOGY () { 0x1a58000; }") unless defined(&SI_BOOT2_CPU_TOPOLOGY);
    eval("sub SI_BOOT2_NUMA () { 0x1a5c000; }") unless defined(&SI_BOOT2_NUMA);
    eval("sub SI_BOOT2_START_APS () { 0x1a60000; }") unless defined(&SI_BOOT2_START_APS);
    eval("sub SI_BOOT2_IOAPIC () { 0x1a70000; }") unless defined(&SI_BOOT2_IOAPIC);
    eval("sub SI_BOOT2_FINISH_PIC () { 0x1a80000; }") unless defined(&SI_BOOT2_FINISH_PIC);
    eval("sub SI_BOOT2_FINISH_CPU () { 0x1a90000; }") unless defined(&SI_BOOT2_FINISH_CPU);
    eval("sub SI_BOOT2_CLOCKREG () { 0x1ac0000; }") unless defined(&SI_BOOT2_CLOCKREG);
    eval("sub SI_BOOT2_OBJCACHE () { 0x1b00000; }") unless defined(&SI_BOOT2_OBJCACHE);
    eval("sub SI_BOOT2_LWKT_INIT () { 0x1b40000; }") unless defined(&SI_BOOT2_LWKT_INIT);
    eval("sub SI_BOOT2_SOFTCLOCK () { 0x1b80000; }") unless defined(&SI_BOOT2_SOFTCLOCK);
    eval("sub SI_BOOT2_CLOCKS () { 0x1c00000; }") unless defined(&SI_BOOT2_CLOCKS);
    eval("sub SI_BOOT2_FINISH_SMP () { 0x1c80000; }") unless defined(&SI_BOOT2_FINISH_SMP);
    eval("sub SI_BOOT2_POST_SMP () { 0x1cc0000; }") unless defined(&SI_BOOT2_POST_SMP);
    eval("sub SI_BOOT2_MACHDEP () { 0x1d80000; }") unless defined(&SI_BOOT2_MACHDEP);
    eval("sub SI_BOOT2_KLD () { 0x1e00000; }") unless defined(&SI_BOOT2_KLD);
    eval("sub SI_BOOT2_VMM () { 0x1e40000; }") unless defined(&SI_BOOT2_VMM);
    eval("sub SI_BOOT2_USCHED () { 0x1e80000; }") unless defined(&SI_BOOT2_USCHED);
    eval("sub SI_BOOT2_PROC0 () { 0x1f00000; }") unless defined(&SI_BOOT2_PROC0);
    eval("sub SI_SUB_CREATE_INIT () { 0x2300000; }") unless defined(&SI_SUB_CREATE_INIT);
    eval("sub SI_SUB_PROP () { 0x2340000; }") unless defined(&SI_SUB_PROP);
    eval("sub SI_SUB_DEVFS_CORE () { 0x2380000; }") unless defined(&SI_SUB_DEVFS_CORE);
    eval("sub SI_SUB_PRE_DRIVERS () { 0x23C0000; }") unless defined(&SI_SUB_PRE_DRIVERS);
    eval("sub SI_SUB_DRIVERS () { 0x2400000; }") unless defined(&SI_SUB_DRIVERS);
    eval("sub SI_SUB_CONFIGURE () { 0x3800000; }") unless defined(&SI_SUB_CONFIGURE);
    eval("sub SI_SUB_ISWARM () { 0x3c00000; }") unless defined(&SI_SUB_ISWARM);
    eval("sub SI_SUB_VFS () { 0x4000000; }") unless defined(&SI_SUB_VFS);
    eval("sub SI_SUB_HELPER_THREADS () { 0x5400000; }") unless defined(&SI_SUB_HELPER_THREADS);
    eval("sub SI_SUB_SYSV_SHM () { 0x6400000; }") unless defined(&SI_SUB_SYSV_SHM);
    eval("sub SI_SUB_SYSV_SEM () { 0x6800000; }") unless defined(&SI_SUB_SYSV_SEM);
    eval("sub SI_SUB_SYSV_MSG () { 0x6C00000; }") unless defined(&SI_SUB_SYSV_MSG);
    eval("sub SI_SUB_P1003_1B () { 0x6E00000; }") unless defined(&SI_SUB_P1003_1B);
    eval("sub SI_SUB_PSEUDO () { 0x7000000; }") unless defined(&SI_SUB_PSEUDO);
    eval("sub SI_SUB_EXEC () { 0x7400000; }") unless defined(&SI_SUB_EXEC);
    eval("sub SI_SUB_PROTO_IF () { 0x8400000; }") unless defined(&SI_SUB_PROTO_IF);
    eval("sub SI_SUB_PROTO_DOMAIN () { 0x8800000; }") unless defined(&SI_SUB_PROTO_DOMAIN);
    eval("sub SI_SUB_PROTO_IFATTACHDOMAIN () { 0x8800001; }") unless defined(&SI_SUB_PROTO_IFATTACHDOMAIN);
    eval("sub SI_SUB_PROTO_END () { 0x8ffffff; }") unless defined(&SI_SUB_PROTO_END);
    eval("sub SI_SUB_KICK_SCHEDULER () { 0xa000000; }") unless defined(&SI_SUB_KICK_SCHEDULER);
    eval("sub SI_SUB_INT_CONFIG_HOOKS () { 0xa800000; }") unless defined(&SI_SUB_INT_CONFIG_HOOKS);
    eval("sub SI_SUB_ROOT_CONF () { 0xb000000; }") unless defined(&SI_SUB_ROOT_CONF);
    eval("sub SI_SUB_DUMP_CONF () { 0xb200000; }") unless defined(&SI_SUB_DUMP_CONF);
    eval("sub SI_SUB_RAID () { 0xb300000; }") unless defined(&SI_SUB_RAID);
    eval("sub SI_SUB_DM_TARGETS () { 0xb3a0000; }") unless defined(&SI_SUB_DM_TARGETS);
    eval("sub SI_SUB_MOUNT_ROOT () { 0xb400000; }") unless defined(&SI_SUB_MOUNT_ROOT);
    eval("sub SI_SUB_PROC0_POST () { 0xd000000; }") unless defined(&SI_SUB_PROC0_POST);
    eval("sub SI_SUB_KTHREAD_INIT () { 0xe000000; }") unless defined(&SI_SUB_KTHREAD_INIT);
    eval("sub SI_SUB_KTHREAD_PAGE () { 0xe400000; }") unless defined(&SI_SUB_KTHREAD_PAGE);
    eval("sub SI_SUB_KTHREAD_VM () { 0xe800000; }") unless defined(&SI_SUB_KTHREAD_VM);
    eval("sub SI_SUB_KTHREAD_BUF () { 0xea00000; }") unless defined(&SI_SUB_KTHREAD_BUF);
    eval("sub SI_SUB_KTHREAD_UPDATE () { 0xec00000; }") unless defined(&SI_SUB_KTHREAD_UPDATE);
    eval("sub SI_SUB_KTHREAD_IDLE () { 0xee00000; }") unless defined(&SI_SUB_KTHREAD_IDLE);
    eval("sub SI_SUB_RUN_SCHEDULER () { 0xfffffff; }") unless defined(&SI_SUB_RUN_SCHEDULER);
    eval("sub SI_ORDER_FIRST () { 0x0000000; }") unless defined(&SI_ORDER_FIRST);
    eval("sub SI_ORDER_SECOND () { 0x0000001; }") unless defined(&SI_ORDER_SECOND);
    eval("sub SI_ORDER_THIRD () { 0x0000002; }") unless defined(&SI_ORDER_THIRD);
    eval("sub SI_ORDER_FOURTH () { 0x0000003; }") unless defined(&SI_ORDER_FOURTH);
    eval("sub SI_ORDER_EARLIER () { 0x0800000; }") unless defined(&SI_ORDER_EARLIER);
    eval("sub SI_ORDER_MIDDLE () { 0x1000000; }") unless defined(&SI_ORDER_MIDDLE);
    eval("sub SI_ORDER_LATER () { 0x2000000; }") unless defined(&SI_ORDER_LATER);
    eval("sub SI_ORDER_ANY () { 0xfffffff; }") unless defined(&SI_ORDER_ANY);
    eval 'sub C_SYSINIT {
        my($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_init = { $subsystem, $order, $func, $ident, $uniquifier };  &DATA_SET( &sysinit_set,$uniquifier   &_sys_init));
    }' unless defined(&C_SYSINIT);
    eval 'sub SYSINIT {
        my($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &C_SYSINIT($uniquifier, $subsystem, $order, ( &sysinit_cfunc_t)( &sysinit_nfunc_t)$func, ( &void *)$ident));
    }' unless defined(&SYSINIT);
    eval 'sub C_SYSUNINIT {
        my($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &static \'struct sysinit\' $uniquifier   &_sys_uninit = { $subsystem, $order, $func, $ident };  &DATA_SET( &sysuninit_set,$uniquifier   &_sys_uninit));
    }' unless defined(&C_SYSUNINIT);
    eval 'sub SYSUNINIT {
        my($uniquifier, $subsystem, $order, $func, $ident) = @_;
	    eval q( &C_SYSUNINIT($uniquifier, $subsystem, $order, ( &sysinit_cfunc_t)( &sysinit_nfunc_t)$func, ( &void *)$ident));
    }' unless defined(&SYSUNINIT);
    eval 'sub TUNABLE_INT {
        my($path, $var) = @_;
	    eval q( &_TUNABLE_INT(($path), ($var),  &__LINE__));
    }' unless defined(&TUNABLE_INT);
    eval 'sub _TUNABLE_INT {
        my($path, $var, $line) = @_;
	    eval q( &__TUNABLE_INT(($path), ($var), $line));
    }' unless defined(&_TUNABLE_INT);
    eval 'sub __TUNABLE_INT {
        my($path, $var, $line) = @_;
	    eval q( &static \'struct tunable_int\'  &__tunable_int_  $line = { $path, $var, };  &SYSINIT( &__Tunable_init_  $line,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE,  &tunable_int_init, & &__tunable_int_  $line));
    }' unless defined(&__TUNABLE_INT);
    eval 'sub TUNABLE_INT_FETCH {
        my($path, $var) = @_;
	    eval q( &kgetenv_int(($path), ($var)));
    }' unless defined(&TUNABLE_INT_FETCH);
    eval 'sub TUNABLE_INT_DECL {
        my($path, $defval, $var) = @_;
	    eval q( &static  &void  &__Tunable_  $var ( &void * &ignored) { ($var) = ($defval);  &TUNABLE_INT_FETCH(($path), ($var)); }  &SYSINIT( &__Tunable_init_  $var,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE,  &__Tunable_  $var ,  &NULL););
    }' unless defined(&TUNABLE_INT_DECL);
    eval 'sub TUNABLE_LONG {
        my($path, $var) = @_;
	    eval q( &_TUNABLE_LONG(($path), ($var),  &__LINE__));
    }' unless defined(&TUNABLE_LONG);
    eval 'sub _TUNABLE_LONG {
        my($path, $var, $line) = @_;
	    eval q( &__TUNABLE_LONG(($path), ($var), $line));
    }' unless defined(&_TUNABLE_LONG);
    eval 'sub __TUNABLE_LONG {
        my($path, $var, $line) = @_;
	    eval q( &static \'struct tunable_long\' \'__tunable_long_\'  $line = { $path, $var, };  &SYSINIT( &__Tunable_init_  $line,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE, \'tunable_long_init\', &\'__tunable_long_\'  $line));
    }' unless defined(&__TUNABLE_LONG);
    eval 'sub TUNABLE_LONG_FETCH {
        my($path, $var) = @_;
	    eval q( &kgetenv_long(($path), ($var)));
    }' unless defined(&TUNABLE_LONG_FETCH);
    eval 'sub TUNABLE_ULONG {
        my($path, $var) = @_;
	    eval q( &_TUNABLE_ULONG(($path), ($var),  &__LINE__));
    }' unless defined(&TUNABLE_ULONG);
    eval 'sub _TUNABLE_ULONG {
        my($path, $var, $line) = @_;
	    eval q( &__TUNABLE_ULONG(($path), ($var), $line));
    }' unless defined(&_TUNABLE_ULONG);
    eval 'sub __TUNABLE_ULONG {
        my($path, $var, $line) = @_;
	    eval q( &static \'struct tunable_ulong\' \'__tunable_ulong_\'  $line = { $path, $var, };  &SYSINIT( &__Tunable_init_  $line,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE, \'tunable_ulong_init\', &\'__tunable_ulong_\'  $line));
    }' unless defined(&__TUNABLE_ULONG);
    eval 'sub TUNABLE_ULONG_FETCH {
        my($path, $var) = @_;
	    eval q( &kgetenv_ulong(($path), ($var)));
    }' unless defined(&TUNABLE_ULONG_FETCH);
    eval 'sub TUNABLE_QUAD {
        my($path, $var) = @_;
	    eval q( &_TUNABLE_QUAD(($path), ($var),  &__LINE__));
    }' unless defined(&TUNABLE_QUAD);
    eval 'sub _TUNABLE_QUAD {
        my($path, $var, $line) = @_;
	    eval q( &__TUNABLE_QUAD(($path), ($var), $line));
    }' unless defined(&_TUNABLE_QUAD);
    eval 'sub __TUNABLE_QUAD {
        my($path, $var, $line) = @_;
	    eval q( &static \'struct tunable_quad\'  &__tunable_quad_  $line = { $path, $var, };  &SYSINIT( &__Tunable_init_  $line,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE,  &tunable_quad_init, & &__tunable_quad_  $line));
    }' unless defined(&__TUNABLE_QUAD);
    eval 'sub TUNABLE_QUAD_FETCH {
        my($path, $var) = @_;
	    eval q( &kgetenv_quad(($path), ($var)));
    }' unless defined(&TUNABLE_QUAD_FETCH);
    eval 'sub TUNABLE_STR {
        my($path, $var, $size) = @_;
	    eval q( &_TUNABLE_STR(($path), ($var), ($size),  &__LINE__));
    }' unless defined(&TUNABLE_STR);
    eval 'sub _TUNABLE_STR {
        my($path, $var, $size, $line) = @_;
	    eval q( &__TUNABLE_STR(($path), ($var), ($size), $line));
    }' unless defined(&_TUNABLE_STR);
    eval 'sub __TUNABLE_STR {
        my($path, $var, $size, $line) = @_;
	    eval q( &static \'struct tunable_str\'  &__tunable_str_  $line = { $path, $var, $size, };  &SYSINIT( &__Tunable_init_  $line,  &SI_BOOT1_TUNABLES,  &SI_ORDER_MIDDLE,  &tunable_str_init, & &__tunable_str_  $line));
    }' unless defined(&__TUNABLE_STR);
    eval 'sub TUNABLE_STR_FETCH {
        my($path, $var, $size) = @_;
	    eval q( &kgetenv_string(($path), ($var), ($size)));
    }' unless defined(&TUNABLE_STR_FETCH);
    unless(defined(&_SYS_MODULE_H_)) {
	require 'sys/module.ph';
    }
    eval 'sub PSEUDO_SET {
        my($sym, $name) = @_;
	    eval q( &static \'int\' $name   &_modevent( &module_t  &mod, \'int\'  &type,  &void * &data) {  &void (* &initfunc)( &void *) = ( &void (*)( &void *)) &data;  &switch ( &type) {  &case  &MOD_LOAD:  &initfunc( &NULL);  &break;  &case  &MOD_UNLOAD:  &kprintf($name \\" module unload - not possible for this module type\\\\n\\");  &return  &EINVAL; }  &return 0; }  &static  &moduledata_t $name   &_mod = { $name, $name   &_modevent, ( &void *)$sym };  &DECLARE_MODULE($name, $name   &_mod,  &SI_SUB_PSEUDO,  &SI_ORDER_ANY));
    }' unless defined(&PSEUDO_SET);
}
1;
