require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_KTRACE_H_)) {
    eval 'sub _SYS_KTRACE_H_ () {1;}' unless defined(&_SYS_KTRACE_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_SYS_TIME_H_)) {
	require 'sys/time.ph';
    }
    unless(defined(&_SYS_SIGNAL_H_)) {
	require 'sys/signal.ph';
    }
    eval 'sub KTROP_SET () {0;}' unless defined(&KTROP_SET);
    eval 'sub KTROP_CLEAR () {1;}' unless defined(&KTROP_CLEAR);
    eval 'sub KTROP_CLEARFILE () {2;}' unless defined(&KTROP_CLEARFILE);
    eval 'sub KTROP {
        my($o) = @_;
	    eval q((($o)&3));
    }' unless defined(&KTROP);
    eval 'sub KTRFLAG_DESCEND () {4;}' unless defined(&KTRFLAG_DESCEND);
    eval 'sub KTRH_THREADED () {0x1;}' unless defined(&KTRH_THREADED);
    eval 'sub KTRH_CPUID_ENCODE {
        my($cpuid) = @_;
	    eval q(((($cpuid) & 0xff) << 8));
    }' unless defined(&KTRH_CPUID_ENCODE);
    eval 'sub KTRH_CPUID_DECODE {
        my($flags) = @_;
	    eval q(((($flags) >> 8) & 0xff));
    }' unless defined(&KTRH_CPUID_DECODE);
    eval 'sub KTRPOINT {
        my($td, $type) = @_;
	    eval q((($td)-> &td_proc  && (($td)-> ($td_proc->{p_traceflag}) & (1<<($type)))  && ((($td)-> ($td_proc->{p_traceflag}) | ($td)-> ($td_lwp->{lwp_traceflag})) &  &KTRFAC_ACTIVE) == 0));
    }' unless defined(&KTRPOINT);
    eval 'sub KTRPOINTP {
        my($p, $td, $type) = @_;
	    eval q( &__predict_false(((($p)-> &p_traceflag & (1<<($type)))  && (( ($p->{p_traceflag}) | ($td)-> ($td_lwp->{lwp_traceflag})) &  &KTRFAC_ACTIVE) == 0)));
    }' unless defined(&KTRPOINTP);
    eval 'sub KTR_SYSCALL () {1;}' unless defined(&KTR_SYSCALL);
    eval 'sub KTR_SYSRET () {2;}' unless defined(&KTR_SYSRET);
    eval 'sub KTR_NAMEI () {3;}' unless defined(&KTR_NAMEI);
    eval 'sub KTR_GENIO () {4;}' unless defined(&KTR_GENIO);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	require 'sys/_uio.ph';
    }
    eval 'sub KTR_PSIG () {5;}' unless defined(&KTR_PSIG);
    eval 'sub KTR_CSW () {6;}' unless defined(&KTR_CSW);
    eval 'sub KTR_USER_MAXLEN () {2048;}' unless defined(&KTR_USER_MAXLEN);
    eval 'sub KTR_USER () {7;}' unless defined(&KTR_USER);
    eval 'sub KTRFAC_MASK () {0xffffff;}' unless defined(&KTRFAC_MASK);
    eval 'sub KTRFAC_SYSCALL () {(1<< &KTR_SYSCALL);}' unless defined(&KTRFAC_SYSCALL);
    eval 'sub KTRFAC_SYSRET () {(1<< &KTR_SYSRET);}' unless defined(&KTRFAC_SYSRET);
    eval 'sub KTRFAC_NAMEI () {(1<< &KTR_NAMEI);}' unless defined(&KTRFAC_NAMEI);
    eval 'sub KTRFAC_GENIO () {(1<< &KTR_GENIO);}' unless defined(&KTRFAC_GENIO);
    eval 'sub KTRFAC_PSIG () {(1<< &KTR_PSIG);}' unless defined(&KTRFAC_PSIG);
    eval 'sub KTRFAC_CSW () {(1<< &KTR_CSW);}' unless defined(&KTRFAC_CSW);
    eval 'sub KTRFAC_USER () {(1<< &KTR_USER);}' unless defined(&KTRFAC_USER);
    eval 'sub KTRFAC_ROOT () {0x80000000;}' unless defined(&KTRFAC_ROOT);
    eval 'sub KTRFAC_INHERIT () {0x40000000;}' unless defined(&KTRFAC_INHERIT);
    eval 'sub KTRFAC_ACTIVE () {0x20000000;}' unless defined(&KTRFAC_ACTIVE);
    if(defined(&_KERNEL)) {
    } else {
	require 'sys/cdefs.ph';
    }
}
1;
