require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MALLOC_H_)) {
    eval 'sub _SYS_MALLOC_H_ () {1;}' unless defined(&_SYS_MALLOC_H_);
    unless(defined(&_SYS_TYPES_H_)) {
	require 'sys/types.ph';
    }
    unless(defined(&_MACHINE_TYPES_H_)) {
	require 'machine/types.ph';
    }
    eval 'sub M_RNOWAIT () {0x1;}' unless defined(&M_RNOWAIT);
    eval 'sub M_WAITOK () {0x2;}' unless defined(&M_WAITOK);
    eval 'sub M_ZERO () {0x100;}' unless defined(&M_ZERO);
    eval 'sub M_USE_RESERVE () {0x200;}' unless defined(&M_USE_RESERVE);
    eval 'sub M_NULLOK () {0x400;}' unless defined(&M_NULLOK);
    eval 'sub M_PASSIVE_ZERO () {0x800;}' unless defined(&M_PASSIVE_ZERO);
    eval 'sub M_USE_INTERRUPT_RESERVE () {0x1000;}' unless defined(&M_USE_INTERRUPT_RESERVE);
    eval 'sub M_POWEROF2 () {0x2000;}' unless defined(&M_POWEROF2);
    eval 'sub M_CACHEALIGN () {0x4000;}' unless defined(&M_CACHEALIGN);
    eval 'sub M_INTNOWAIT () {( &M_RNOWAIT |  &M_NULLOK |  &M_USE_RESERVE |  &M_USE_INTERRUPT_RESERVE);}' unless defined(&M_INTNOWAIT);
    eval 'sub M_SYSNOWAIT () {( &M_RNOWAIT |  &M_NULLOK |  &M_USE_RESERVE);}' unless defined(&M_SYSNOWAIT);
    eval 'sub M_INTWAIT () {( &M_WAITOK |  &M_USE_RESERVE |  &M_USE_INTERRUPT_RESERVE);}' unless defined(&M_INTWAIT);
    eval 'sub M_SYSWAIT () {( &M_WAITOK |  &M_USE_RESERVE);}' unless defined(&M_SYSWAIT);
    eval 'sub M_NOWAIT () {( &M_RNOWAIT |  &M_NULLOK |  &M_USE_RESERVE);}' unless defined(&M_NOWAIT);
    eval 'sub M_SYSALLOC () { &M_SYSWAIT;}' unless defined(&M_SYSALLOC);
    eval 'sub M_MAGIC () {877983977;}' unless defined(&M_MAGIC);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	require 'sys/_malloc.ph';
	unless(defined(&NULL)) {
	    require 'sys/_null.ph';
	}
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub MALLOC_DEFINE {
	    my($type, $shortdesc, $longdesc) = @_;
    	    eval q(\'struct malloc_type\' $type->[1] = { {  &NULL, 0, 0, 0, 0,  &M_MAGIC, $shortdesc, 0,  ($type[0]->{ks_use0}), { 0, 0, 0, 0} } };  &SYSINIT($type &_init,  &SI_BOOT1_KMALLOC,  &SI_ORDER_ANY,  &malloc_init, $type);  &SYSUNINIT($type &_uninit,  &SI_BOOT1_KMALLOC,  &SI_ORDER_ANY,  &malloc_uninit, $type));
	}' unless defined(&MALLOC_DEFINE);
	eval 'sub MALLOC_DEFINE_OBJ {
	    my($type, $size, $shortdesc, $longdesc) = @_;
    	    eval q(\'struct malloc_type\' $type $_obj[1] = { {  &NULL, 0, 0, 0,  &KSF_OBJSIZE,  &M_MAGIC, $shortdesc,  &__VM_CACHELINE_ALIGN(($size)), $type ($_obj[0]->{ks_use0}), { 0, 0, 0, 0} } };  &SYSINIT($type &_init,  &SI_BOOT1_KMALLOC,  &SI_ORDER_ANY,  &malloc_init, $type &_obj);  &SYSUNINIT($type &_uninit,  &SI_BOOT1_KMALLOC,  &SI_ORDER_ANY,  &malloc_uninit, $type &_obj));
	}' unless defined(&MALLOC_DEFINE_OBJ);
    } else {
	eval 'sub MALLOC_DEFINE {
	    my($type, $shortdesc, $longdesc) = @_;
    	    eval q(\'struct malloc_type\' $type->[1] = { {  &NULL, 0, 0, 0, 0,  &M_MAGIC, $shortdesc, 0,  ($type[0]->{ks_use0}), { 0, 0, 0, 0} });
	}' unless defined(&MALLOC_DEFINE);
	eval 'sub MALLOC_DEFINE_OBJ {
	    my($type, $size, $shortdesc, $longdesc) = @_;
    	    eval q(\'struct malloc_type\' $type $_obj[1] = { {  &NULL, 0, 0, 0,  &KSF_OBJSIZE,  &M_MAGIC, $shortdesc,  &__VM_CACHELINE_ALIGN(($size)), $type ($_obj[0]->{ks_use0}), { 0, 0, 0, 0} });
	}' unless defined(&MALLOC_DEFINE_OBJ);
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub MINALLOCSIZE () {$sizeof{ &void };}' unless defined(&MINALLOCSIZE);
	eval 'sub kmalloc_create_obj {
	    my($typep, $descr, $objsize) = @_;
    	    eval q( &_kmalloc_create_obj(($typep &_obj), ($descr), ($objsize)));
	}' unless defined(&kmalloc_create_obj);
	eval 'sub kmalloc_destroy_obj {
	    my($type) = @_;
    	    eval q( &kmalloc_destroy(($type &_obj)));
	}' unless defined(&kmalloc_destroy_obj);
	if(defined(&SLAB_DEBUG)) {
	    eval 'sub __kmalloc {
	        my($size, $type, $flags) = @_;
    		eval q(({  &void * &_malloc_item; \'size_t\'  &_size = ($size);  &if ( &__builtin_constant_p($size)  &&  &__builtin_constant_p($flags)  && (($flags) &  &M_ZERO)) {  &_malloc_item =  &_kmalloc_debug( &_size, $type, ($flags) & ~ &M_ZERO,  &__FILE__,  &__LINE__);  &if ((($flags) & ( &M_WAITOK| &M_NULLOK)) ==  &M_WAITOK ||  &__predict_true( &_malloc_item !=  &NULL)) {  &__builtin_memset( &_malloc_item, 0,  &_size); } }  &else {  &_malloc_item =  &_kmalloc_debug( &_size, $type, $flags,  &__FILE__,  &__LINE__); }  &_malloc_item; }));
	    }' unless defined(&__kmalloc);
	    eval 'sub __kmalloc_obj {
	        my($size, $type, $flags) = @_;
    		eval q(({  &void * &_malloc_item; \'size_t\'  &_size =  &__VM_CACHELINE_ALIGN($size);  &if ( &__builtin_constant_p($size)  &&  &__builtin_constant_p($flags)  && (($flags) &  &M_ZERO)) {  &_malloc_item =  &_kmalloc_obj_debug( &_size, $type, ($flags) & ~ &M_ZERO,  &__FILE__,  &__LINE__);  &if ((($flags) & ( &M_WAITOK| &M_NULLOK)) ==  &M_WAITOK ||  &__predict_true( &_malloc_item !=  &NULL)) {  &__builtin_memset( &_malloc_item, 0,  &_size); } }  &else {  &_malloc_item =  &_kmalloc_obj_debug( &_size, $type, $flags,  &__FILE__,  &__LINE__); }  &_malloc_item; }));
	    }' unless defined(&__kmalloc_obj);
	    eval 'sub kmalloc {
	        my($size, $type, $flags) = @_;
    		eval q( &__kmalloc($size, $type, $flags));
	    }' unless defined(&kmalloc);
	    eval 'sub kmalloc_obj {
	        my($size, $type, $flags) = @_;
    		eval q( &__kmalloc_obj($size, $type &_obj, $flags));
	    }' unless defined(&kmalloc_obj);
	    eval 'sub krealloc {
	        my($addr, $size, $type, $flags) = @_;
    		eval q( &krealloc_debug($addr, $size, $type, $flags,  &__FILE__,  &__LINE__));
	    }' unless defined(&krealloc);
	    eval 'sub kstrdup {
	        my($str, $type) = @_;
    		eval q( &kstrdup_debug($str, $type,  &__FILE__,  &__LINE__));
	    }' unless defined(&kstrdup);
	    eval 'sub kstrndup {
	        my($str, $maxlen, $type) = @_;
    		eval q( &kstrndup_debug($str, $maxlen, $type,  &__FILE__,  &__LINE__));
	    }' unless defined(&kstrndup);
	} else {
	    eval 'sub __kmalloc {
	        my($_size,$_type,$_flags) = @_;
    		eval q({  &if ( &__builtin_constant_p($_size)  &&  &__builtin_constant_p($_flags)  && ($_flags &  &M_ZERO)) {  &void * &_malloc_item;  &_malloc_item =  &_kmalloc($_size, $_type, $_flags & ~ &M_ZERO);  &if (($_flags & ( &M_WAITOK| &M_NULLOK)) ==  &M_WAITOK ||  &__predict_true( &_malloc_item !=  &NULL)) {  &__builtin_memset( &_malloc_item, 0, $_size); }  &_malloc_item; } ( &_kmalloc($_size, $_type, $_flags)); });
	    }' unless defined(&__kmalloc);
	    eval 'sub __kmalloc_obj {
	        my($_size,$_type,$_flags) = @_;
    		eval q({  &if ( &__builtin_constant_p($_size)  &&  &__builtin_constant_p($_flags)  && ($_flags &  &M_ZERO)) {  &void * &_malloc_item;  &_malloc_item =  &_kmalloc_obj( &__VM_CACHELINE_ALIGN($_size), $_type, $_flags & ~ &M_ZERO);  &if (($_flags & ( &M_WAITOK| &M_NULLOK)) ==  &M_WAITOK ||  &__predict_true( &_malloc_item !=  &NULL)) {  &__builtin_memset( &_malloc_item, 0, $_size); }  &_malloc_item; } ( &_kmalloc_obj( &__VM_CACHELINE_ALIGN($_size), $_type, $_flags)); });
	    }' unless defined(&__kmalloc_obj);
	    eval 'sub kmalloc {
	        my($size, $type, $flags) = @_;
    		eval q( &__kmalloc(($size), $type, ($flags)));
	    }' unless defined(&kmalloc);
	    eval 'sub kmalloc_obj {
	        my($size, $type, $flags) = @_;
    		eval q( &__kmalloc_obj(($size), $type &_obj, ($flags)));
	    }' unless defined(&kmalloc_obj);
	    eval 'sub _kmalloc_debug {
	        my($size, $type, $flags, $file, $line) = @_;
    		eval q( &__kmalloc(($size), $type, ($flags)));
	    }' unless defined(&_kmalloc_debug);
	    eval 'sub _kmalloc_obj_debug {
	        my($size, $type, $flags, $file, $line) = @_;
    		eval q( &__kmalloc_obj(($size), $type &_obj, ($flags)));
	    }' unless defined(&_kmalloc_obj_debug);
	    eval 'sub krealloc_debug {
	        my($addr, $size, $type, $flags, $file, $line) = @_;
    		eval q( &krealloc($addr, $size, $type, $flags));
	    }' unless defined(&krealloc_debug);
	    eval 'sub kstrdup_debug {
	        my($str, $type, $file, $line) = @_;
    		eval q( &kstrdup($str, $type));
	    }' unless defined(&kstrdup_debug);
	    eval 'sub kstrndup_debug {
	        my($str, $maxlen, $type, $file, $line) = @_;
    		eval q( &kstrndup($str, $maxlen, $type));
	    }' unless defined(&kstrndup_debug);
	}
	eval 'sub kmalloc_obj_raise_limit {
	    my($type, $bytes) = @_;
    	    eval q( &kmalloc_raise_limit($type &_obj, $bytes));
	}' unless defined(&kmalloc_obj_raise_limit);
	eval 'sub kmalloc_obj_set_unlimited {
	    my($type) = @_;
    	    eval q( &kmalloc_set_unlimited($type &_obj));
	}' unless defined(&kmalloc_obj_set_unlimited);
	eval 'sub kfree {
	    my($addr, $type) = @_;
    	    eval q( &_kfree($addr, $type));
	}' unless defined(&kfree);
	eval 'sub kfree_obj {
	    my($addr, $type) = @_;
    	    eval q( &_kfree_obj($addr, $type &_obj));
	}' unless defined(&kfree_obj);
    }
}
1;
