require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MOUNT_H_)) {
    eval 'sub _SYS_MOUNT_H_ () {1;}' unless defined(&_SYS_MOUNT_H_);
    require 'sys/queue.ph';
    require 'sys/tree.ph';
    require 'sys/ucred.ph';
    unless(defined(&_KERNEL)) {
	if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	    require 'sys/stat.ph';
	}
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_LOCK_H_)) {
	    require 'sys/lock.ph';
	}
	unless(defined(&_SYS_NAMECACHE_H_)) {
	    require 'sys/namecache.ph';
	}
	unless(defined(&_SYS_STATVFS_H_)) {
	    require 'sys/statvfs.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
	require 'sys/vfs_quota.ph';
	require 'sys/mplock2.ph';
    }
    eval 'sub fsidcmp {
        my($a, $b) = @_;
	    eval q( &memcmp(($a), ($b), $sizeof{ &fsid_t}));
    }' unless defined(&fsidcmp);
    eval 'sub MAXFIDSZ () {16;}' unless defined(&MAXFIDSZ);
    eval 'sub MFSNAMELEN () {16;}' unless defined(&MFSNAMELEN);
    eval 'sub MNAMELEN () {80;}' unless defined(&MNAMELEN);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
    }
    eval 'sub ACCT_CHUNK_BITS () {5;}' unless defined(&ACCT_CHUNK_BITS);
    eval 'sub ACCT_CHUNK_NIDS () {(1<< &ACCT_CHUNK_BITS);}' unless defined(&ACCT_CHUNK_NIDS);
    eval 'sub ACCT_CHUNK_MASK () {( &ACCT_CHUNK_NIDS - 1);}' unless defined(&ACCT_CHUNK_MASK);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
    }
    eval 'sub MNT_RDONLY () {0x1;}' unless defined(&MNT_RDONLY);
    eval 'sub MNT_SYNCHRONOUS () {0x2;}' unless defined(&MNT_SYNCHRONOUS);
    eval 'sub MNT_NOEXEC () {0x4;}' unless defined(&MNT_NOEXEC);
    eval 'sub MNT_NOSUID () {0x8;}' unless defined(&MNT_NOSUID);
    eval 'sub MNT_NODEV () {0x10;}' unless defined(&MNT_NODEV);
    eval 'sub MNT_AUTOMOUNTED () {0x20;}' unless defined(&MNT_AUTOMOUNTED);
    eval 'sub MNT_ASYNC () {0x40;}' unless defined(&MNT_ASYNC);
    eval 'sub MNT_SUIDDIR () {0x100000;}' unless defined(&MNT_SUIDDIR);
    eval 'sub MNT_SOFTDEP () {0x200000;}' unless defined(&MNT_SOFTDEP);
    eval 'sub MNT_NOSYMFOLLOW () {0x400000;}' unless defined(&MNT_NOSYMFOLLOW);
    eval 'sub MNT_TRIM () {0x1000000;}' unless defined(&MNT_TRIM);
    eval 'sub MNT_NOATIME () {0x10000000;}' unless defined(&MNT_NOATIME);
    eval 'sub MNT_NOCLUSTERR () {0x40000000;}' unless defined(&MNT_NOCLUSTERR);
    eval 'sub MNT_NOCLUSTERW () {0x80000000;}' unless defined(&MNT_NOCLUSTERW);
    eval 'sub MNT_EXRDONLY () {0x80;}' unless defined(&MNT_EXRDONLY);
    eval 'sub MNT_EXPORTED () {0x100;}' unless defined(&MNT_EXPORTED);
    eval 'sub MNT_DEFEXPORTED () {0x200;}' unless defined(&MNT_DEFEXPORTED);
    eval 'sub MNT_EXPORTANON () {0x400;}' unless defined(&MNT_EXPORTANON);
    eval 'sub MNT_EXKERB () {0x800;}' unless defined(&MNT_EXKERB);
    eval 'sub MNT_EXPUBLIC () {0x20000000;}' unless defined(&MNT_EXPUBLIC);
    eval 'sub MNT_LOCAL () {0x1000;}' unless defined(&MNT_LOCAL);
    eval 'sub MNT_QUOTA () {0x2000;}' unless defined(&MNT_QUOTA);
    eval 'sub MNT_ROOTFS () {0x4000;}' unless defined(&MNT_ROOTFS);
    eval 'sub MNT_USER () {0x8000;}' unless defined(&MNT_USER);
    eval 'sub MNT_IGNORE () {0x800000;}' unless defined(&MNT_IGNORE);
    eval 'sub MNT_VISFLAGMASK () {( &MNT_RDONLY |  &MNT_SYNCHRONOUS |  &MNT_NOEXEC |  &MNT_NOSUID |  &MNT_NODEV |  &MNT_ASYNC |  &MNT_EXRDONLY |  &MNT_EXPORTED |  &MNT_DEFEXPORTED |  &MNT_EXPORTANON|  &MNT_EXKERB |  &MNT_LOCAL |  &MNT_USER |  &MNT_QUOTA |  &MNT_ROOTFS |  &MNT_NOATIME |  &MNT_NOCLUSTERR|  &MNT_NOCLUSTERW |  &MNT_SUIDDIR |  &MNT_SOFTDEP |  &MNT_IGNORE |  &MNT_NOSYMFOLLOW |  &MNT_EXPUBLIC|  &MNT_TRIM |  &MNT_AUTOMOUNTED);}' unless defined(&MNT_VISFLAGMASK);
    eval 'sub MNT_UPDATE () {0x10000;}' unless defined(&MNT_UPDATE);
    eval 'sub MNT_DELEXPORT () {0x20000;}' unless defined(&MNT_DELEXPORT);
    eval 'sub MNT_RELOAD () {0x40000;}' unless defined(&MNT_RELOAD);
    eval 'sub MNT_FORCE () {0x80000;}' unless defined(&MNT_FORCE);
    eval 'sub MNT_CMDFLAGS () {( &MNT_UPDATE| &MNT_DELEXPORT| &MNT_RELOAD| &MNT_FORCE);}' unless defined(&MNT_CMDFLAGS);
    eval 'sub MNTK_UNMOUNTF () {0x1;}' unless defined(&MNTK_UNMOUNTF);
    eval 'sub MNTK_QUICKHALT () {0x8000;}' unless defined(&MNTK_QUICKHALT);
    eval 'sub MNTK_MPSAFE () {0x10000;}' unless defined(&MNTK_MPSAFE);
    eval 'sub MNTK_RD_MPSAFE () {0x20000;}' unless defined(&MNTK_RD_MPSAFE);
    eval 'sub MNTK_WR_MPSAFE () {0x40000;}' unless defined(&MNTK_WR_MPSAFE);
    eval 'sub MNTK_GA_MPSAFE () {0x80000;}' unless defined(&MNTK_GA_MPSAFE);
    eval 'sub MNTK_IN_MPSAFE () {0x100000;}' unless defined(&MNTK_IN_MPSAFE);
    eval 'sub MNTK_SG_MPSAFE () {0x200000;}' unless defined(&MNTK_SG_MPSAFE);
    eval 'sub MNTK_NCALIASED () {0x800000;}' unless defined(&MNTK_NCALIASED);
    eval 'sub MNTK_UNMOUNT () {0x1000000;}' unless defined(&MNTK_UNMOUNT);
    eval 'sub MNTK_MWAIT () {0x2000000;}' unless defined(&MNTK_MWAIT);
    eval 'sub MNTK_WANTRDWR () {0x4000000;}' unless defined(&MNTK_WANTRDWR);
    eval 'sub MNTK_NOSTKMNT () {0x10000000;}' unless defined(&MNTK_NOSTKMNT);
    eval 'sub MNTK_NOMSYNC () {0x20000000;}' unless defined(&MNTK_NOMSYNC);
    eval 'sub MNTK_THR_SYNC () {0x40000000;}' unless defined(&MNTK_THR_SYNC);
    eval 'sub MNTK_ST_MPSAFE () {0x80000000;}' unless defined(&MNTK_ST_MPSAFE);
    eval 'sub MNTK_ALL_MPSAFE () {( &MNTK_MPSAFE |  &MNTK_RD_MPSAFE |  &MNTK_WR_MPSAFE |  &MNTK_GA_MPSAFE |  &MNTK_IN_MPSAFE |  &MNTK_SG_MPSAFE |  &MNTK_ST_MPSAFE);}' unless defined(&MNTK_ALL_MPSAFE);
    eval 'sub MNTSCAN_FORWARD () {0x1;}' unless defined(&MNTSCAN_FORWARD);
    eval 'sub MNTSCAN_REVERSE () {0x2;}' unless defined(&MNTSCAN_REVERSE);
    eval 'sub MNTSCAN_NOBUSY () {0x4;}' unless defined(&MNTSCAN_NOBUSY);
    eval 'sub MNTSCAN_NOUNLOCK () {0x8;}' unless defined(&MNTSCAN_NOUNLOCK);
    eval 'sub MNTINS_FIRST () {0x1;}' unless defined(&MNTINS_FIRST);
    eval 'sub MNTINS_LAST () {0x2;}' unless defined(&MNTINS_LAST);
    eval 'sub VFS_VFSCONF () {0;}' unless defined(&VFS_VFSCONF);
    eval 'sub VFS_GENERIC () {0;}' unless defined(&VFS_GENERIC);
    eval 'sub VFS_MAXTYPENUM () {1;}' unless defined(&VFS_MAXTYPENUM);
    eval 'sub VFS_CONF () {2;}' unless defined(&VFS_CONF);
    eval 'sub VFS_MPLOCK_DECLARE () {\'struct mount\' * &xlock_mp;}' unless defined(&VFS_MPLOCK_DECLARE);
    eval 'sub VFS_MPLOCK {
        my($mp) = @_;
	    eval q( &VFS_MPLOCK_FLAG($mp,  &MNTK_MPSAFE));
    }' unless defined(&VFS_MPLOCK);
    eval 'sub VFS_MPLOCK_FLAG {
        my($mp, $flag) = @_;
	    eval q( &do {  &if ( ($mp->{mnt_kern_flag}) & $flag) {  &xlock_mp =  &NULL; }  &else {  &xlock_mp = ($mp);  &get_mplock();  &lwkt_gettoken( ($xlock_mp->{mnt_token})); } }  &while(0));
    }' unless defined(&VFS_MPLOCK_FLAG);
    eval 'sub VFS_MPUNLOCK () {
        eval q( &do {  &if ( &xlock_mp) {  &lwkt_reltoken( ($xlock_mp->{mnt_token}));  &rel_mplock(); } }  &while(0));
    }' unless defined(&VFS_MPUNLOCK);
    eval 'sub MNT_WAIT () {0x1;}' unless defined(&MNT_WAIT);
    eval 'sub MNT_NOWAIT () {0x2;}' unless defined(&MNT_NOWAIT);
    eval 'sub MNT_LAZY () {0x4;}' unless defined(&MNT_LAZY);
    eval 'sub VOP_FSYNC_SYSCALL () {0x1;}' unless defined(&VOP_FSYNC_SYSCALL);
    eval 'sub VFCF_STATIC () {0x10000;}' unless defined(&VFCF_STATIC);
    eval 'sub VFCF_NETWORK () {0x20000;}' unless defined(&VFCF_NETWORK);
    eval 'sub VFCF_READONLY () {0x40000;}' unless defined(&VFCF_READONLY);
    eval 'sub VFCF_SYNTHETIC () {0x80000;}' unless defined(&VFCF_SYNTHETIC);
    eval 'sub VFCF_LOOPBACK () {0x100000;}' unless defined(&VFCF_LOOPBACK);
    eval 'sub VFCF_UNICODE () {0x200000;}' unless defined(&VFCF_UNICODE);
    eval 'sub VFCF_MPSAFE () {0x400000;}' unless defined(&VFCF_MPSAFE);
    eval 'sub VQ_NOTRESP () {0x1;}' unless defined(&VQ_NOTRESP);
    eval 'sub VQ_NEEDAUTH () {0x2;}' unless defined(&VQ_NEEDAUTH);
    eval 'sub VQ_LOWDISK () {0x4;}' unless defined(&VQ_LOWDISK);
    eval 'sub VQ_MOUNT () {0x8;}' unless defined(&VQ_MOUNT);
    eval 'sub VQ_UNMOUNT () {0x10;}' unless defined(&VQ_UNMOUNT);
    eval 'sub VQ_DEAD () {0x20;}' unless defined(&VQ_DEAD);
    eval 'sub VQ_ASSIST () {0x40;}' unless defined(&VQ_ASSIST);
    eval 'sub VQ_NOTRESPLOCK () {0x80;}' unless defined(&VQ_NOTRESPLOCK);
    eval 'sub VQ_FLAG0100 () {0x100;}' unless defined(&VQ_FLAG0100);
    eval 'sub VQ_FLAG0200 () {0x200;}' unless defined(&VQ_FLAG0200);
    eval 'sub VQ_FLAG0400 () {0x400;}' unless defined(&VQ_FLAG0400);
    eval 'sub VQ_FLAG0800 () {0x800;}' unless defined(&VQ_FLAG0800);
    eval 'sub VQ_FLAG1000 () {0x1000;}' unless defined(&VQ_FLAG1000);
    eval 'sub VQ_FLAG2000 () {0x2000;}' unless defined(&VQ_FLAG2000);
    eval 'sub VQ_FLAG4000 () {0x4000;}' unless defined(&VQ_FLAG4000);
    eval 'sub VQ_FLAG8000 () {0x8000;}' unless defined(&VQ_FLAG8000);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	eval 'sub VFSOPSF_NOSYNCERTHR () {0x1;}' unless defined(&VFSOPSF_NOSYNCERTHR);
	eval 'sub VFS_MOUNT {
	    my($MP, $PATH, $DATA, $CRED) = @_;
    	    eval q( &vfs_mount($MP, $PATH, $DATA, $CRED));
	}' unless defined(&VFS_MOUNT);
	eval 'sub VFS_START {
	    my($MP, $FLAGS) = @_;
    	    eval q( &vfs_start($MP, $FLAGS));
	}' unless defined(&VFS_START);
	eval 'sub VFS_UNMOUNT {
	    my($MP, $FORCE) = @_;
    	    eval q( &vfs_unmount($MP, $FORCE));
	}' unless defined(&VFS_UNMOUNT);
	eval 'sub VFS_ROOT {
	    my($MP, $VPP) = @_;
    	    eval q( &vfs_root($MP, $VPP));
	}' unless defined(&VFS_ROOT);
	eval 'sub VFS_QUOTACTL {
	    my($MP, $C, $U, $A, $CRED) = @_;
    	    eval q( &vfs_quotactl($MP, $C, $U, $A, $CRED));
	}' unless defined(&VFS_QUOTACTL);
	eval 'sub VFS_STATFS {
	    my($MP, $SBP, $CRED) = @_;
    	    eval q( &vfs_statfs($MP, $SBP, $CRED));
	}' unless defined(&VFS_STATFS);
	eval 'sub VFS_STATVFS {
	    my($MP, $SBP, $CRED) = @_;
    	    eval q( &vfs_statvfs($MP, $SBP, $CRED));
	}' unless defined(&VFS_STATVFS);
	eval 'sub VFS_SYNC {
	    my($MP, $WAIT) = @_;
    	    eval q( &vfs_sync($MP, $WAIT));
	}' unless defined(&VFS_SYNC);
	eval 'sub VFS_VGET {
	    my($MP, $DVP, $INO, $VPP) = @_;
    	    eval q( &vfs_vget($MP, $DVP, $INO, $VPP));
	}' unless defined(&VFS_VGET);
	eval 'sub VFS_FHTOVP {
	    my($MP, $ROOTVP, $FIDP, $VPP) = @_;
    	    eval q( &vfs_fhtovp($MP, $ROOTVP, $FIDP, $VPP));
	}' unless defined(&VFS_FHTOVP);
	eval 'sub VFS_VPTOFH {
	    my($VP, $FIDP) = @_;
    	    eval q( &vfs_vptofh($VP, $FIDP));
	}' unless defined(&VFS_VPTOFH);
	eval 'sub VFS_CHECKEXP {
	    my($MP, $NAM, $EXFLG, $CRED) = @_;
    	    eval q( &vfs_checkexp($MP, $NAM, $EXFLG, $CRED));
	}' unless defined(&VFS_CHECKEXP);
	eval 'sub VFS_EXTATTRCTL {
	    my($MP, $C, $FVP, $NS, $N, $CRED) = @_;
    	    eval q( &vfs_extattrctl($MP, $C, $FVP, $NS, $N, $CRED));
	}' unless defined(&VFS_EXTATTRCTL);
	eval 'sub VFS_ACCOUNT {
	    my($MP, $U, $G, $D) = @_;
    	    eval q( &if (( ($MP->{mnt_op}->{vfs_account}) !=  &NULL)  && ($D != 0))  ($MP->{mnt_op}->{vfs_account})($MP, $U, $G, $D););
	}' unless defined(&VFS_ACCOUNT);
	eval 'sub VFS_ACINIT {
	    my($MP, $ERROR) = @_;
    	    eval q( &if ( &vfs_quota_enabled  &&  ($MP->{mnt_op}->{vfs_acinit}) !=  &NULL) $ERROR =  ($MP->{mnt_op}->{vfs_acinit})($MP););
	}' unless defined(&VFS_ACINIT);
	eval 'sub VFS_ACDONE {
	    my($MP) = @_;
    	    eval q( &if ( &vfs_quota_enabled  &&  ($MP->{mnt_op}->{vfs_acdone}) !=  &NULL)  ($MP->{mnt_op}->{vfs_acdone})($MP););
	}' unless defined(&VFS_ACDONE);
	eval 'sub VFS_NCPGEN_SET {
	    my($MP, $NCP) = @_;
    	    eval q( ($MP->{mnt_op}->{vfs_ncpgen_set})($MP, $NCP));
	}' unless defined(&VFS_NCPGEN_SET);
	eval 'sub VFS_NCPGEN_TEST {
	    my($MP, $NCP) = @_;
    	    eval q( ($MP->{mnt_op}->{vfs_ncpgen_test})($MP, $NCP));
	}' unless defined(&VFS_NCPGEN_TEST);
	eval 'sub VFS_MODIFYING {
	    my($MP) = @_;
    	    eval q( ($MP->{mnt_op}->{vfs_modifying})($MP));
	}' unless defined(&VFS_MODIFYING);
    }
    if(defined(&_KERNEL)) {
	require 'sys/module.ph';
	eval 'sub VFS_SET {
	    my($vfsops, $fsname, $flags) = @_;
    	    eval q( &static \'struct vfsconf\' $fsname   &_vfsconf = { $vfsops, $fsname, -1, 0, $flags, {  &NULL }, };  &static  &moduledata_t $fsname   &_mod = { $fsname,  &vfs_modevent, & $fsname   &_vfsconf };  &DECLARE_MODULE($fsname, $fsname   &_mod,  &SI_SUB_VFS,  &SI_ORDER_MIDDLE));
	}' unless defined(&VFS_SET);
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	require 'net/radix.ph';
	eval 'sub NE_LOCK {
	    my($nep) = @_;
    	    eval q( &lwkt_getpooltoken($nep));
	}' unless defined(&NE_LOCK);
	eval 'sub NE_UNLOCK {
	    my($nep) = @_;
    	    eval q( &lwkt_relpooltoken($nep));
	}' unless defined(&NE_UNLOCK);
	eval 'sub NE_ASSERT_LOCKED {
	    my($nep) = @_;
    	    eval q( &ASSERT_LWKT_TOKEN_HELD( &lwkt_token_pool_lookup($nep)));
	}' unless defined(&NE_ASSERT_LOCKED);
    }
    if(defined(&_KERNEL)) {
    } else {
	require 'sys/cdefs.ph';
	eval 'sub getvfsbyname () { &new_getvfsbyname;}' unless defined(&getvfsbyname);
    }
}
1;
