require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MUTEX2_H_)) {
    eval 'sub _SYS_MUTEX2_H_ () {1;}' unless defined(&_SYS_MUTEX2_H_);
    unless(defined(&_SYS_MUTEX_H_)) {
	require 'sys/mutex.ph';
    }
    unless(defined(&_SYS_THREAD2_H_)) {
	require 'sys/thread2.ph';
    }
    unless(defined(&_SYS_GLOBALDATA_H_)) {
	require 'sys/globaldata.ph';
    }
    require 'machine/atomic.ph';
    eval 'sub mtx_init_flags {
        my($mtx,$ident,$flags) = @_;
	    eval q({  ($mtx->{mtx_lock}) = 0;  ($mtx->{mtx_flags}) = $flags;  ($mtx->{mtx_owner}) =  &NULL;  ($mtx->{mtx_exlink}) =  &NULL;  ($mtx->{mtx_shlink}) =  &NULL;  ($mtx->{mtx_ident}) = $ident; });
    }' unless defined(&mtx_init_flags);
    eval 'sub mtx_lock_ex_quick {
        my($mtx) = @_;
	    eval q({  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}), 0,  &MTX_EXCLUSIVE | 1) == 0) ( &_mtx_lock_ex_quick($mtx));  ($mtx->{mtx_owner}) =  &curthread; (0); });
    }' unless defined(&mtx_lock_ex_quick);
    eval 'sub mtx_lock_sh_link {
        my($mtx,$link,$flags,$to) = @_;
	    eval q({  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}), 0, 1) == 0) ( &_mtx_lock_sh_link($mtx, $link, $flags, $to));  ($link->{state}) =  &MTX_LINK_ACQUIRED; (0); });
    }' unless defined(&mtx_lock_sh_link);
    eval 'sub mtx_lock_sh_quick {
        my($mtx) = @_;
	    eval q({  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}), 0, 1) == 0) ( &_mtx_lock_sh_quick($mtx)); (0); });
    }' unless defined(&mtx_lock_sh_quick);
    eval 'sub mtx_spinlock_try {
        my($mtx) = @_;
	    eval q({  &globaldata_t  &gd =  &mycpu;  &crit_enter_quick( ($gd->{gd_curthread})); ++ ($gd->{gd_spinlocks});  &cpu_ccfence();  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}), 0,  &MTX_EXCLUSIVE | 1) == 0) ( &_mtx_spinlock_try($mtx));  ($mtx->{mtx_owner}) =  ($gd->{gd_curthread}); (0); });
    }' unless defined(&mtx_spinlock_try);
    eval 'sub mtx_unlock_ex {
        my($mtx) = @_;
	    eval q({  &globaldata_t  &gd  &__debugvar =  &mycpu; \'u_int\'  &lock =  ($mtx->{mtx_lock});  &KKASSERT(( ($mtx->{mtx_lock}) &  &MTX_EXCLUSIVE) == 0||  ($mtx->{mtx_owner}) ==  ($gd->{gd_curthread}));  &if ( &lock == ( &MTX_EXCLUSIVE | 1)) {  ($mtx->{mtx_owner}) =  &NULL;  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}),  &lock, 0) == 0)  &_mtx_unlock($mtx); }  &else {  &_mtx_unlock($mtx); } });
    }' unless defined(&mtx_unlock_ex);
    eval 'sub mtx_unlock_sh {
        my($mtx) = @_;
	    eval q({  &if ( &atomic_cmpset_int( ($mtx->{mtx_lock}), 1, 0) == 0)  &_mtx_unlock($mtx); });
    }' unless defined(&mtx_unlock_sh);
}
1;
