require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PROC_H_)) {
    eval 'sub _SYS_PROC_H_ () {1;}' unless defined(&_SYS_PROC_H_);
    if(!defined(&_KERNEL)  && !defined(&_KERNEL_STRUCTURES)) {
	die("Userland must include sys/user.h instead of sys/proc.h");
    } else {
	require 'sys/callout.ph';
	require 'sys/cpumask.ph';
	require 'sys/filedesc.ph';
	require 'sys/queue.ph';
	require 'sys/tree.ph';
	require 'sys/rtprio.ph';
	require 'sys/signal.ph';
	require 'sys/lock.ph';
	require 'sys/upmap.ph';
	unless(defined(&_KERNEL)) {
	    require 'sys/time.ph';
	}
	require 'sys/ucred.ph';
	require 'sys/event.ph';
	require 'sys/eventvar.ph';
	require 'sys/proc_common.ph';
	require 'sys/sysent.ph';
	require 'sys/thread.ph';
	require 'sys/varsym.ph';
	require 'sys/resourcevar.ph';
	if(defined(&_KERNEL)) {
	    require 'sys/procctl.ph';
	    require 'sys/globaldata.ph';
	}
	require 'sys/systimer.ph';
	require 'sys/iosched.ph';
	require 'sys/usched.ph';
	require 'machine/proc.ph';
	require 'machine/atomic.ph';
	require 'sys/signalvar.ph';
	eval 'sub PS_NOCLDWAIT () {0x1;}' unless defined(&PS_NOCLDWAIT);
	eval 'sub PS_NOCLDSTOP () {0x2;}' unless defined(&PS_NOCLDSTOP);
	eval 'sub PS_CLDSIGIGN () {0x4;}' unless defined(&PS_CLDSIGIGN);
	eval 'sub lwp_startcopy () { &lwp_cpumask;}' unless defined(&lwp_startcopy);
	eval 'sub lwp_endcopy () { &lwp_md;}' unless defined(&lwp_endcopy);
	eval 'sub p_sigignore () { ($p_sigacts->{ps_sigignore});}' unless defined(&p_sigignore);
	eval 'sub p_sigcatch () { ($p_sigacts->{ps_sigcatch});}' unless defined(&p_sigcatch);
	eval 'sub p_rlimit () { ($p_limit->{pl_rlimit});}' unless defined(&p_rlimit);
	eval 'sub p_startcopy () { &p_comm;}' unless defined(&p_startcopy);
	eval 'sub p_endcopy () { &p_unused02;}' unless defined(&p_endcopy);
	eval 'sub lwp_wchan () { ($lwp_thread->{td_wchan});}' unless defined(&lwp_wchan);
	eval 'sub lwp_wmesg () { ($lwp_thread->{td_wmesg});}' unless defined(&lwp_wmesg);
	eval 'sub p_session () { ($p_pgrp->{pg_session});}' unless defined(&p_session);
	eval 'sub p_pgid () { ($p_pgrp->{pg_id});}' unless defined(&p_pgid);
	eval 'sub P_UNUSED00 () {0x1;}' unless defined(&P_UNUSED00);
	eval 'sub P_CONTROLT () {0x2;}' unless defined(&P_CONTROLT);
	eval 'sub P_SWAPPEDOUT () {0x4;}' unless defined(&P_SWAPPEDOUT);
	eval 'sub P_SYSVSEM () {0x8;}' unless defined(&P_SYSVSEM);
	eval 'sub P_PPWAIT () {0x10;}' unless defined(&P_PPWAIT);
	eval 'sub P_PROFIL () {0x20;}' unless defined(&P_PROFIL);
	eval 'sub P_POSTEXIT () {0x40;}' unless defined(&P_POSTEXIT);
	eval 'sub P_SCMOUSE () {0x80;}' unless defined(&P_SCMOUSE);
	eval 'sub P_SUGID () {0x100;}' unless defined(&P_SUGID);
	eval 'sub P_SYSTEM () {0x200;}' unless defined(&P_SYSTEM);
	eval 'sub P_MAYBETHREADED () {0x400;}' unless defined(&P_MAYBETHREADED);
	eval 'sub P_TRACED () {0x800;}' unless defined(&P_TRACED);
	eval 'sub P_WAITED () {0x1000;}' unless defined(&P_WAITED);
	eval 'sub P_WEXIT () {0x2000;}' unless defined(&P_WEXIT);
	eval 'sub P_EXEC () {0x4000;}' unless defined(&P_EXEC);
	eval 'sub P_CONTINUED () {0x8000;}' unless defined(&P_CONTINUED);
	eval 'sub P_LOWMEMKILL () {0x10000;}' unless defined(&P_LOWMEMKILL);
	eval 'sub P_UNUSED17 () {0x20000;}' unless defined(&P_UNUSED17);
	eval 'sub P_UNUSED18 () {0x40000;}' unless defined(&P_UNUSED18);
	eval 'sub P_UNUSED19 () {0x80000;}' unless defined(&P_UNUSED19);
	eval 'sub P_UNUSED20 () {0x100000;}' unless defined(&P_UNUSED20);
	eval 'sub P_UNUSED21 () {0x200000;}' unless defined(&P_UNUSED21);
	eval 'sub P_IDLESWAP () {0x400000;}' unless defined(&P_IDLESWAP);
	eval 'sub P_JAILED () {0x1000000;}' unless defined(&P_JAILED);
	eval 'sub P_SIGVTALRM () {0x2000000;}' unless defined(&P_SIGVTALRM);
	eval 'sub P_SIGPROF () {0x4000000;}' unless defined(&P_SIGPROF);
	eval 'sub P_INEXEC () {0x8000000;}' unless defined(&P_INEXEC);
	eval 'sub P_DIDCHROOT () {0x10000000;}' unless defined(&P_DIDCHROOT);
	eval 'sub P_UNUSED29 () {0x20000000;}' unless defined(&P_UNUSED29);
	eval 'sub P_XCPU () {0x40000000;}' unless defined(&P_XCPU);
	eval 'sub LWP_ALTSTACK () {0x1;}' unless defined(&LWP_ALTSTACK);
	eval 'sub LWP_OLDMASK () {0x2;}' unless defined(&LWP_OLDMASK);
	eval 'sub LWP_SINTR () {0x8;}' unless defined(&LWP_SINTR);
	eval 'sub LWP_SELECT () {0x10;}' unless defined(&LWP_SELECT);
	eval 'sub LWP_UNUSED20 () {0x20;}' unless defined(&LWP_UNUSED20);
	eval 'sub LWP_UNUSED40 () {0x40;}' unless defined(&LWP_UNUSED40);
	eval 'sub LWP_UNUSED80 () {0x80;}' unless defined(&LWP_UNUSED80);
	eval 'sub LWP_PASSIVE_ACQ () {0x100;}' unless defined(&LWP_PASSIVE_ACQ);
	eval 'sub LWP_PAGING () {0x200;}' unless defined(&LWP_PAGING);
	eval 'sub LWP_MP_ONRUNQ () {0x1;}' unless defined(&LWP_MP_ONRUNQ);
	eval 'sub LWP_MP_WEXIT () {0x2;}' unless defined(&LWP_MP_WEXIT);
	eval 'sub LWP_MP_WSTOP () {0x4;}' unless defined(&LWP_MP_WSTOP);
	eval 'sub LWP_MP_ULOAD () {0x8;}' unless defined(&LWP_MP_ULOAD);
	eval 'sub LWP_MP_RRFORCE () {0x10;}' unless defined(&LWP_MP_RRFORCE);
	eval 'sub LWP_MP_VNLRU () {0x20;}' unless defined(&LWP_MP_VNLRU);
	eval 'sub LWP_MP_URETMASK () {( &LWP_MP_WEXIT |  &LWP_MP_VNLRU);}' unless defined(&LWP_MP_URETMASK);
	eval 'sub FIRST_LWP_IN_PROC {
	    my($p) = @_;
    	    eval q( &RB_FIRST( &lwp_rb_tree, ($p)-> &p_lwp_tree));
	}' unless defined(&FIRST_LWP_IN_PROC);
	eval 'sub FOREACH_LWP_IN_PROC {
	    my($lp, $p) = @_;
    	    eval q( &RB_FOREACH($lp,  &lwp_rb_tree, ($p)-> &p_lwp_tree));
	}' unless defined(&FOREACH_LWP_IN_PROC);
	eval 'sub ONLY_LWP_IN_PROC {
	    my($p) = @_;
    	    eval q( &_only_lwp_in_proc($p,  &__func__));
	}' unless defined(&ONLY_LWP_IN_PROC);
	if(defined(&_KERNEL)) {
	    eval 'sub _only_lwp_in_proc {
	        my($p,$caller) = @_;
    		eval q({  &if ( ($p->{p_nthreads}) != 1) {  &panic(\\"%s: proc %p (pid %d cmd %s) has more than one thread\\", $caller, $p,  ($p->{p_pid}),  ($p->{p_comm})); }  &RB_ROOT( ($p->{p_lwp_tree})); });
	    }' unless defined(&_only_lwp_in_proc);
	}
	eval 'sub PID_MAX () {999999;}' unless defined(&PID_MAX);
	eval 'sub NO_PID () {0x7fffffff;}' unless defined(&NO_PID);
	eval 'sub SESS_LEADER {
	    my($p) = @_;
    	    eval q((($p)-> ($p_session->{s_leader}) == ($p)));
	}' unless defined(&SESS_LEADER);
	if(defined(&_KERNEL)) {
	    if(defined(&MALLOC_DECLARE)) {
	    }
	    eval 'sub NULL_CRED_OKAY () {0x2;}' unless defined(&NULL_CRED_OKAY);
	    eval 'sub PRISON_CHECK {
	        my($cr1, $cr2) = @_;
    		eval q(((!($cr1)-> &cr_prison) || ($cr1)-> &cr_prison == ($cr2)-> &cr_prison));
	    }' unless defined(&PRISON_CHECK);
	    eval 'sub STOPEVENT {
	        my($p,$e,$v) = @_;
    		eval q( &do {  &if ( &__predict_false(($p)-> &p_stops & ($e))) {  &stopevent($p,$e,$v); } }  &while (0));
	    }' unless defined(&STOPEVENT);
	    eval 'sub PHOLD {
	        my($p) = @_;
    		eval q( &phold(($p)));
	    }' unless defined(&PHOLD);
	    eval 'sub PRELE {
	        my($p) = @_;
    		eval q( &prele(($p)));
	    }' unless defined(&PRELE);
	    eval 'sub PHOLDZOMB {
	        my($p) = @_;
    		eval q( &pholdzomb(($p)));
	    }' unless defined(&PHOLDZOMB);
	    eval 'sub PRELEZOMB {
	        my($p) = @_;
    		eval q( &prelezomb(($p)));
	    }' unless defined(&PRELEZOMB);
	    eval 'sub PWAITRES_PENDING {
	        my($p) = @_;
    		eval q( &pwaitres_pending(($p)));
	    }' unless defined(&PWAITRES_PENDING);
	    eval 'sub PWAITRES_SET {
	        my($p) = @_;
    		eval q( &pwaitres_set(($p)));
	    }' unless defined(&PWAITRES_SET);
	    eval 'sub PSTALL {
	        my($p, $msg, $n) = @_;
    		eval q( &do {  &if (($p)-> &p_lock > ($n))  &pstall(($p), ($msg), ($n)); }  &while (0));
	    }' unless defined(&PSTALL);
	    eval 'sub STOPLWP {
	        my($p, $lp) = @_;
    		eval q(((($p)-> &p_stat ==  &SSTOP || ($p)-> &p_stat ==  &SCORE)  && (($lp)-> &lwp_mpflags &  &LWP_MP_WEXIT) == 0));
	    }' unless defined(&STOPLWP);
	    eval 'sub LWPHOLD {
	        my($lp) = @_;
    		eval q( &atomic_add_int(($lp)-> &lwp_lock, 1));
	    }' unless defined(&LWPHOLD);
	    eval 'sub LWPRELE {
	        my($lp) = @_;
    		eval q( &atomic_add_int(($lp)-> &lwp_lock, -1));
	    }' unless defined(&LWPRELE);
	    eval 'sub ESTCPUFREQ () {50;}' unless defined(&ESTCPUFREQ);
	}
    }
}
1;
