require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_THREAD_H_)) {
    eval 'sub _SYS_THREAD_H_ () {1;}' unless defined(&_SYS_THREAD_H_);
    unless(defined(&_SYS_PARAM_H_)) {
	require 'sys/param.ph';
    }
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    unless(defined(&_SYS_MSGPORT_H_)) {
	require 'sys/msgport.ph';
    }
    unless(defined(&_SYS_TIME_H_)) {
	require 'sys/time.ph';
    }
    unless(defined(&_SYS_LOCK_H)) {
	require 'sys/lock.ph';
    }
    unless(defined(&_SYS_SPINLOCK_H_)) {
	require 'sys/spinlock.ph';
    }
    unless(defined(&_SYS_IOSCHED_H_)) {
	require 'sys/iosched.ph';
    }
    require 'machine/thread.ph';
    require 'machine/stdint.ph';
    require 'machine/ucontext.ph';
    if(0) {
    }
    if(0) {
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_CPUMASK_H_)) {
	    require 'sys/cpumask.ph';
	}
	unless(defined(&_CPU_FRAME_H_)) {
	    require 'machine/frame.ph';
	}
    } else {
    }
    eval 'sub TOK_EXCLUSIVE () {0x1;}' unless defined(&TOK_EXCLUSIVE);
    eval 'sub TOK_EXCLREQ () {0x2;}' unless defined(&TOK_EXCLREQ);
    eval 'sub TOK_INCR () {4;}' unless defined(&TOK_INCR);
    eval 'sub TOK_COUNTMASK () {(~( &TOK_EXCLUSIVE| &TOK_EXCLREQ));}' unless defined(&TOK_COUNTMASK);
    eval 'sub LWKT_TOKEN_INITIALIZER {
        my($name) = @_;
	    eval q({ . &t_count = 0, . &t_ref =  &NULL, . &t_collisions = 0, . &t_desc = $name });
    }' unless defined(&LWKT_TOKEN_INITIALIZER);
    eval 'sub LWKT_TOKEN_HELD_ANY {
        my($tok) = @_;
	    eval q( &_lwkt_token_held_any($tok,  &curthread));
    }' unless defined(&LWKT_TOKEN_HELD_ANY);
    eval 'sub LWKT_TOKEN_HELD_EXCL {
        my($tok) = @_;
	    eval q( &_lwkt_token_held_excl($tok,  &curthread));
    }' unless defined(&LWKT_TOKEN_HELD_EXCL);
    eval 'sub ASSERT_LWKT_TOKEN_HELD {
        my($tok) = @_;
	    eval q( &KKASSERT( &LWKT_TOKEN_HELD_ANY($tok)));
    }' unless defined(&ASSERT_LWKT_TOKEN_HELD);
    eval 'sub ASSERT_LWKT_TOKEN_HELD_EXCL {
        my($tok) = @_;
	    eval q( &KKASSERT( &LWKT_TOKEN_HELD_EXCL($tok)));
    }' unless defined(&ASSERT_LWKT_TOKEN_HELD_EXCL);
    eval 'sub ASSERT_NO_TOKENS_HELD {
        my($td) = @_;
	    eval q( &KKASSERT(($td)-> &td_toks_stop ==  ($td->{td_toks_array[0]})));
    }' unless defined(&ASSERT_NO_TOKENS_HELD);
    eval 'sub MAXCPUFIFO () {256;}' unless defined(&MAXCPUFIFO);
    eval 'sub MAXCPUFIFO_MASK () {( &MAXCPUFIFO - 1);}' unless defined(&MAXCPUFIFO_MASK);
    eval 'sub LWKT_MAXTOKENS () {32;}' unless defined(&LWKT_MAXTOKENS);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
    }
    if(0) {
    }
    eval 'sub NFDCACHE () {4;}' unless defined(&NFDCACHE);
    if(defined(&DEBUG_CRIT_SECTIONS)) {
	eval 'sub CRIT_DEBUG_ARRAY_SIZE () {32;}' unless defined(&CRIT_DEBUG_ARRAY_SIZE);
	eval 'sub CRIT_DEBUG_ARRAY_MASK () {( &CRIT_DEBUG_ARRAY_SIZE - 1);}' unless defined(&CRIT_DEBUG_ARRAY_MASK);
    }
    if(defined(&DEBUG_LOCKS)) {
	eval 'sub SPINLOCK_DEBUG_ARRAY_SIZE () {32;}' unless defined(&SPINLOCK_DEBUG_ARRAY_SIZE);
	eval 'sub LOCKMGR_DEBUG_ARRAY_SIZE () {8;}' unless defined(&LOCKMGR_DEBUG_ARRAY_SIZE);
    }
    eval 'sub td_toks_base () { $td_toks_array[0];}' unless defined(&td_toks_base);
    eval 'sub td_toks_end () { $td_toks_array[ &LWKT_MAXTOKENS];}' unless defined(&td_toks_end);
    eval 'sub TD_TOKS_HELD {
        my($td) = @_;
	    eval q((($td)-> &td_toks_stop != ($td)-> &td_toks_base));
    }' unless defined(&TD_TOKS_HELD);
    eval 'sub TD_TOKS_NOT_HELD {
        my($td) = @_;
	    eval q((($td)-> &td_toks_stop == ($td)-> &td_toks_base));
    }' unless defined(&TD_TOKS_NOT_HELD);
    eval 'sub TDF_RUNNING () {0x1;}' unless defined(&TDF_RUNNING);
    eval 'sub TDF_RUNQ () {0x2;}' unless defined(&TDF_RUNQ);
    eval 'sub TDF_PREEMPT_LOCK () {0x4;}' unless defined(&TDF_PREEMPT_LOCK);
    eval 'sub TDF_PREEMPT_DONE () {0x8;}' unless defined(&TDF_PREEMPT_DONE);
    eval 'sub TDF_NOSTART () {0x10;}' unless defined(&TDF_NOSTART);
    eval 'sub TDF_MIGRATING () {0x20;}' unless defined(&TDF_MIGRATING);
    eval 'sub TDF_SINTR () {0x40;}' unless defined(&TDF_SINTR);
    eval 'sub TDF_TSLEEPQ () {0x80;}' unless defined(&TDF_TSLEEPQ);
    eval 'sub TDF_SYSTHREAD () {0x100;}' unless defined(&TDF_SYSTHREAD);
    eval 'sub TDF_ALLOCATED_THREAD () {0x200;}' unless defined(&TDF_ALLOCATED_THREAD);
    eval 'sub TDF_ALLOCATED_STACK () {0x400;}' unless defined(&TDF_ALLOCATED_STACK);
    eval 'sub TDF_FPU_HEUR () {0x800;}' unless defined(&TDF_FPU_HEUR);
    eval 'sub TDF_DEADLKTREAT () {0x1000;}' unless defined(&TDF_DEADLKTREAT);
    eval 'sub TDF_MARKER () {0x2000;}' unless defined(&TDF_MARKER);
    eval 'sub TDF_TIMEOUT_RUNNING () {0x4000;}' unless defined(&TDF_TIMEOUT_RUNNING);
    eval 'sub TDF_TIMEOUT () {0x8000;}' unless defined(&TDF_TIMEOUT);
    eval 'sub TDF_INTTHREAD () {0x10000;}' unless defined(&TDF_INTTHREAD);
    eval 'sub TDF_TSLEEP_DESCHEDULED () {0x20000;}' unless defined(&TDF_TSLEEP_DESCHEDULED);
    eval 'sub TDF_BLOCKED () {0x40000;}' unless defined(&TDF_BLOCKED);
    eval 'sub TDF_PANICWARN () {0x80000;}' unless defined(&TDF_PANICWARN);
    eval 'sub TDF_BLOCKQ () {0x100000;}' unless defined(&TDF_BLOCKQ);
    eval 'sub TDF_FORCE_SPINPORT () {0x200000;}' unless defined(&TDF_FORCE_SPINPORT);
    eval 'sub TDF_EXITING () {0x400000;}' unless defined(&TDF_EXITING);
    eval 'sub TDF_USINGFP () {0x800000;}' unless defined(&TDF_USINGFP);
    eval 'sub TDF_KERNELFP () {0x1000000;}' unless defined(&TDF_KERNELFP);
    eval 'sub TDF_DELAYED_WAKEUP () {0x2000000;}' unless defined(&TDF_DELAYED_WAKEUP);
    eval 'sub TDF_FIXEDCPU () {0x4000000;}' unless defined(&TDF_FIXEDCPU);
    eval 'sub TDF_USERMODE () {0x8000000;}' unless defined(&TDF_USERMODE);
    eval 'sub TDF_NOFAULT () {0x10000000;}' unless defined(&TDF_NOFAULT);
    eval 'sub TDF_CLKTHREAD () {0x20000000;}' unless defined(&TDF_CLKTHREAD);
    eval 'sub TDF_MP_STOPREQ () {0x1;}' unless defined(&TDF_MP_STOPREQ);
    eval 'sub TDF_MP_WAKEREQ () {0x2;}' unless defined(&TDF_MP_WAKEREQ);
    eval 'sub TDF_MP_EXITWAIT () {0x4;}' unless defined(&TDF_MP_EXITWAIT);
    eval 'sub TDF_MP_EXITSIG () {0x8;}' unless defined(&TDF_MP_EXITSIG);
    eval 'sub TDF_MP_BATCH_DEMARC () {0x10;}' unless defined(&TDF_MP_BATCH_DEMARC);
    eval 'sub TDF_MP_DIDYIELD () {0x20;}' unless defined(&TDF_MP_DIDYIELD);
    eval 'sub TD_TYPE_GENERIC () {0;}' unless defined(&TD_TYPE_GENERIC);
    eval 'sub TD_TYPE_CRYPTO () {1;}' unless defined(&TD_TYPE_CRYPTO);
    eval 'sub TD_TYPE_NETISR () {2;}' unless defined(&TD_TYPE_NETISR);
    eval 'sub TDPRI_IDLE_THREAD () {0;}' unless defined(&TDPRI_IDLE_THREAD);
    eval 'sub TDPRI_IDLE_WORK () {1;}' unless defined(&TDPRI_IDLE_WORK);
    eval 'sub TDPRI_USER_SCHEDULER () {2;}' unless defined(&TDPRI_USER_SCHEDULER);
    eval 'sub TDPRI_USER_IDLE () {4;}' unless defined(&TDPRI_USER_IDLE);
    eval 'sub TDPRI_USER_NORM () {6;}' unless defined(&TDPRI_USER_NORM);
    eval 'sub TDPRI_USER_REAL () {8;}' unless defined(&TDPRI_USER_REAL);
    eval 'sub TDPRI_KERN_LPSCHED () {9;}' unless defined(&TDPRI_KERN_LPSCHED);
    eval 'sub TDPRI_KERN_USER () {10;}' unless defined(&TDPRI_KERN_USER);
    eval 'sub TDPRI_KERN_DAEMON () {12;}' unless defined(&TDPRI_KERN_DAEMON);
    eval 'sub TDPRI_SOFT_NORM () {14;}' unless defined(&TDPRI_SOFT_NORM);
    eval 'sub TDPRI_SOFT_TIMER () {16;}' unless defined(&TDPRI_SOFT_TIMER);
    eval 'sub TDPRI_UNUSED19 () {19;}' unless defined(&TDPRI_UNUSED19);
    eval 'sub TDPRI_INT_SUPPORT () {20;}' unless defined(&TDPRI_INT_SUPPORT);
    eval 'sub TDPRI_INT_LOW () {27;}' unless defined(&TDPRI_INT_LOW);
    eval 'sub TDPRI_INT_MED () {28;}' unless defined(&TDPRI_INT_MED);
    eval 'sub TDPRI_INT_HIGH () {29;}' unless defined(&TDPRI_INT_HIGH);
    eval 'sub TDPRI_MAX () {31;}' unless defined(&TDPRI_MAX);
    eval 'sub LWKT_THREAD_STACK () {( &UPAGES *  &PAGE_SIZE);}' unless defined(&LWKT_THREAD_STACK);
    eval 'sub IN_CRITICAL_SECT {
        my($td) = @_;
	    eval q((($td)-> &td_critcount));
    }' unless defined(&IN_CRITICAL_SECT);
    if(defined(&_KERNEL)) {
    }
}
1;
