require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_THREAD2_H_)) {
    eval 'sub _SYS_THREAD2_H_ () {1;}' unless defined(&_SYS_THREAD2_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included by userland programs.");
    }
    unless(defined(&_SYS_SYSTM_H_)) {
	require 'sys/systm.ph';
    }
    unless(defined(&_SYS_GLOBALDATA_H_)) {
	require 'sys/globaldata.ph';
    }
    unless(defined(&_SYS_CPUMASK_H_)) {
	require 'sys/cpumask.ph';
    }
    require 'machine/cpufunc.ph';
    eval 'sub crit_exit_raw {
        my($td) = @_;
	    eval q({  &cpu_ccfence(); -- ($td->{td_critcount});  &cpu_ccfence(); });
    }' unless defined(&crit_exit_raw);
    if(defined(&DEBUG_CRIT_SECTIONS)) {
	eval 'sub __DEBUG_CRIT_ARG__ () { &const \'char\' * &id;}' unless defined(&__DEBUG_CRIT_ARG__);
	eval 'sub __DEBUG_CRIT_ADD_ARG__ () {,  &const \'char\' * &id;}' unless defined(&__DEBUG_CRIT_ADD_ARG__);
	eval 'sub __DEBUG_CRIT_PASS_ARG__ () {,  &id;}' unless defined(&__DEBUG_CRIT_PASS_ARG__);
	eval 'sub __DEBUG_CRIT_ENTER {
	    my($td) = @_;
    	    eval q( &_debug_crit_enter(($td),  &id));
	}' unless defined(&__DEBUG_CRIT_ENTER);
	eval 'sub __DEBUG_CRIT_EXIT {
	    my($td) = @_;
    	    eval q( &_debug_crit_exit(($td),  &id));
	}' unless defined(&__DEBUG_CRIT_EXIT);
	eval 'sub crit_enter () {
	    eval q( &_crit_enter( &mycpu,  &__func__));
	}' unless defined(&crit_enter);
	eval 'sub crit_enter_id {
	    my($id) = @_;
    	    eval q( &_crit_enter( &mycpu, $id));
	}' unless defined(&crit_enter_id);
	eval 'sub crit_enter_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_enter(($curgd),  &__func__));
	}' unless defined(&crit_enter_gd);
	eval 'sub crit_enter_quick {
	    my($curtd) = @_;
    	    eval q( &_crit_enter_quick(($curtd),  &__func__));
	}' unless defined(&crit_enter_quick);
	eval 'sub crit_enter_hard () {
	    eval q( &_crit_enter_hard( &mycpu,  &__func__));
	}' unless defined(&crit_enter_hard);
	eval 'sub crit_enter_hard_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_enter_hard(($curgd),  &__func__));
	}' unless defined(&crit_enter_hard_gd);
	eval 'sub crit_exit () {
	    eval q( &_crit_exit( &mycpu,  &__func__));
	}' unless defined(&crit_exit);
	eval 'sub crit_exit_id {
	    my($id) = @_;
    	    eval q( &_crit_exit( &mycpu, $id));
	}' unless defined(&crit_exit_id);
	eval 'sub crit_exit_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_exit(($curgd),  &__func__));
	}' unless defined(&crit_exit_gd);
	eval 'sub crit_exit_quick {
	    my($curtd) = @_;
    	    eval q( &_crit_exit_quick(($curtd),  &__func__));
	}' unless defined(&crit_exit_quick);
	eval 'sub crit_exit_hard () {
	    eval q( &_crit_exit_hard( &mycpu,  &__func__));
	}' unless defined(&crit_exit_hard);
	eval 'sub crit_exit_hard_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_exit_hard(($curgd),  &__func__));
	}' unless defined(&crit_exit_hard_gd);
	eval 'sub crit_exit_noyield {
	    my($curtd) = @_;
    	    eval q( &_crit_exit_noyield(($curtd), &__func__));
	}' unless defined(&crit_exit_noyield);
    } else {
	eval 'sub __DEBUG_CRIT_ARG__ () { &void;}' unless defined(&__DEBUG_CRIT_ARG__);
	eval 'sub __DEBUG_CRIT_ADD_ARG__ () {1;}' unless defined(&__DEBUG_CRIT_ADD_ARG__);
	eval 'sub __DEBUG_CRIT_PASS_ARG__ () {1;}' unless defined(&__DEBUG_CRIT_PASS_ARG__);
	eval 'sub __DEBUG_CRIT_ENTER {
	    my($td) = @_;
    	    eval q();
	}' unless defined(&__DEBUG_CRIT_ENTER);
	eval 'sub __DEBUG_CRIT_EXIT {
	    my($td) = @_;
    	    eval q();
	}' unless defined(&__DEBUG_CRIT_EXIT);
	eval 'sub crit_enter () {
	    eval q( &_crit_enter( &mycpu));
	}' unless defined(&crit_enter);
	eval 'sub crit_enter_id {
	    my($id) = @_;
    	    eval q( &_crit_enter( &mycpu));
	}' unless defined(&crit_enter_id);
	eval 'sub crit_enter_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_enter(($curgd)));
	}' unless defined(&crit_enter_gd);
	eval 'sub crit_enter_quick {
	    my($curtd) = @_;
    	    eval q( &_crit_enter_quick(($curtd)));
	}' unless defined(&crit_enter_quick);
	eval 'sub crit_enter_hard () {
	    eval q( &_crit_enter_hard( &mycpu));
	}' unless defined(&crit_enter_hard);
	eval 'sub crit_enter_hard_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_enter_hard(($curgd)));
	}' unless defined(&crit_enter_hard_gd);
	eval 'sub crit_exit () {
	    eval q( &crit_exit_wrapper());
	}' unless defined(&crit_exit);
	eval 'sub crit_exit_id {
	    my($id) = @_;
    	    eval q( &_crit_exit( &mycpu));
	}' unless defined(&crit_exit_id);
	eval 'sub crit_exit_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_exit(($curgd)));
	}' unless defined(&crit_exit_gd);
	eval 'sub crit_exit_quick {
	    my($curtd) = @_;
    	    eval q( &_crit_exit_quick(($curtd)));
	}' unless defined(&crit_exit_quick);
	eval 'sub crit_exit_hard () {
	    eval q( &_crit_exit_hard( &mycpu));
	}' unless defined(&crit_exit_hard);
	eval 'sub crit_exit_hard_gd {
	    my($curgd) = @_;
    	    eval q( &_crit_exit_hard(($curgd)));
	}' unless defined(&crit_exit_hard_gd);
	eval 'sub crit_exit_noyield {
	    my($curtd) = @_;
    	    eval q( &_crit_exit_noyield(($curtd)));
	}' unless defined(&crit_exit_noyield);
    }
    if(defined(&DEBUG_CRIT_SECTIONS)) {
	eval 'sub _debug_crit_enter {
	    my($td,$id) = @_;
    	    eval q({ \'int\'  &wi =  ($td->{td_crit_debug_index});  ($td->{td_crit_debug_array[wi & CRIT_DEBUG_ARRAY_MASK]}) = $id; ++ ($td->{td_crit_debug_index}); });
	}' unless defined(&_debug_crit_enter);
	eval 'sub _debug_crit_exit {
	    my($td,$id) = @_;
    	    eval q({  &const \'char\' * &gid; \'int\'  &wi;  &wi =  ($td->{td_crit_debug_index}) - 1;  &if (( &gid =  ($td->{td_crit_debug_array[wi & CRIT_DEBUG_ARRAY_MASK]})) != $id) {  &if ( ($td->{td_in_crit_report}) == 0) {  ($td->{td_in_crit_report}) = 1;  &kprintf(\\"crit_exit(%s) expected id %s\\\\n\\", $id,  &gid);  ($td->{td_in_crit_report}) = 0; } } -- ($td->{td_crit_debug_index}); });
	}' unless defined(&_debug_crit_exit);
    }
    eval 'sub _crit_enter {
        my($__DEBUG_CRIT_ADD_ARG__) = @_;
	    eval q({  &_crit_enter_quick( ($gd->{gd_curthread})  &__DEBUG_CRIT_PASS_ARG__); });
    }' unless defined(&_crit_enter);
    eval 'sub _crit_enter_hard {
        my($__DEBUG_CRIT_ADD_ARG__) = @_;
	    eval q({  &_crit_enter_quick( ($gd->{gd_curthread})  &__DEBUG_CRIT_PASS_ARG__); ++ ($gd->{gd_intr_nesting_level});  &cpu_ccfence(); });
    }' unless defined(&_crit_enter_hard);
    if(defined(&INVARIANTS)) {
    }
    eval 'sub _crit_exit_quick {
        my($__DEBUG_CRIT_ADD_ARG__) = @_;
	    eval q({  &_crit_exit_noyield( &td  &__DEBUG_CRIT_PASS_ARG__);  &if ( &__predict_false( ($td->{td_gd}->{gd_reqflags}) &  &RQF_IDLECHECK_MASK))  &lwkt_maybe_splz( &td); });
    }' unless defined(&_crit_exit_quick);
    eval 'sub _crit_exit {
        my($__DEBUG_CRIT_ADD_ARG__) = @_;
	    eval q({  &_crit_exit_quick( ($gd->{gd_curthread})  &__DEBUG_CRIT_PASS_ARG__); });
    }' unless defined(&_crit_exit);
    eval 'sub _crit_exit_hard {
        my($__DEBUG_CRIT_ADD_ARG__) = @_;
	    eval q({  &cpu_ccfence(); -- ($gd->{gd_intr_nesting_level});  &_crit_exit_quick( ($gd->{gd_curthread})  &__DEBUG_CRIT_PASS_ARG__); });
    }' unless defined(&_crit_exit_hard);
    eval 'sub crit_test {
        my($td) = @_;
	    eval q({ ( ($td->{td_critcount})); });
    }' unless defined(&crit_test);
    eval 'sub lwkt_getpri {
        my($td) = @_;
	    eval q({ ( ($td->{td_pri})); });
    }' unless defined(&lwkt_getpri);
    eval 'sub lwkt_getpri_self {
        my($void) = @_;
	    eval q({ ( &lwkt_getpri( &curthread)); });
    }' unless defined(&lwkt_getpri_self);
    unless(defined(&NO_LWKT_SPLIT_USERPRI)) {
    }
    eval 'sub lwkt_send_ipiq2 {
        my($target,$func,$arg1,$arg2) = @_;
	    eval q({ ( &lwkt_send_ipiq3($target, ( &ipifunc3_t)$func, $arg1, $arg2)); });
    }' unless defined(&lwkt_send_ipiq2);
    eval 'sub lwkt_send_ipiq_mask {
        my($mask,$func,$arg) = @_;
	    eval q({ ( &lwkt_send_ipiq3_mask($mask, ( &ipifunc3_t)$func, $arg, 0)); });
    }' unless defined(&lwkt_send_ipiq_mask);
    eval 'sub lwkt_send_ipiq2_mask {
        my($mask,$func,$arg1,$arg2) = @_;
	    eval q({ ( &lwkt_send_ipiq3_mask($mask, ( &ipifunc3_t)$func, $arg1, $arg2)); });
    }' unless defined(&lwkt_send_ipiq2_mask);
    eval 'sub lwkt_send_ipiq_passive {
        my($target,$func,$arg) = @_;
	    eval q({ ( &lwkt_send_ipiq3_passive($target, ( &ipifunc3_t)$func, $arg, 0)); });
    }' unless defined(&lwkt_send_ipiq_passive);
    eval 'sub lwkt_send_ipiq2_passive {
        my($target,$func,$arg1,$arg2) = @_;
	    eval q({ ( &lwkt_send_ipiq3_passive($target, ( &ipifunc3_t)$func, $arg1, $arg2)); });
    }' unless defined(&lwkt_send_ipiq2_passive);
    eval 'sub lwkt_send_ipiq_bycpu {
        my($dcpu,$func,$arg) = @_;
	    eval q({ ( &lwkt_send_ipiq3_bycpu($dcpu, ( &ipifunc3_t)$func, $arg, 0)); });
    }' unless defined(&lwkt_send_ipiq_bycpu);
    eval 'sub lwkt_send_ipiq2_bycpu {
        my($dcpu,$func,$arg1,$arg2) = @_;
	    eval q({ ( &lwkt_send_ipiq3_bycpu($dcpu, ( &ipifunc3_t)$func, $arg1, $arg2)); });
    }' unless defined(&lwkt_send_ipiq2_bycpu);
    eval 'sub lwkt_need_ipiq_process {
        my($gd) = @_;
	    eval q({  &lwkt_ipiq_t  &ipiq;  &if ( &CPUMASK_TESTNZERO( ($gd->{gd_ipimask}))) 1;  &ipiq =  ($gd->{gd_cpusyncq}); ( ($ipiq->{ip_rindex}) !=  ($ipiq->{ip_windex})); });
    }' unless defined(&lwkt_need_ipiq_process);
}
1;
