require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TYPES_H_)) {
    eval 'sub _SYS_TYPES_H_ () {1;}' unless defined(&_SYS_TYPES_H_);
    unless(defined(&_SYS_CDEFS_H_)) {
	require 'sys/cdefs.ph';
    }
    require 'machine/endian.ph';
    require 'machine/stdint.ph';
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    }
    unless(defined(&_BLKCNT_T_DECLARED)) {
	eval 'sub _BLKCNT_T_DECLARED () {1;}' unless defined(&_BLKCNT_T_DECLARED);
    }
    unless(defined(&_BLKSIZE_T_DECLARED)) {
	eval 'sub _BLKSIZE_T_DECLARED () {1;}' unless defined(&_BLKSIZE_T_DECLARED);
    }
    unless(defined(&_DEV_T_DECLARED)) {
	eval 'sub _DEV_T_DECLARED () {1;}' unless defined(&_DEV_T_DECLARED);
    }
    unless(defined(&_FSBLKCNT_T_DECLARED)) {
	eval 'sub _FSBLKCNT_T_DECLARED () {1;}' unless defined(&_FSBLKCNT_T_DECLARED);
    }
    unless(defined(&_FSFILCNT_T_DECLARED)) {
	eval 'sub _FSFILCNT_T_DECLARED () {1;}' unless defined(&_FSFILCNT_T_DECLARED);
    }
    unless(defined(&_GID_T_DECLARED)) {
	eval 'sub _GID_T_DECLARED () {1;}' unless defined(&_GID_T_DECLARED);
    }
    unless(defined(&_ID_T_DECLARED)) {
	eval 'sub _ID_T_DECLARED () {1;}' unless defined(&_ID_T_DECLARED);
    }
    unless(defined(&_IN_ADDR_T_DECLARED)) {
	eval 'sub _IN_ADDR_T_DECLARED () {1;}' unless defined(&_IN_ADDR_T_DECLARED);
    }
    unless(defined(&_IN_PORT_T_DECLARED)) {
	eval 'sub _IN_PORT_T_DECLARED () {1;}' unless defined(&_IN_PORT_T_DECLARED);
    }
    unless(defined(&_INO_T_DECLARED)) {
	eval 'sub _INO_T_DECLARED () {1;}' unless defined(&_INO_T_DECLARED);
    }
    unless(defined(&_KEY_T_DECLARED)) {
	eval 'sub _KEY_T_DECLARED () {1;}' unless defined(&_KEY_T_DECLARED);
    }
    unless(defined(&_MODE_T_DECLARED)) {
	eval 'sub _MODE_T_DECLARED () {1;}' unless defined(&_MODE_T_DECLARED);
    }
    unless(defined(&_NLINK_T_DECLARED)) {
	eval 'sub _NLINK_T_DECLARED () {1;}' unless defined(&_NLINK_T_DECLARED);
    }
    unless(defined(&_OFF_T_DECLARED)) {
	eval 'sub _OFF_T_DECLARED () {1;}' unless defined(&_OFF_T_DECLARED);
    }
    unless(defined(&_PID_T_DECLARED)) {
	eval 'sub _PID_T_DECLARED () {1;}' unless defined(&_PID_T_DECLARED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	unless(defined(&_RLIM_T_DECLARED)) {
	    eval 'sub _RLIM_T_DECLARED () {1;}' unless defined(&_RLIM_T_DECLARED);
	}
    }
    unless(defined(&_SUSECONDS_T_DECLARED)) {
	eval 'sub _SUSECONDS_T_DECLARED () {1;}' unless defined(&_SUSECONDS_T_DECLARED);
    }
    unless(defined(&_UID_T_DECLARED)) {
	eval 'sub _UID_T_DECLARED () {1;}' unless defined(&_UID_T_DECLARED);
    }
    unless(defined(&_USECONDS_T_DECLARED)) {
	eval 'sub _USECONDS_T_DECLARED () {1;}' unless defined(&_USECONDS_T_DECLARED);
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)  && !defined(&_KERNEL)) {
	eval 'sub major {
	    my($x) = @_;
    	    eval q((((($x) >> 8)&0xff)));
	}' unless defined(&major);
	eval 'sub minor {
	    my($x) = @_;
    	    eval q(((($x)&0xffff00ff)));
	}' unless defined(&minor);
	eval 'sub makedev {
	    my($x,$y) = @_;
    	    eval q((( &dev_t)((($x) << 8) | ($y))));
	}' unless defined(&makedev);
    }
    unless(defined(&_CLOCK_T_DECLARED)) {
	eval 'sub _CLOCK_T_DECLARED () {1;}' unless defined(&_CLOCK_T_DECLARED);
    }
    unless(defined(&_CLOCKID_T_DECLARED)) {
	eval 'sub _CLOCKID_T_DECLARED () {1;}' unless defined(&_CLOCKID_T_DECLARED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	unless(defined(&_LWPID_T_DECLARED)) {
	    eval 'sub _LWPID_T_DECLARED () {1;}' unless defined(&_LWPID_T_DECLARED);
	}
    }
    unless(defined(&_SIZE_T_DECLARED)) {
	eval 'sub _SIZE_T_DECLARED () {1;}' unless defined(&_SIZE_T_DECLARED);
    }
    unless(defined(&_SSIZE_T_DECLARED)) {
	eval 'sub _SSIZE_T_DECLARED () {1;}' unless defined(&_SSIZE_T_DECLARED);
    }
    unless(defined(&_TIME_T_DECLARED)) {
	eval 'sub _TIME_T_DECLARED () {1;}' unless defined(&_TIME_T_DECLARED);
    }
    unless(defined(&_TIMER_T_DECLARED)) {
	eval 'sub _TIMER_T_DECLARED () {1;}' unless defined(&_TIMER_T_DECLARED);
    }
    unless(defined(&_KERNEL)) {
	unless(defined(&_STDINT_H_)) {
	    require 'stdint.ph';
	}
    }
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_STDINT_H_)) {
	    require 'sys/stdint.ph';
	}
	require 'machine/types.ph';
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	require 'sys/_fd_set.ph';
	require 'sys/_timeval.ph';
    }
    if(!defined(&_KERNEL)  && !defined(&_STANDALONE)) {
	require 'sys/_pthreadtypes.ph';
    }
}
1;
