require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_VKERNEL_H_)) {
    eval 'sub _SYS_VKERNEL_H_ () {1;}' unless defined(&_SYS_VKERNEL_H_);
    if(defined(&_KERNEL) || defined(&_KERNEL_STRUCTURES)) {
	unless(defined(&_SYS_PARAM_H_)) {
	    require 'sys/param.ph';
	}
	unless(defined(&_SYS_QUEUE_H_)) {
	    require 'sys/queue.ph';
	}
	unless(defined(&_SYS_TREE_H_)) {
	    require 'sys/tree.ph';
	}
	unless(defined(&_SYS_SPINLOCK_H_)) {
	    require 'sys/spinlock.ph';
	}
	unless(defined(&_SYS_THREAD_H_)) {
	    require 'sys/thread.ph';
	}
	require 'machine/frame.ph';
	require 'machine/vframe.ph';
	require 'machine/limits.ph';
	eval 'sub VKE_REF_DELETED () {0x80000000;}' unless defined(&VKE_REF_DELETED);
	if(defined(&_KERNEL)) {
	}
    } else {
	unless(defined(&_MACHINE_PARAM_H_)) {
	    require 'machine/param.ph';
	}
    }
    if((defined(&LONG_BIT) ? &LONG_BIT : undef) == 32) {
	eval 'sub VPTE_FRAME_END () {32;}' unless defined(&VPTE_FRAME_END);
	eval 'sub VPTE_PAGE_BITS () {10;}' unless defined(&VPTE_PAGE_BITS);
	eval 'sub VPTE_FRAME () {0xfffff000;}' unless defined(&VPTE_FRAME);
    }
 elsif((defined(&LONG_BIT) ? &LONG_BIT : undef) == 64) {
	eval 'sub VPTE_FRAME_END () {48;}' unless defined(&VPTE_FRAME_END);
	eval 'sub VPTE_PAGE_BITS () {9;}' unless defined(&VPTE_PAGE_BITS);
	eval 'sub VPTE_FRAME () {0xffffffffff000;}' unless defined(&VPTE_FRAME);
    } else {
	die("LONG_BIT not defined");
    }
    eval 'sub VPTE_PAGE_ENTRIES () {( &PAGE_SIZE / $sizeof{ &vpte_t});}' unless defined(&VPTE_PAGE_ENTRIES);
    eval 'sub VPTE_PAGE_MASK () {((1<<  &VPTE_PAGE_BITS) - 1);}' unless defined(&VPTE_PAGE_MASK);
    eval 'sub VPTE_PAGETABLE_SIZE () { &PAGE_SIZE;}' unless defined(&VPTE_PAGETABLE_SIZE);
    eval 'sub VPTE_V () {0x1;}' unless defined(&VPTE_V);
    eval 'sub VPTE_RW () {0x2;}' unless defined(&VPTE_RW);
    eval 'sub VPTE_U () {0x4;}' unless defined(&VPTE_U);
    eval 'sub VPTE_A () {0x20;}' unless defined(&VPTE_A);
    eval 'sub VPTE_M () {0x40;}' unless defined(&VPTE_M);
    eval 'sub VPTE_PS () {0x80;}' unless defined(&VPTE_PS);
    eval 'sub VPTE_G () {0x100;}' unless defined(&VPTE_G);
    eval 'sub VPTE_WIRED () {0x200;}' unless defined(&VPTE_WIRED);
    eval 'sub VPTE_MANAGED () {0x400;}' unless defined(&VPTE_MANAGED);
    eval 'sub VPTE_NX () {0x800;}' unless defined(&VPTE_NX);
}
1;
